Package: hypeR
Title: An R Package For Geneset Enrichment Workflows
Version: 2.10.0
Authors@R: c(person(given="Anthony", family="Federico", email="anfed@bu.edu", 
             role=c("aut")),
             person(given="Andrew", family="Chen", email="andrewdr@bu.edu", 
             role=c("aut", "cre")),
             person(given="Stefano", family="Monti", email="smonti@bu.edu", 
             role=c("aut")))
Description: An R Package for Geneset Enrichment Workflows.
Depends: R (>= 3.6.0)
License: GPL-3 + file LICENSE
URL: https://github.com/montilab/hypeR
Encoding: UTF-8
RoxygenNote: 7.3.1
Imports: ggplot2, ggforce, R6, magrittr, dplyr, purrr, stats, stringr,
        scales, rlang, httr, openxlsx, htmltools, reshape2, reactable,
        msigdbr, kableExtra, rmarkdown, igraph, visNetwork, shiny,
        BiocStyle
Suggests: tidyverse, devtools, testthat, knitr
biocViews: GeneSetEnrichment, Annotation, Pathways
VignetteBuilder: knitr
BugReports: https://github.com/montilab/hypeR/issues
git_url: https://git.bioconductor.org/packages/hypeR
git_branch: RELEASE_3_23
git_last_commit: 6ec1e80
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-29
NeedsCompilation: no
Packaged: 2026-04-29 22:24:10 UTC; biocbuild
Author: Anthony Federico [aut],
  Andrew Chen [aut, cre],
  Stefano Monti [aut]
Maintainer: Andrew Chen <andrewdr@bu.edu>

#' @title A hyp object
#' 
#' @examples
#' data <- data.frame(replicate(5,sample(0:1,10,rep=TRUE)))
#' args <- list("arg_1"=1, "arg_2"=2, "arg_3"=3)
#' hyp_obj <- hyp$new(data, args=args)
#' 
#' @section See Also:
#' 
#' \code{multihyp}
#'
#' @importFrom R6 R6Class
#' 
#' @export
hyp <- R6Class("hyp", list(
    #' @field data A dataframe returned by hypeR()
    #' @field plots A list of plots returned by hypeR()
    #' @field args A list of arguments passed to hypeR()
    #' @field info Exported information for reproducibility
    data  = NULL,
    plots = NULL,
    args  = NULL,
    info  = NULL,

    #' @description
    #' Create a hyp object
    #' @param data A dataframe returned by hypeR()
    #' @param plots A list of plots returned by hypeR()
    #' @param args A list of arguments passed to hypeR()
    #' @param info Exported information for reproducibility
    #' @return A new hyp object  
    initialize = function(data, plots=NULL, args=NULL, info=NULL) {
        self$data  <- data
        self$plots <- plots
        self$args  <- args
        self$info  <- info
    },
    #' @description
    #' Print hyp obect
    #' @return NULL
    print = function() {
        cat("(hyp) \n\n")
        cat("  data: \n")
        base::print(head(self$data), row.names=FALSE)
        cat(.format_str("\n  plots: {1} Figures\n\n", length(self$plots)))
        cat(.format_str("  args: {1}", paste(names(self$args), collapse="\n        ")))
        invisible(self)
    },
    #' @description
    #' Extract dataframe from hyp obect
    #' @return NULL
    as.data.frame = function() {
        self$data
    }
))

test_that("hyp object is working", {
    data <- data.frame(replicate(5,sample(0:1,10,rep=TRUE)))
    args <- list("arg_1"=1, "arg_2"=2, "arg_3"=3)
    hyp_obj <- hyp$new(data, args=args)
    expect_is(hyp_obj, "hyp")
    expect_is(hyp_obj, "R6")
    expect_output(print(hyp_obj))
    expect_is(hyp_obj$as.data.frame(), "data.frame")
    expect_equal(names(hyp_obj$args), c("arg_1", "arg_2", "arg_3"))
    expect_equal(dim(hyp_obj$data), c(10, 5))
})

#' Get url base for species-specific enrichr libraries
#'
#' @param db A species
#' @return A url
#' 
#' @keywords internal
enrichr_urls <- function(db=c("Enrichr", "YeastEnrichr", "FlyEnrichr", "WormEnrichr", "FishEnrichr")) {
    switch(match.arg(db),
        "Enrichr"      = "http://maayanlab.cloud/Enrichr/{1}",
        "YeastEnrichr" = "http://maayanlab.cloud/YeastEnrichr/{1}",
        "FlyEnrichr"   = "http://maayanlab.cloud/FlyEnrichr/{1}",
        "WormEnrichr"  = "http://maayanlab.cloud/WormEnrichr/{1}",
        "FishEnrichr"  = "http://maayanlab.cloud/FishEnrichr/{1}"
    )
}

#' Connect to the enrichr web application
#'
#' @param endpoint The url endpoint to connect to
#' @param db A species
#' @return A web response
#'
#' @importFrom httr GET http_status
#' 
#' @keywords internal
enrichr_connect <- function(endpoint, db=c("Enrichr", "YeastEnrichr", "FlyEnrichr", "WormEnrichr", "FishEnrichr")) {
    url <- enrichr_urls(db)
    response <- httr::GET(.format_str(url, endpoint))   
    if (!http_status(response)$category == "Success") {
        stop(http_status(response)$message)
    }
    return(response)
}

#' Get enrichr available genesets
#'
#' @param db A species
#' @return A dataframe of available genesets
#'
#' @examples
#' enrichr_available()
#' 
#' @importFrom httr content
#' @importFrom magrittr %>% set_colnames
#' @importFrom dplyr select
#' 
#' @export
enrichr_available <- function(db=c("Enrichr", "YeastEnrichr", "FlyEnrichr", "WormEnrichr", "FishEnrichr")) {
    response <- enrichr_connect("datasetStatistics", db)
    data <- content(response, "parsed")  
    data$statistics %>%
    lapply(function(x) do.call(cbind.data.frame, x)) %>%
    do.call(rbind.data.frame, .) %>%
    dplyr::select("libraryName", "numTerms", "geneCoverage", "genesPerTerm", "link") %>%
    magrittr::set_colnames(c("Geneset", "Set Number", "Coverage", "Genes Per Set", "Source"))
}

#' Download data from enrichr in the form of a named list
#'
#' @param genesets A name corresponding to available genesets
#' @param db A species
#' @return A list of genesets
#'
#' @examples
#' ATLAS <- enrichr_download("Human_Gene_Atlas")
#' 
#' @importFrom httr content
#' 
#' @export
enrichr_download <- function(genesets, db=c("Enrichr", "YeastEnrichr", "FlyEnrichr", "WormEnrichr", "FishEnrichr")) {
    response <- enrichr_connect(.format_str("geneSetLibrary?mode=text&libraryName={1}", genesets), db)
    data <- content(response, "text")
    split <- strsplit(data, split="\n")[[1]]
    genesets <- sapply(split, function(x) strsplit(x, "\t")[[1]])
    names(genesets) <- unlist(lapply(genesets, function(x) x[1]))
    lapply(genesets, function(x) {
        genes <- x[3:length(x)]
        genes <- genes[genes != ""]
        unique(genes)
    })
}

#' Download data from enrichr in the form of a gsets object
#'
#' @param genesets A name corresponding to available genesets
#' @param db A species
#' @param clean Use true to clean labels of genesets
#' @return A gsets object
#'
#' @examples
#' ATLAS <- enrichr_gsets("Human_Gene_Atlas")
#' 
#' @importFrom httr content
#' 
#' @export
enrichr_gsets <- function(genesets, db=c("Enrichr", "YeastEnrichr", "FlyEnrichr", "WormEnrichr", "FishEnrichr"), clean=FALSE) {
    name <- .format_str("{1} ({2})", genesets, match.arg(db))
    genesets <- enrichr_download(genesets, db)
    version <- .format_str("Downloaded: {1}", Sys.Date())
    gsets$new(genesets, name=name, version=version, clean=clean)
}

#' A push/pop capable vector
#'
#' @importFrom R6 R6Class
#' 
#' @keywords internal
pvector <- R6Class("pvector", list(
    #' @field values A vector of values
    values = NULL,

    #' @description
    #' Create a pvector
    #' @param values A vector of values
    #' @return A new pvector  
    initialize = function(values=c()) {
        self$values <- values
    },
    #' @description
    #' Print pvector
    #' @return NULL  
    print = function() {
        base::print(self$values)
        invisible(self)
    },
    #' @description
    #' Get length of pvector
    #' @return An integer  
    length = function() {
        base::length(self$values)
    },
    #' @description
    #' Pop vector
    #' @return Popped value 
    pop = function() {
        if (length(self$values) > 0) {
            popped.value <- self$values[1]
            self$values <- self$values[-1]
            return(popped.value)   
        }
    },
    #' @description
    #' Push values
    #' @param pushed.values A vector of values
    #' @return NULL
    push = function(pushed.values) {
        self$values <- c(self$values, pushed.values)
    }
))

hyp_hmap_tests <- function(hyp_obj, return_obj=FALSE) {
    expect_silent(hyp_hmap(hyp_obj, top=5))
    expect_silent(hyp_hmap(hyp_obj, val="pval", top=10))
    expect_silent(hyp_hmap(hyp_obj, val="fdr", top=10))
    p <- hyp_hmap(hyp_obj,  top=10)
    expect_is(p, "visNetwork")
    expect_is(p, "htmlwidget")
    p <- hyp_hmap(hyp_obj,  top=0)
    expect_true(is.null(p))
    if (return_obj) return(hyp_obj)
}

test_that("hyp_hmap() is working", {
    
    testdat <- readRDS(file.path(system.file("extdata", package="hypeR"), "testdat.rds"))
    rgsets_obj <- testdat$rgsets
    
    # Overrepresentation (signature)
    signature <- testdat$signature
    experiment <- testdat$experiment
    
    hypeR(signature, rgsets_obj, test="hypergeometric", background=100) %>%
    hyp_hmap_tests()
    p <- hypeR(experiment, rgsets_obj, test="hypergeometric", background=100) %>%
         hyp_hmap()
    expect_equal(length(p), 3)
    expect_equal(names(p), c("Signature 1", "Signature 2", "Signature 3"))
    expect_is(p[["Signature 3"]], "visNetwork")
    
    # Enrichment (ranked signature)
    signature <- names(testdat$weighted_signature)
    experiment <- lapply(testdat$weighted_experiment, names)

    hypeR(signature, rgsets_obj, test="kstest") %>%
    hyp_hmap_tests()
    p <- hypeR(experiment, rgsets_obj, test="kstest") %>%
         hyp_hmap()
    expect_equal(length(p), 3)
    expect_equal(names(p), c("Signature 1", "Signature 2", "Signature 3"))
    expect_is(p[["Signature 3"]], "visNetwork")
        
    # Enrichment (weighted signature)
    signature <- testdat$weighted_signature
    experiment <- testdat$weighted_experiment
    
    hypeR(signature, rgsets_obj, test="kstest") %>%
    hyp_hmap_tests()
    p <- hypeR(experiment, rgsets_obj, test="kstest") %>%
         hyp_hmap()
    expect_equal(length(p), 3)
    expect_equal(names(p), c("Signature 1", "Signature 2", "Signature 3"))
    expect_is(p[["Signature 3"]], "visNetwork")
})

hyp_tests <- function(hyp_obj, test_plots=FALSE, return_obj=FALSE) {
    expect_is(hyp_obj, "hyp")
    expect_is(hyp_obj, "R6")  
    expect_is(hyp_obj$data, "data.frame")
    expect_is(hyp_obj$args, "list")
    expect_output(print(hyp_obj))
    if (test_plots) {
        expect_is(hyp_obj$plots, "list")
        expect_is(hyp_obj$plots[[1]], "gg")
        expect_equal(names(hyp_obj$plots), hyp_obj$data$label)
    }
    if (return_obj) return(hyp_obj)
}

hypeR_tests <- function(test, signature, experiment, genesets, gsets_obj, rgsets_obj) {

    # Basic
    hypeR(signature, genesets, test=test, background=2520) %>%
    hyp_tests()    
            
    # Basic
    hypeR(signature, gsets_obj, test=test, background=2520) %>%
    hyp_tests()
    
    # Basic with plots
    hypeR(signature, gsets_obj, test=test, background=2520, plotting=TRUE) %>%
    hyp_tests(test_plots=TRUE)
    
    # Test pval_cutoff
    hypeR(signature, gsets_obj, test=test, background=100, pval=0.0001) %>%
    hyp_tests()
    
    # Test fdr_cutoff
    hyp_obj <- hypeR(signature, gsets_obj, test=test, background=100, fdr=0.0001) %>%
               hyp_tests(return_obj=TRUE)
    
    expect_equal(hyp_obj$args$genesets, gsets_obj)
    expect_equal(hyp_obj$args$pval, 1)
    expect_equal(hyp_obj$args$fdr, 0.0001)
    
    # Test relational gsets
    hyp_obj <- hypeR(signature, rgsets_obj, test=test, background=80, pval=0.01) %>%
               hyp_tests(return_obj=TRUE)
    expect_is(hyp_obj$args$genesets, "rgsets")
    expect_is(hyp_obj$args$genesets, "R6")
    
    # Multiple signatures
    multihyp_obj <- hypeR(experiment, gsets_obj, test=test, background=100, fdr=0.01)
    expect_is(multihyp_obj, "multihyp")
    expect_is(multihyp_obj, "R6")
    expect_equal(names(multihyp_obj$data), c("Signature 1", "Signature 2", "Signature 3"))
    
    # Extracting hyp objects
    multihyp_obj$data[["Signature 1"]] %>%
    hyp_tests()
    
    # Extracting hyp objects with plots
    multihyp_obj <- hypeR(experiment, gsets_obj, test=test, background=100, plotting=TRUE)
    multihyp_obj$data[["Signature 1"]] %>%
    hyp_tests(test_plots=TRUE)
    
    # Test relational gsets
    multihyp_obj <- hypeR(experiment, rgsets_obj, test=test, background=100, pval=0.05)
    multihyp_obj$data[["Signature 2"]] %>%
    hyp_tests()
}

test_that("Hypergeometric is working", {
    fisher <- function(s, g, bg) {
        mat <- matrix(0, nrow=2, ncol=2)
        mat[1,1] <- length(intersect(s, g))
        mat[1,2] <- length(setdiff(s, g))
        mat[2,1] <- length(setdiff(g, s))
        mat[2,2] <- bg-sum(mat[1,1], mat[1,2], mat[2,1])
        pval <- fisher.test(mat, alternative="greater")$p.value
        signif(pval, 2)
    }
    
    # The alphabet
    bg <- LETTERS
    
    # A signature
    s <- c("N", "Y", "D", "G", "A", "B", "K", "Z")
    
    # Genesets
    gs <- list(G1 = c("N", "Y", "D", "G", "A", "B", "K", "Z", "M", "Q", "U"),
               G2 = c("F", "A", "S", "X", "H", "Z", "L", "U", "V", "G", "K", "Y", "D", "M", "R"),
               G3 = c("W", "M", "O", "P", "Q", "R"))
    
    # Hypergeometric
    hyp_obj <- hypeR(s, gs, background=length(bg))
    expect_equal(filter(hyp_obj$data, label == "G1") %>% pull(pval), fisher(s, gs$G1, length(bg)))
    expect_equal(filter(hyp_obj$data, label == "G2") %>% pull(pval), fisher(s, gs$G2, length(bg)))
    expect_equal(filter(hyp_obj$data, label == "G3") %>% pull(pval), fisher(s, gs$G3, length(bg)))
    
    # Hypergeometric - Restrict Genesets to Background
    hyp_obj <- hypeR(s, gs, background=bg[1:18])
    expect_equal(filter(hyp_obj$data, label == "G1") %>% pull(pval), fisher(s, intersect(gs$G1, bg[1:18]), length(bg[1:18])))
    expect_equal(filter(hyp_obj$data, label == "G2") %>% pull(pval), fisher(s, intersect(gs$G2, bg[1:18]), length(bg[1:18])))
    expect_equal(filter(hyp_obj$data, label == "G3") %>% pull(pval), fisher(s, intersect(gs$G3, bg[1:18]), length(bg[1:18])))
    
    gsets_obj <- gsets$new(gs, quiet=TRUE)   
    hyp_obj <- hypeR(s, gsets_obj, background=bg[1:18])
    expect_equal(filter(hyp_obj$data, label == "G1") %>% pull(pval), fisher(s, intersect(gs$G1, bg[1:18]), length(bg[1:18])))
    expect_equal(filter(hyp_obj$data, label == "G2") %>% pull(pval), fisher(s, intersect(gs$G2, bg[1:18]), length(bg[1:18])))
    expect_equal(filter(hyp_obj$data, label == "G3") %>% pull(pval), fisher(s, intersect(gs$G3, bg[1:18]), length(bg[1:18])))
})

test_that("KS Test is working", {

  genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")$genesets[1:5]
  all_genes <- genesets %>% unlist(use.names = FALSE)
  genesets_names <- names(genesets)

  # Geneset 1 is top skewed
  experiment <- c(head(genesets[[1]], 5), LETTERS, tail(genesets[[1]], 1))
  hyp_obj <- hypeR(experiment, genesets, background=2522, test="kstest")
  #expect_equal(hyp_obj$data[genesets_names[[1]], "hits"] %>% unlist(use.names=FALSE), paste0("'", genesets[[1]][1:5], "'",collapse=","))
  expect_equal(filter(hyp_obj$data, label == genesets_names[[1]]) %>% dplyr::pull(hits) %>% unname(), 
               paste(genesets[[1]][1:5], collapse = " , "))
  
  # Geneset 2 is mixed
  experiment <- c(head(genesets[[2]], 8), LETTERS, tail(genesets[[2]], 10))
  hyp_obj <- hypeR(experiment, genesets, background=2522, test="kstest")
  #expect_equal(hyp_obj$data[genesets_names[[2]], "hits"] %>% unlist(use.names=FALSE), paste0("'", genesets[[2]][1:8], "'",collapse=","))
  expect_equal(filter(hyp_obj$data, label == genesets_names[[2]]) %>% dplyr::pull(hits) %>% unname(), 
               paste(genesets[[2]][1:8], collapse = " , "))
  
  # Geneset 3 is bottom skewed
  experiment <- c(head(genesets[[3]], 1), LETTERS, tail(genesets[[3]], 8))
  hyp_obj <- hypeR(experiment, genesets, background=2522, test="kstest")
  #expect_equal(hyp_obj$data[genesets_names[[3]], "hits"] %>% unlist(use.names=FALSE), paste0("'", genesets[[3]][1], "'",collapse=","))
  expect_equal(filter(hyp_obj$data, label == genesets_names[[3]]) %>% dplyr::pull(hits) %>% unname(), 
               paste(genesets[[3]][1], collapse = " , "))
})

test_that("hypeR() is working", {
    # Testing data
    testdat <- readRDS(file.path(system.file("extdata", package="hypeR"), "testdat.rds"))
    genesets <- testdat$gsets$genesets
    gsets_obj <- testdat$gsets
    rgsets_obj <- testdat$rgsets
    
    # Overrepresentation (signature)
    signature <- testdat$signature
    experiment <- testdat$experiment
    hypeR_tests(test="hypergeometric", signature, experiment, genesets, gsets_obj, rgsets_obj)
    
    # Enrichment (ranked signature)
    signature <- names(testdat$weighted_signature)
    experiment <- lapply(testdat$weighted_experiment, names)
    hypeR_tests(test="kstest", signature, experiment, genesets, gsets_obj, rgsets_obj)
    
    # Enrichment (weighted signature)
    signature <- testdat$weighted_signature
    experiment <- testdat$weighted_experiment
    hypeR_tests(test="kstest", signature, experiment, genesets, gsets_obj, rgsets_obj)
})

test_that("pvector object is working", {
    pv <- pvector$new(c(1,2,3,4,5))
    expect_is(pv, "pvector")
    expect_is(pv, "R6")
    popped <- pv$pop()
    expect_equal(popped, 1)
    expect_output(print(pv))
    expect_equal(pv$values, c(2,3,4,5))
    expect_equal(pv$length(), 4)
    pv$push(6)
    pv$push(c(7,8))
    expect_output(print(pv))
    expect_equal(pv$values, c(2,3,4,5,6,7,8))
    pv <- pvector$new(c(1,2))
    popped <- pv$pop()
    popped <- pv$pop()
    expect_equal(pv$length(), 0)
    popped <- pv$pop()
    expect_null(popped)
    expect_equal(pv$length(), 0)
})

hyp_dots_tests <- function(hyp_obj, return_obj=FALSE) {
    expect_silent(hyp_dots(hyp_obj))
    expect_silent(hyp_dots(hyp_obj, val="pval"))
    expect_silent(hyp_dots(hyp_obj, val="fdr"))
    expect_silent(hyp_dots(hyp_obj, abrv=20))
    expect_silent(hyp_dots(hyp_obj, title="title"))
    expect_silent(hyp_dots(hyp_obj, size_by="genesets"))
    expect_silent(hyp_dots(hyp_obj, size_by="significance"))
    expect_silent(hyp_dots(hyp_obj, size_by="none"))
    p <- hyp_dots(hyp_obj)
    expect_is(p, "gg")
    if (return_obj) return(hyp_obj)
}

test_that("hyp_dots() is working", {

    testdat <- readRDS(file.path(system.file("extdata", package="hypeR"), "testdat.rds"))
    gsets_obj <- testdat$gsets
    rgsets_obj <- testdat$rgsets

    # Overrepresentation (signature)
    signature <- testdat$signature
    experiment <- testdat$experiment

    hypeR(signature, gsets_obj, test="hypergeometric", background=100) %>%
    hyp_dots_tests()
    hypeR(signature, rgsets_obj, test="hypergeometric", background=100) %>%
    hyp_dots_tests()
    p <- hypeR(experiment, gsets_obj, test="hypergeometric", background=100) %>%
         hyp_dots()
    expect_equal(length(p), 3)
    expect_equal(names(p), c("Signature 1", "Signature 2", "Signature 3"))
    expect_is(p[["Signature 3"]], "gg")

    # Enrichment (ranked signature)
    signature <- names(testdat$weighted_signature)
    experiment <- lapply(testdat$weighted_experiment, names)

    hypeR(signature, gsets_obj, test="kstest") %>%
    hyp_dots_tests()
    hypeR(signature, rgsets_obj, test="kstest") %>%
    hyp_dots_tests()
    p <- hypeR(experiment, gsets_obj, test="kstest") %>%
         hyp_dots()
    expect_equal(length(p), 3)
    expect_equal(names(p), c("Signature 1", "Signature 2", "Signature 3"))
    expect_is(p[["Signature 3"]], "gg")

    # Enrichment (weighted signature)
    signature <- testdat$weighted_signature
    experiment <- testdat$weighted_experiment

    hypeR(signature, gsets_obj, test="kstest") %>%
    hyp_dots_tests()
    hypeR(signature, rgsets_obj, test="kstest") %>%
    hyp_dots_tests()
    p <- hypeR(experiment, gsets_obj, test="kstest") %>%
         hyp_dots()
    expect_equal(length(p), 3)
    expect_equal(names(p), c("Signature 1", "Signature 2", "Signature 3"))
    expect_is(p[["Signature 3"]], "gg")
})

#' Enrichment plot implemented in ggplot
#'
#' @param n The length of a ranked list
#' @param positions A vector of positions in the ranked list
#' @param x_axis The x-axis of a running enrichment score
#' @param y_axis The y-axis of a running enrichment score
#' @param title Plot title
#' @return A ggplot object
#' 
#' @importFrom ggplot2 qplot aes geom_rug geom_hline geom_vline annotate theme element_text element_blank element_line element_rect
#' 
#' @export
ggeplot <- function(n, positions, x_axis, y_axis, title = "") {
  score <- which.max(abs(y_axis))
  DF <- data.frame(x_axis = x_axis, y_axis = y_axis)
  ggplot2::ggplot(DF, aes(x = x_axis, y = y_axis)) +
    ggplot2::geom_line() +
    ggplot2::labs(
      title = title,
      y = "Running Enrichment Score",
      x = "Position in Ranked List of Genes"
    ) +
    ggplot2::geom_rug(data = data.frame(positions), aes(x = positions), inherit.aes = FALSE) +
    ggplot2::geom_hline(yintercept = 0) +
    ggplot2::geom_vline(xintercept = n / 2, linetype = "dotted") +
    ggplot2::annotate("point", x = x_axis[score], y = y_axis[score], color = "red") +
    ggplot2::annotate("text", x = x_axis[score] + n / 20, y = y_axis[score], label = round(y_axis[score], 2)) +
    ggplot2::annotate("point", x = x_axis[score], y = y_axis[score], color = "red") +
    ggplot2::theme(
      plot.title = ggplot2::element_text(hjust = 0.5),
      panel.background = ggplot2::element_blank(),
      axis.line = ggplot2::element_line(color = "black"),
      panel.border = ggplot2::element_rect(color = "black", fill = NA, linewidth = 1)
    )
}

#' Plot enrichment map
#'
#' @param hyp_df A dataframe from a hyp object
#' @param genesets A list of genesets
#' @param similarity_metric Metric to calculate geneset similarity
#' @param similarity_cutoff Geneset similarity cutoff
#' @param pval_cutoff Filter results to be less than pval cutoff
#' @param fdr_cutoff Filter results to be less than fdr cutoff
#' @param val Choose significance value shown above nodes e.g. c("fdr", "pval")
#' @param top Limit number of pathways shown
#' @param title Plot title
#' @return A visNetwork object
#'
#' @importFrom purrr when
#' @importFrom dplyr filter
#' @importFrom igraph graph.adjacency V
#' @importFrom visNetwork visNetwork visNodes visEdges visOptions visInteraction toVisNetworkData visIgraphLayout
#' 
#' @keywords internal
.enrichment_map <- function(hyp_df,
                            genesets, 
                            similarity_metric=c("jaccard_similarity", "overlap_similarity"),
                            similarity_cutoff=0.2,
                            pval_cutoff=1, 
                            fdr_cutoff=1,
                            val=c("fdr", "pval"),
                            top=NULL,
                            title="") {

    # Subset results
    hyp_df <- hyp_df %>%
              dplyr::filter(pval <= pval_cutoff) %>%
              dplyr::filter(fdr <= fdr_cutoff) %>%
              purrr::when(!is.null(top) ~ head(., top), ~ .)

    # Handle empty dataframes
    if (nrow(hyp_df) == 0) return(NULL)
    
    # Geneset similarity matrix
    hyp.genesets <- genesets[hyp_df$label]
    hyp.genesets.mat <- sapply(hyp.genesets, function(x) {
        sapply(hyp.genesets, function(y,x) {
            if (similarity_metric == "jaccard_similarity") .jaccard_similarity(x, y)
            else if (similarity_metric == "overlap_similarity") .overlap_similarity(x, y)     
            else stop(.format_str("{1} is an invalid metric", similarity_metric))
        }, x)
    })
    
    m <- as.matrix(hyp.genesets.mat)

    # Sparsity settings
    m[m < similarity_cutoff] <- 0
    
    # Similarity matrix to weighted network
    inet <- igraph::graph.adjacency(m, mode="undirected", weighted=TRUE, diag=FALSE)
    
    # igraph to visnet
    vnet <- toVisNetworkData(inet)

    nodes <- vnet$nodes
    edges <- vnet$edges
    
    # Add edge weights
    edges$value <- vnet$edges$weight

    # Add node scaled sizes based on genset size
    size.scaler <- function(x) (x-min(x))/(max(x)-min(x))*30 
    node.sizes <- sapply(igraph::V(inet), function(x) hyp_df[x, "geneset"])
    nodes$size <-  size.scaler(node.sizes)+20
    
    val.pretty <- ifelse(val == "fdr", "FDR", "P-Value")
    nodes$title <- sapply(igraph::V(inet), function(x) {
                            paste(val.pretty, hyp_df[x, val], sep=": ")
                   })
    
    # Add node scaled weights based on significance
    weight.scaler <- function(x) (x-max(x))/(min(x)-max(x))
    node.weights <- sapply(igraph::V(inet), function(x) hyp_df[x, val])
    nodes$color.border <- "rgb(0,0,0)"
    nodes$color.highlight <- "rgba(199,0,57,0.9)"
    nodes$color.background <- sapply(weight.scaler(node.weights), function(x) { 
                                  if (is.na(x)) {
                                      return("rgba(199,0,57,0)")
                                  } else{
                                      return(paste("rgba(199,0,57,", round(x, 3), ")", sep=""))   
                                  }
                          })

    visNetwork(nodes, edges, main=list(text=title, style="font-family:Helvetica")) %>%
    visNodes(borderWidth=1, borderWidthSelected=0) %>%
    visEdges(color="rgb(88,24,69)") %>%
    visOptions(highlightNearest=TRUE) %>%
    visInteraction(multiselect=TRUE, tooltipDelay=300) %>%
    visIgraphLayout(layout="layout_nicely")
}

#' Visualize hyp/multihyp objects as an enrichment map
#'
#' @param hyp_obj A hyp or multihyp object
#' @param similarity_metric Metric to calculate geneset similarity
#' @param similarity_cutoff Geneset similarity cutoff
#' @param pval Filter results to be less than pval cutoff
#' @param fdr Filter results to be less than fdr cutoff
#' @param val Choose significance value shown above nodes e.g. c("fdr", "pval")
#' @param top Limit number of pathways shown
#' @param title Plot title
#' @return A visNetwork object
#'
#' @examples
#' genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")
#'
#' signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
#'                "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
#'                "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")
#'
#' hyp_obj <- hypeR(signature, genesets, background=2522)
#'
#' hyp_emap(hyp_obj, top=30, val="fdr")
#'
#' @export
hyp_emap <- function(hyp_obj, 
                     similarity_metric=c("jaccard_similarity", "overlap_similarity"),
                     similarity_cutoff=0.2,
                     pval=1, 
                     fdr=1,
                     val=c("fdr", "pval"),
                     top=NULL,
                     title="") {

    stopifnot(is(hyp_obj, "hyp") | is(hyp_obj, "multihyp"))

    # Default arguments
    similarity_metric <- match.arg(similarity_metric)
    val <- match.arg(val)

    # Handling of multiple signatures
    if (is(hyp_obj, "multihyp")) {
        multihyp_obj <- hyp_obj

        mapply(function(hyp_obj, title) {

            hyp_emap(hyp_obj,
                     similarity_metric=similarity_metric, 
                     similarity_cutoff=similarity_cutoff,
                     pval=pval,
                     fdr=fdr,
                     val=val,
                     top=top,
                     title=title) 

        }, multihyp_obj$data, names(multihyp_obj$data), USE.NAMES=TRUE, SIMPLIFY=FALSE)
    } 
    else {
        hyp_df <- hyp_obj$data
        genesets <- hyp_obj$args$genesets$genesets
        .enrichment_map(hyp_df, genesets, similarity_metric, similarity_cutoff, pval, fdr, val, top, title)
    }
}

#' Calculate enrichment of one or more signatures
#' 
#' @param signature A vector of symbols
#' @param genesets A gsets/rgsets object or a named list of genesets
#' @param test Choose an enrichment type e.g. c("hypergeometric", "kstest")
#' @param background Size or character vector of background population genes
#' @param power Exponent for weights (kstest only)
#' @param absolute Takes max-min score rather than the max deviation from null (kstest only)
#' @param pval Filter results to be less than pval cutoff
#' @param fdr Filter results to be less than fdr cutoff
#' @param plotting Use true to generate plots for each geneset test (may slow performance)
#' @param quiet Use true to suppress logs and warnings
#' @return A hyp object
#'
#' @examples
#' genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")
#'
#' signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
#'                "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
#'                "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")
#'
#' hyp_obj <- hypeR(signature, genesets, background=2522)
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr filter arrange
#' 
#' @export
hypeR <- function(signature,
                  genesets,
                  test=c("hypergeometric", "kstest"),
                  background=23467,
                  power=1,
                  absolute=FALSE,
                  pval=1,
                  fdr=1,
                  plotting=FALSE,
                  quiet=TRUE) {

    # Handling of multiple signatures
    if (is(signature, "list")) {
        
        if (is.null(names(signature))) {
            stop("Lists of signatures must be named")
        }

        lhyp <- mapply(function(x, id) {
            if (!quiet) {
                cat(.format_str("\n{1}\n", id)) 
            }

            hypeR(x,
                  genesets=genesets, 
                  test=test, 
                  background=background, 
                  power=power, 
                  absolute=absolute,
                  pval=pval,
                  fdr=fdr,
                  plotting=plotting, 
                  quiet=quiet)

        }, signature, names(signature), USE.NAMES=TRUE, SIMPLIFY=FALSE)

        # Wrap list of hyp objects in multihyp object
        return(multihyp$new(data=lhyp))
    }

    # Save original arguments
    args <- as.list(environment())

    # Default arguments
    test <- match.arg(test)
    args$test <- test

    # Handle gsets
    if (is(genesets, "list")) {
        gsets.obj <- gsets$new(genesets, quiet=quiet)
    }
    else if (is(genesets, "gsets") | is(genesets, "rgsets")) {
        gsets.obj <- genesets
    } 
    else {
        stop("Genesets must be gsets/rgsets object or named list of genesets")
    }

    # Handling a background population
    if (is(background, "character") & is(background, "vector")) {
        gsets.obj <- gsets.obj$reduce(background)
        background <- length(background)
    }

    # Save gsets object
    args$genesets <- gsets.obj

    # In case results are empty
    plots <- ggempty()

    # Overrepresentation test
    if (test == "hypergeometric") {
        signature.type <- "symbols"
        data <- data.frame(matrix(ncol=8, nrow=0))
        colnames(data) <- c("label", "pval", "fdr", "signature", "geneset", "overlap", "background", "hits")
        results <- .hyper_enrichment(signature=signature, 
                                     genesets=gsets.obj$genesets, 
                                     background=background, 
                                     plotting=plotting)
    }
    
    # Enrichment test
    if (test == "kstest") {
        if (is(signature, "numeric")) {
            if (is.null(names(signature))) stop("Weighted signatures must be named")
            weights <- signature
            signature <- names(weights)
            signature.type <- "weighted"
        } else {
          weights <- NULL
          signature.type <- "ranked"
        }
        data <- data.frame(matrix(ncol=8, nrow=0))
        colnames(data) <- c("label", "score", "pval", "fdr", "geneset", "signature", "overlap", "hits")
        results <- .ks_enrichment(signature=signature, 
                                  genesets=gsets.obj$genesets,
                                  weights=weights, 
                                  weights.pwr=power, 
                                  absolute=absolute, 
                                  plotting=plotting)
    }

    # Ensure signature is present across genesets
    overlap <- .check_overlap(signature, gsets.obj$genesets)

    if (!quiet) {
        cat(.format_str("Signature size: {1}\n", length(signature)))
        cat(.format_str("Number of genesets: {1}\n", length(gsets.obj$genesets)))
        cat(.format_str("Percentage of signature found across genesets: {1}% \n", overlap))
        cat(.format_str("Background population size: {1} \n", background))
        cat(.format_str("P-Value cutoff: {1} \n", pval))
        cat(.format_str("FDR cutoff: {1}\n", fdr))
    }

    # Filter data
    if (!is.null(results$data)) {
        
        data <- results$data %>%
                dplyr::filter(pval <= args$pval) %>%
                dplyr::filter(fdr <= args$fdr) %>%
                dplyr::arrange(pval)

        plots <- results$plots[data$label]
    }
    
    # Reproducibility information
    info <- list()
    info$hypeR <- paste("v", packageVersion("hypeR"), sep="")
    info$signature.head <- paste(head(signature), collapse=",")
    info$signature.size <- length(signature)
    info$signature.type <- signature.type
    info$genesets <- gsets.obj$info()
    info$background <- ifelse(is.numeric(args$background), args$background, length(args$background))

    # Static args
    info <- c(info, args[c("pval", "fdr", "test", "power", "absolute")])
    info <- lapply(info, as.character)

    # Make pretty
    names(info) <- c("hypeR",
                     "Signature Head",
                     "Signature Size",
                     "Signature Type",
                     "Genesets", 
                     "Background",
                     "P-Value",
                     "FDR",
                     "Test",
                     "Power",
                     "Absolute")

    # Wrap dataframe in hyp object
    return(hyp$new(data=data, plots=plots, args=args, info=info))
}

test_that("hyp_show() is working", {

    testdat <- readRDS(file.path(system.file("extdata", package="hypeR"), "testdat.rds"))
    gsets_obj <- testdat$gsets
    rgsets_obj <- testdat$rgsets
    signature <- testdat$signature
    experiment <- testdat$experiment
    
    hyp_obj <- hypeR(signature, gsets_obj)
    multihyp_obj <- hypeR(experiment, gsets_obj)

    expect_silent(hyp_show(hyp_obj))
    expect_silent(hyp_show(hyp_obj, simple=TRUE))
    expect_error(hyp_show(multihyp_obj))
})

test_that("hyp_to_excel() is working", {
    
    testdat <- readRDS(file.path(system.file("extdata", package="hypeR"), "testdat.rds"))
    gsets_obj <- testdat$gsets
    rgsets_obj <- testdat$rgsets
    
    signature <- testdat$signature
    experiment <- testdat$experiment
    
    hyp_obj <- hypeR(signature, gsets_obj)
    multihyp_obj <- hypeR(experiment, rgsets_obj)
    
    # A single excel file with one tab
    hyp_to_excel(hyp_obj, file_path="hyp.xlsx")
    expect_true(file.exists("hyp.xlsx"))
    
    # A single excel file with multiple tabs
    hyp_to_excel(multihyp_obj, file_path="multihyp.xlsx")
    expect_true(file.exists("multihyp.xlsx"))
})

hyp_to_rmd_tests <- function(hyp_obj, file_path, ...) {
    hyp_to_rmd(hyp_obj, file_path, ...)
    expect_true(file.exists(file_path))
    expect_true(file.exists(gsub("rmd", "html", file_path)))
}

test_that("hyp_to_rmd() is working", {
    
    testdat <- readRDS(file.path(system.file("extdata", package="hypeR"), "testdat.rds"))
    gsets_obj <- testdat$gsets
    rgsets_obj <- testdat$rgsets
    
    # Overrepresentation (signature)
    signature <- testdat$signature
    experiment <- testdat$experiment
    project <- testdat$project      
    
    hypeR(signature, gsets_obj, background=100) %>%
    hyp_to_rmd_tests("hyp.1.rmd")
    
    multihyp_obj <- hypeR(experiment, gsets_obj, background=100) %>%
    hyp_to_rmd_tests("multihyp.1.rmd")   
    
    lapply(project, function(x) {hypeR(x, gsets_obj, background=100)}) %>%
    hyp_to_rmd_tests("lmultihyp.1.rmd")   

    hypeR(signature, rgsets_obj, background=100) %>%
    hyp_to_rmd_tests("hyp.2.rmd", show_hmaps=TRUE)  
    
    multihyp_obj <- hypeR(experiment, rgsets_obj, background=100) %>%
    hyp_to_rmd_tests("multihyp.2.rmd", show_hmaps=TRUE)
    
    lapply(project, function(x) {hypeR(x, rgsets_obj, background=100)}) %>%
    hyp_to_rmd_tests("lmultihyp.2.rmd", show_hmaps=TRUE) 
    
    lapply(project, function(x) {hypeR(x, rgsets_obj, background=100)}) %>%
    hyp_to_rmd_tests("lmultihyp.3.rmd", 
                     show_hmaps=TRUE,
                     hyp_dots_args=list(top=5, val="pval"), 
                     hyp_emap_args=list(top=5, val="pval"),
                     hyp_hmap_args=list(top=5, val="pval"))     
    
    # Enrichment (ranked signature)
    signature <- names(testdat$weighted_signature)
    experiment <- lapply(testdat$weighted_experiment, names)

    hypeR(signature, gsets_obj, test="kstest") %>%
    hyp_to_rmd_tests("hyp.4.rmd")
    
    multihyp_obj <- hypeR(experiment, gsets_obj, test="kstest") %>%
    hyp_to_rmd_tests("multihyp.4.rmd")   

    # Combinations
    hyp_obj <- hypeR(signature, rgsets_obj, background=100)
    multihyp_obj <- hypeR(experiment, rgsets_obj, background=100)

    hyp_to_rmd_tests(list("hyp"=hyp_obj, "multihyp"=multihyp_obj), "combo.1.rmd")
    
    hyp_to_rmd_tests(list("hyp"=hyp_obj, "multihyp"=multihyp_obj), "combo.2.rmd",
                                                                   show_dots=FALSE,
                                                                   show_hmaps=TRUE,
                                                                   show_tables=FALSE,
                                                                   hyp_emap_args=list(similarity_metric="jaccard_similarity"),
                                                                   hyp_hmap_args=list(val="fdr"))

     hyp_to_rmd_tests(list("hyp"=hyp_obj, "multihyp"=multihyp_obj), "combo.3.rmd",
                                                                    show_dots=FALSE,
                                                                    show_emaps=FALSE,
                                                                    show_hmaps=TRUE,
                                                                    show_tables=FALSE,
                                                                    session_info=TRUE,
                                                                    hyp_hmap_args=list(top=10, val="pval"))
})

test_that("hyp_to_table() is working", {
  testdat <- readRDS(file.path(system.file("extdata", package = "hypeR"), "testdat.rds"))
  gsets_obj <- testdat$gsets
  rgsets_obj <- testdat$rgsets

  signature <- testdat$signature
  experiment <- testdat$experiment

  hyp_obj <- hypeR(signature, gsets_obj)
  multihyp_obj <- hypeR(experiment, rgsets_obj)

  # A single file
  hyp_to_table(hyp_obj, file_path = "signature.txt", sep = "\t")
  expect_true(file.exists("signature.txt"))

  # Multiple files within a directory
  hyp_to_table(multihyp_obj, file_path = "experiment", sep = "\t")
  expect_true(file.exists("experiment/Signature 1.txt"))
  expect_true(file.exists("experiment/Signature 2.txt"))
  expect_true(file.exists("experiment/Signature 3.txt"))
})

#' Get base url for hyperdb
#' 
#' @return A base url
#'
#' @keywords internal
.hyperdb_url <- function(api=FALSE) {
    if (api) {
        return("https://api.github.com/repos/montilab/hyperdb")
    } else {
        return("https://github.com/montilab/hyperdb")   
    }
}

#' Load an rds file directly from github
#' 
#' @param url A url
#' @return A list
#'
#' @importFrom httr GET
#'
#' @keywords internal
.github_rds <- function(url) {
    temp <- tempfile(fileext=".rds")
    httr::GET(url, .send_headers=c("Accept"="application/octet-stream"), httr::write_disk(temp, overwrite=TRUE))    
    return(readRDS(temp))
}

#' Check available data to download from hyperdb
#' 
#' @examples
#' hyperdb_available()
#'
#' @importFrom httr GET stop_for_status
#' @importFrom reshape2 melt
#' @importFrom magrittr set_colnames
#' @importFrom dplyr relocate
#'
#' @export
hyperdb_available <- function() {
    base <- .hyperdb_url(api=TRUE)
    url <- .format_str("{1}/git/trees/master?recursive=1", base)
    response <- httr::GET(url)
    httr::stop_for_status(response)
    repo <- unlist(lapply(content(response)$tree, "[", "path"), use.names=F)
    fl <- repo[grepl("^data/.", repo)]
    ll <- list()
    for (f in fl) {
        name <- NULL
        split <- strsplit(f , "/")[[1]]
        if (length(split) > 2){
            name <- split[2]
            rds <- split[3]
            if (!name %in% names(ll)) {
                ll[[name]] <- c(rds)
            } else {
                ll[[name]] <- c(ll[[name]], rds)
            }
        }
    }
    ll %>%
    reshape2::melt() %>%
    magrittr::set_colnames(c("gsets", "source")) %>%
    dplyr::relocate(source, gsets)
}

#' Download data from hyperdb
#'
#' @param source A source identifier
#' @param gsets A genesets identifier
#' @return A list
#'
#' @examples
#' KEGG <- hyperdb_gsets("KEGG", "KEGG_v92.0.rds")
#' 
#' @export
hyperdb_gsets <- function(source, gsets) {
    base <- .hyperdb_url()
    url <- .format_str("{1}/raw/master/data/{2}/{3}", base, source, gsets)
    .github_rds(url)
}

#' Download data from hyperdb in the form of a rgsets object
#'
#' @param rgsets A name corresponding to an available relational genesets object
#' @param version A version number
#' @return An rgsets object
#'
#' @examples
#' REACTOME <- hyperdb_rgsets("REACTOME", "70.0")
#'
#' @export
hyperdb_rgsets <- function(rgsets, version) {
    base <- .hyperdb_url()
    url <- .format_str("{1}/raw/master/data/{2}/{2}_v{3}.rds", base, rgsets, version)
    .github_rds(url)
}

#' Overrepresentation test via hyper-geometric distribution
#'
#' @param signature A vector of symbols
#' @param genesets A list of genesets
#' @param background Size of background population genes
#' @param plotting Use true to generate plots
#' @return A list of data and plots
#'
#' @importFrom stats phyper p.adjust
#' 
#' @keywords internal
.hyper_enrichment <- function(signature,
                              genesets,
                              background=length(unique(unlist(genesets))),
                              plotting=TRUE) {

    if (!is(signature, "vector")) stop("Expected signature to be a vector of symbols\n")
    if (!is(genesets, "list")) stop("Expected genesets to be a list of genesets\n")
    
    signature <- unique(signature)
    genesets <- lapply(genesets, unique)
    
    # Construct table
    signature.found <- signature[signature %in% unique(unlist(genesets))]
    n.hits <- sapply(genesets, function(x, y) length(intersect(x, y)), signature.found)
    n.drawn <- length(signature)
    n.genesets <- sapply(genesets, length)
    n.left <- background-n.genesets
    
    # Hypergeometric test
    pvals <- suppressWarnings(stats::phyper(q=n.hits-1,
                                            m=n.genesets,
                                            n=n.left,
                                            k=n.drawn,
                                            lower.tail=FALSE))
    
    # Format data
    data <- data.frame(label=names(genesets),
                       pval=signif(pvals, 2),
                       fdr=signif(stats::p.adjust(pvals, method="fdr"), 2),
                       signature=length(signature),
                       geneset=n.genesets,
                       overlap=n.hits,
                       background=background,
                       #hits=sapply(genesets, function(x, y) paste(intersect(x, y), collapse=','), signature.found),
                       hits=sapply(genesets, function(x, y) paste(intersect(x, y), collapse=' , '), signature.found),
                       stringsAsFactors=FALSE)
    
    # Handle plots
    if (plotting) {
        plots <- mapply(function(geneset, title) {
            ggvenn(signature, geneset, "Signature", "Geneset", title)
        }, genesets, names(genesets), USE.NAMES=TRUE, SIMPLIFY=FALSE)
    } else {
        plots <- lapply(genesets, function(x) {ggempty()})
    }
    
    return(list(data=data, plots=plots))
}

#' Shiny interface module for geneset selection
#' 
#' @param id A unique namespace identifier
#' @return Shiny ui elements
#'
#' @importFrom shiny NS tagList uiOutput selectizeInput actionButton
#' 
#' @export
genesets_UI <- function(id) {
    genesets <- readRDS(file.path(system.file("extdata", package="hypeR"), "genesets.rds"))
    
    ns <- NS(id)
    tagList(
        selectizeInput(ns("db"), label="Database", choices=names(genesets)),
        uiOutput(ns("species")),
        uiOutput(ns("genesets")),
        actionButton(ns("fetch"), label="Fetch Genesets"),
        uiOutput(ns("status"), inline=TRUE)
    )
}

#' Shiny server module for geneset selection
#' 
#' @param id A unique namespace identifier matching to interface
#' @param clean Use true to clean geneset names
#' @return Shiny server code
#'
#' @importFrom shiny moduleServer renderUI validate need icon selectizeInput eventReactive
#' 
#' @export
genesets_Server <- function(id, clean=FALSE) {
    genesets <- readRDS(file.path(system.file("extdata", package="hypeR"), "genesets.rds"))
    
    moduleServer(
        id,
        function(input, output, session) {
            
            # Build species selection
            output$species <- renderUI({
                ns <- session$ns
                validate(need(input$db, message=FALSE))
                choices <- names(genesets[[input$db]])
                selectizeInput(ns("species"), label="Species", choices=choices)
            })
            
            # Build genesets selection
            output$genesets <- renderUI({
                ns <- session$ns
                validate(need(input$db, message=FALSE))
                validate(need(input$species, message=FALSE))
                choices <- names(genesets[[input$db]][[input$species]])
                selectizeInput(ns("genesets"), label="Genesets", choices=choices)
            })
            
            # Download selected geneset and put into a reactive expression
            reactive.genesets <- eventReactive(input$fetch, {
                validate(need(input$db, message=FALSE))
                validate(need(input$species, message=FALSE))
                validate(need(input$genesets, message=FALSE))
                if (input$db == "msigdb") {
                    kwargs <- genesets[[input$db]][[input$species]][[input$genesets]]
                    gs <- do.call(msigdb_download, kwargs)
                }   
                else if (input$db == "enrichr") {
                    kwargs <- genesets[[input$db]][[input$species]][[input$genesets]]
                    gs <- do.call(enrichr_download, kwargs)
                }
                else {
                    gs <- NULL
                }
                if (!is.null(gs) & clean) {
                    names(gs) <- clean_genesets(names(gs))
                }
                return(gs)
            })
            
            # Check status of loaded genesets
            output$status <- renderUI({
                if (is.null(reactive.genesets())) {
                    icon("times-circle fa-lg", lib="font-awesome")
                } else {
                    ic <- icon("check-circle fa-lg", lib="font-awesome")
                }
            })
            
            return(reactive.genesets)
        }
    )
}

#' Clean labels of genesets
#' 
#' @param x A vector of labels
#' 
#' @examples
#' HALLMARK <- msigdb_download("Homo sapiens", "H")
#' names(HALLMARK) <- clean_genesets(names(HALLMARK))
#' head(names(HALLMARK))
#' 
#' @importFrom stringr str_to_sentence
#' 
#' @export
clean_genesets <- function(x) {
    # Longest leading common substring
    x.split <- strsplit(x, '')
    x.split <- lapply(x.split, `length<-`, max(nchar(x)))
    x.mat <- do.call(rbind, x.split)
    csl <- which.max(apply(x.mat, 2, function(col) !length(unique(col)) == 1)) - 1
    lcls <- substr(x[1], 1, csl)
    
    # Clean
    x <- gsub(lcls, "", x)
    x <- gsub("_", " ", x)
    x <- stringr::str_to_title(x)
    return(x)
}

#' Check overlap of signature across genesets
#' 
#' @param signature A vector of symbols
#' @param genesets A list of genesets
#' @param threshold Minimum percent overlap
#' @return Percent overlap
#'
#' @keywords internal
.check_overlap <- function(signature, genesets, threshold=0.05) {
    overlap <- signif(length(intersect(signature, unique(unlist(genesets)))) / length(signature), 2)
    if (overlap < threshold) {
        warning(.format_str("Only {1}% of signature was found across genesets", overlap*100))
    }
    return(overlap)
}

#' Format a string using placeholders
#'
#' @param string A an unformatted string with placeholders
#' @param ... Variables to format placeholders with
#' @return A formatted string
#' 
#' @examples
#' \dontrun{
#' format_str("Format with {1} and {2}", "x", "y")
#' }
#'
#' @keywords internal
.format_str <- function(string, ...) {
    args <- list(...)
    for (i in 1:length(args)) {
        pattern <- paste("\\{", i, "}", sep="")
        replacement <- args[[i]]
        string <- gsub(pattern, replacement, string)
    }
    return(string)
}

#' Convert an arguments list to string format
#'
#' @param args A list of keyword arguments
#' @return A string of keyword arguments
#'
#' @examples
#' \dontrun{
#' string_args(list(x=15, y="fdr", z=TRUE))
#' }
#'
#' @keywords internal
.string_args <- function(args) {
    paste(paste(names(args), 
                sapply(unname(args), function(x) {
                    if (is.character(x)) {shQuote(x)}
                    else if (is.null(x)) {"NULL"}
                    else {x}
                }), 
                sep='='), 
                collapse=",")
}

#' Calculate jaccard similarity of two sets
#'
#' @param a A vector
#' @param b A vector
#' @return A numerical value
#'
#' @keywords internal
.jaccard_similarity <- function(a, b) {
    length( intersect(a, b) ) / length( union(a, b) )
}

#' Calculate overlap similarity of two sets
#'
#' @param a A vector
#' @param b A vector
#' @return A numerical value
#'
#' @keywords internal
.overlap_similarity <- function(a, b) {
    length( intersect(a, b) ) / min( length(a), length(b) )
}

#' Custom reverse log transformation of continous ggplot axes
#'
#' @param base Logarithm base
#' @importFrom scales trans_new log_breaks
#' 
#' @keywords internal
.reverselog_trans <- function(base=exp(1)) {
    trans <- function(x) -log(x, base)
    inv <- function(x) base^(-x)
    scales::trans_new(paste0("reverselog-", format(base)), trans, inv, 
              scales::log_breaks(base=base), 
              domain=c(1e-100, Inf))
}

#' Find geneset members
#'
#' @param id A vector of ids
#' @param genesets A list of genesets (see \code{rgsets})
#' @param nodes A data frame of labeled nodes (see \code{rgsets})
#' @param edges A data frame of directed edges (see \code{rgsets})
#' @return A vector of ids
#'
#' @importFrom dplyr filter pull %>%
#' 
#' @keywords internal
.find_members <- function(id, genesets, nodes, edges) {
    label <- nodes[id, "label"]
    if (label %in% names(genesets)) {
        genesets[[label]]
    } else {
        edges %>%
        dplyr::filter(from == id) %>%
        dplyr::pull(to) %>%
        lapply(.find_members, genesets, nodes, edges) %>%
        unlist() %>%
        unique()
    }
}

#' Adjust alpha of a hex string
#'
#' @param hex A 6-character hex string (e.g. #000000)
#' @param percent Alpha level from 0-1
#' @return A hex string
#' 
#' @keywords internal
.hexa <- function(hex, percent=1) {
    if (percent < 0) percent <- 0
    if (percent > 1) percent <- 1
    percent <- toupper(as.hexmode(floor(percent * 255)))
    percent <- sprintf("%02s", percent)
    hex <- paste0(hex, percent)
    return(hex)
}

rmd_config <- "---
title: '{1}'
subtitle: '{2}'
author: '{3}'
output:
  html_document:
    theme: united
    toc: true
    toc_float: true
    code_folding: hide
    toc_depth: 1
    df_print: paged
---

**Generated with hypeR**: v`r packageVersion('hypeR')`  
**Date Generated**: `r Sys.Date()`

***
"

rmd_knitr <- "
```{r setup, echo=FALSE, message=FALSE}
knitr::opts_chunk$set(echo=TRUE, warning=FALSE, message=FALSE)
library(kableExtra)
```
"

rmd_tabset <- "
# {1}
##  {.tabset .tabset-fade}
"

rmd_tab <- "
### {1} 
```{r {2}, fig.width=8.25, fig.align='center'}
hyp_obj <- tabsets[['{3}']][['{1}']] 
{4}
{5}
{6}
{7}
{8}
```
"

tab_dots <- "
hyp_obj %>%
hyp_dots({1})
"

tab_emap <- "
hyp_obj %>%
hyp_emap({1})
"

tab_hmap <- "
hyp_obj %>%
hyp_hmap({1})
"

tab_table <- "
df <- hyp_obj$as.data.frame()
df$label.abrv <- substr(df$label, 1, 30) 
col_ix <- match(c('pval', 'fdr', 'label.abrv'), colnames(df))
df <- df[, c(col_ix, (1:ncol(df))[-col_ix])]
df$label <- NULL
rownames(df) <- NULL
df
"

rmd_versioning <- "
info <- hyp_obj$info
mat <- matrix(c(names(hyp_obj$info), as.character(hyp_obj$info)), ncol=2)
df <- as.data.frame(mat)
colnames(df) <- NULL
df
"

rmd_session <- "
# Session Info
```{r}
sessionInfo()
```
"

#' Export hyp object to rmarkdown
#'
#' @param hyp_obj A hyp object, multihyp object, or list of multihyp objects
#' @param file_path A file path
#' @param title Title of markdown report
#' @param subtitle Subtitle of markdown report
#' @param author Authors of markdown report
#' @param header Header name of tabset section
#' @param versioning Add versioning information
#' @param show_dots Option to show dots plots in tabs
#' @param show_emaps Option to show enrichment maps in tabs
#' @param show_hmaps Option to show hiearchy maps in tabs
#' @param show_tables Option to show table in tabs
#' @param hyp_dots_args A list of keyword arguments passed to hyp_dots
#' @param hyp_emap_args A list of keyword arguments passed to hyp_emap
#' @param hyp_hmap_args A list of keyword arguments passed to hyp_hmap
#' @param custom_rmd_config Replace configuration section of markdown report
#' @param custom_pre_content Insert custom content before tabset section
#' @param custom_post_content Insert custom content after tabset section
#' @param session_info Use true to include session info
#' @return NULL
#'
#' @import kableExtra
#' @importFrom rmarkdown render
#' @importFrom magrittr %>%
#' 
#' @export
hyp_to_rmd <- function(hyp_obj,
                       file_path,
                       title="Workflow Report",
                       subtitle="",
                       author="",
                       header="Results",
                       versioning=TRUE,
                       show_dots=TRUE,
                       show_emaps=TRUE,
                       show_hmaps=FALSE,
                       show_tables=TRUE,
                       hyp_dots_args=list(top=15, 
                                          val="fdr"),
                       hyp_emap_args=list(top=25, 
                                          val="fdr", 
                                          similarity_metric="jaccard_similarity", 
                                          similarity_cutoff=0.2),
                       hyp_hmap_args=list(top=25,
                                          val="fdr"),    
                       custom_rmd_config=NULL,
                       custom_pre_content=NULL,
                       custom_post_content=NULL,
                       session_info=FALSE) {
    
    # Markdown configuration
    if (!is.null(custom_rmd_config)) {
        rmd_config <- custom_rmd_config
    } else {
        rmd_config <- .format_str(rmd_config, title, subtitle, author)
    }

    write(rmd_config, file=file_path, append=FALSE)
    write(rmd_knitr, file=file_path, append=TRUE)

    # Content before hyper enrichment tabs
    if (!is.null(custom_pre_content)) {
        write(custom_pre_content, file=file_path, append=TRUE)
    }

    # Iterate over the following object structure
    #
    # Generate a tab...
    # for each multihyp
    #    for each hyp
    #
    # Example:
    # list(tabset1 = list(tab1 = hyp,
    #                     tab2 = hyp),
    #      tabset2 = list(tab1 = hyp,
    #                     tab2 = hyp))

    # A single set of tabs
    # ----------------------
    if (is(hyp_obj, "hyp")) {
        tabsets <- list(x = list(" " = hyp_obj))
        names(tabsets) <- c(header)
    }
    if (is(hyp_obj, "multihyp")) {
        tabsets <- list(x = hyp_obj$data)
        names(tabsets) <- c(header)
    }
    if (is(hyp_obj, "list")) {
        tabsets <- lapply(hyp_obj, function(x) {
            stopifnot(is(x, "hyp")| is(x, "multihyp"))
            if (is(x, "hyp")) {
                return(list(" " = x))
            }
            if (is(x, "multihyp")) {
                return(x$data)
            }
        })
    }
    # ----------------------
    
    # Limit is 10,000 tabs
    ids <- pvector$new(seq(10000))

    for (tabset in names(tabsets)) {

        # Tabset header and init code
        rmd_tabset %>%
        .format_str(tabset) %>%
        write(file=file_path, append=TRUE)

        # Tab content
        tabs <- tabsets[[tabset]]
        for (tab in names(tabs)) {

            tab_id <- ids$pop()
        
            dots_area <- ifelse(show_dots,  .format_str(tab_dots, .string_args(hyp_dots_args)), "")
            data_area <- ifelse(show_tables, tab_table, "")
            emap_area <- ifelse(show_emaps, .format_str(tab_emap, .string_args(hyp_emap_args)), "")
            hmap_area <- ifelse(show_hmaps, .format_str(tab_hmap, .string_args(hyp_hmap_args)), "")
            vers_area <- ifelse(versioning, rmd_versioning, "")

            rmd_tab %>%
            .format_str(tab, tab_id, tabset, dots_area, data_area, emap_area, hmap_area, vers_area) %>%
            write(file=file_path, append=TRUE)
        }
    }

    # Session info
    if (session_info) write(rmd_session, file=file_path, append=TRUE)
    
    # Trailing content
    if (!is.null(custom_post_content)) write(custom_post_content, file=file_path, append=TRUE)

    rmarkdown::render(input=file_path, 
                      output_format="html_document",
                      output_file=gsub("rmd", "html", basename(file_path)))
}

#' @title A multihyp object
#'
#' @examples
#' data <- data.frame(replicate(5,sample(0:1,10,rep=TRUE)))
#' args <- list("arg_1"=1, "arg_2"=2, "arg_3"=3)
#' hyp_obj <- hyp$new(data, args=args)
#' data <- list("hyp_1"=hyp_obj, "hyp_2"=hyp_obj,"hyp_3"=hyp_obj)
#' multihyp_obj <- multihyp$new(data)
#'
#' @section See Also:
#' 
#' \code{hyp}
#' 
#' @importFrom R6 R6Class
#' 
#' @export
multihyp <- R6Class("multihyp", list(
    #' @field data A list of hyp objects
    data = NULL,

    #' @description
    #' Create a multihyp object
    #' @param data A list of hyp objects
    #' @return A new multihyp object  
    initialize = function(data) {
        self$data <- data
    },
    #' @description
    #' Print multihyp obect
    #' @return NULL
    print = function() {
        cat("(multihyp) \n")
        for (i in names(self$data)) {
            dims <- dim(self$data[[i]]$data)
            cat(.format_str("  (hyp) {1}\n", i))
            cat(.format_str("        {1} x {2}\n", dims[1], dims[2]))
        }
        invisible(self)
    },
    #' @description
    #' Print multihyp obect
    #' @return A list of hyp objects as dataframes
    as.list = function() {
        lapply(self$data, function(x) x$as.data.frame())
    }
))

test_that("multihyp object is working", {
    data <- data.frame(replicate(5,sample(0:1,10,rep=TRUE)))
    args <- list("arg_1"=1, "arg_2"=2, "arg_3"=3)
    hyp_obj <- hyp$new(data, args=args)
    data <- list("hyp_1"=hyp_obj, "hyp_2"=hyp_obj,"hyp_3"=hyp_obj)
    multihyp_obj <- multihyp$new(data)
    expect_is(multihyp_obj, "multihyp")
    expect_is(multihyp_obj, "R6")
    expect_equal(names(multihyp_obj$data), c("hyp_1", "hyp_2", "hyp_3"))
    expect_is(multihyp_obj$as.list(), "list")
    expect_equal(names(multihyp_obj$as.list()), c("hyp_1", "hyp_2", "hyp_3"))
    expect_equal(dim(multihyp_obj$as.list()[[1]]), c(10, 5))
})

#' Export hyp/multihyp object to table
#'
#' @param hyp_obj A hyp or multihyp object
#' @param file_path A file path for hyp objects and directory for multihyp objects
#' @param sep The field separator string
#' @param cols Dataframe columns to include
#' @param versioning Add header with versioning information
#' @return NULL
#'
#' @examples
#' genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")
#'
#' signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
#'                "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
#'                "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")
#'
#' hyp_obj <- hypeR(signature, genesets, background=2522)
#'
#' hyp_to_table(hyp_obj, file_path="pathways.txt")
#'
#' @importFrom magrittr %>% extract
#' 
#' @export
hyp_to_table <- function(hyp_obj, file_path, sep="\t", cols=NULL, versioning=TRUE) {

    stopifnot(is(hyp_obj, "hyp") | is(hyp_obj, "multihyp"))

    # A multihyp object results in multiple tables within a director named file_path
    if (is(hyp_obj, "multihyp")) {
        multihyp_obj <- hyp_obj

        # Create directory if not exists
        dir.create(file_path, showWarnings=TRUE)

        # A new file for each dataframe
        for (i in names(multihyp_obj$data)) {
            
            fname <- i
            fx = "rtf"
            if (sep == "\t") {fx <- "txt"}
            if (sep ==  ",") {fx <- "csv"}
            fp <- paste(file.path(file_path, fname), fx, sep=".")

            # Extract hyp object
            hyp_obj <- multihyp_obj$data[[i]]

            # Recursive call for each hyp object
            hyp_to_table(hyp_obj, fp, sep, cols)
        }

    # A hyp object results in a single table named file_path
    } else  {
        # Extract hyp dataframe
        df <- hyp_obj$data
        if (is.null(cols)) {
            cols <- seq_len(ncol(df))
        }

        if (versioning) {

            header <- matrix(c(names(hyp_obj$info), as.character(hyp_obj$info)), ncol=2)
            header[,1] <- paste("#", header[,1], sep="")
            
            write.table(x=header, 
                        file=file_path, 
                        quote=FALSE,
                        sep=sep,
                        col.names=FALSE, 
                        row.names=FALSE,
                        append=FALSE)

            append <- TRUE
        } else {
            append <- FALSE
        }

        suppressWarnings(write.table(x=df[,cols,drop=FALSE],
                                     file=file_path,
                                     quote=FALSE,
                                     sep=sep,
                                     col.names=TRUE,
                                     row.names=FALSE,
                                     append=append))
    }
}

#' Export hyp/multihyp object to excel
#'
#' @param hyp_obj A hyp or multihyp object
#' @param file_path A file path
#' @param cols Dataframe columns to include
#' @param versioning Add sheet with versioning information
#' @return NULL
#'
#' @examples
#' genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")
#'
#' signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
#'                "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
#'                "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")
#'
#' hyp_obj <- hypeR(signature, genesets, background=2522)
#'
#' hyp_to_excel(hyp_obj, file_path="pathways.xlsx")
#'
#' @importFrom openxlsx createWorkbook addWorksheet writeData saveWorkbook
#' 
#' @export
hyp_to_excel <- function(hyp_obj, file_path, cols=NULL, versioning=TRUE) {
    
    stopifnot(is(hyp_obj, "hyp") | is(hyp_obj, "multihyp"))

    # Handle hyp objects
    if (is(hyp_obj, "hyp")) {
        multihyp_obj <- multihyp$new(data=list(" "=hyp_obj))
    } else {
        multihyp_obj <- hyp_obj
    }
    
    # Generate excel file
    wb <- openxlsx::createWorkbook()

    # A new sheet for each dataframe
    for (i in names(multihyp_obj$data)) {
        sheet <- openxlsx::addWorksheet(wb, sheetName=i)

        # Extract hyp dataframe
        hyp_obj <- multihyp_obj$data[[i]]
        df <- hyp_obj$data

        if (is.null(cols)) {
            cols <- seq_len(ncol(df))
        }
        x <- df[,cols,drop=FALSE]

        openxlsx::writeData(wb, sheet=i, x=x, colNames=TRUE, rowNames=FALSE)
    }

    if (versioning) {
        x <- mapply(function(x) x$info, multihyp_obj$data)
        sheet <- openxlsx::addWorksheet(wb, sheetName="versioning")
        openxlsx::writeData(wb, sheet="versioning", x=x, colNames=ncol(x) > 1, rowNames=TRUE)    
    }

    suppressMessages(openxlsx::saveWorkbook(wb, file=file_path, overwrite=TRUE))
}

#' One-sided Kolmogorov–Smirnov test
#'
#' @param n.x The length of a ranked list
#' @param y A vector of positions in the ranked list
#' @param weights Weights for weighted score (Subramanian et al.)
#' @param weights.pwr Exponent for weights (Subramanian et al.)
#' @param absolute Takes max-min score rather than the max deviation from null
#' @param plotting Use true to generate plot
#' @param plot.title Plot title
#' @return A list of data and plots
#'
#' @importFrom stats ks.test
#' 
#' @keywords internal
.kstest <- function(n.x,
                    y, 
                    weights=NULL,
                    weights.pwr=1,
                    absolute=FALSE, # this is not really implemented, should be removed
                    plotting=FALSE, 
                    plot.title="") 
{
  n.y <- length(y)
  err <- list(score = 0, pval = 1, leading_edge = NULL, leading_hits = NULL, plot = ggempty())
  if (n.y < 1 || any(y > n.x) || any(y < 1) ) {
    return(err)
  }
  x.axis <- y.axis <- NULL
  leading_edge <- NULL # recording the x corresponding to the highest y value
  
  ## If weights are provided
  if ( !is.null(weights) ) {
    weights <- abs(weights[y])^weights.pwr
    
    Pmis <- rep(1, n.x); Pmis[y] <- 0; Pmis <- cumsum(Pmis); Pmis <- Pmis/(n.x-n.y)
    Phit <- rep(0, n.x); Phit[y] <- weights; Phit <- cumsum(Phit); Phit <- Phit/Phit[n.x]
    z <- Phit-Pmis
    
    score <- if (absolute) max(z)-min(z) else z[leading_edge <- which.max(abs(z))]
    
    x.axis <- 1:n.x
    y.axis <- z
  } 
  ## Without weights
  else {
    y <- sort(y)
    n <- n.x*n.y/(n.x + n.y)
    hit <- 1/n.y
    mis <- 1/n.x
    
    Y <- sort(c(y-1, y))    # append the positions preceding hits
    Y <- Y[diff(Y) != 0]    # remove repeated position
    y.match <- match(y, Y)  # find the hits' positions
    D <- rep(0, length(Y))
    D[y.match] <- (1:n.y)
    zero <- which(D == 0)[-1]
    D[zero] <- D[zero-1]
    
    z <- D*hit-Y*mis
    
    score <- if (absolute) max(z)-min(z) else z[leading_edge <- which.max(abs(z))]
    
    x.axis <- Y
    y.axis <- z
    
    if (Y[1] > 0) {
      x.axis <- c(0, x.axis)
      y.axis <- c(0, y.axis)
    }
    if (max(Y) < n.x) {
      x.axis <- c(x.axis, n.x)
      y.axis <- c(y.axis, 0)
    }    
  }
  leading_edge <- x.axis[leading_edge]
  leading_hits <- intersect(x.axis[x.axis <= leading_edge], y)
  
  ## One-sided Kolmogorov–Smirnov test
  results <- suppressWarnings(ks.test(1:n.x, y, alternative="less"))
  results$statistic <- score  # Use the signed statistic
  
  ## Enrichment plot
  p <- if (plotting && n.y > 0) {
    ggeplot(n.x, y, x.axis, y.axis, plot.title) +
      geom_vline(xintercept = leading_edge, linetype = "dotted", color = "red", linewidth = 0.25)
  } else {
    ggempty()
  }
  return(list(
    score = as.numeric(results$statistic),
    pval = results$p.value,
    leading_edge = leading_edge,
    leading_hits = leading_hits,
    plot = p
  ))
}
#' Enrichment test via one-sided Kolmogorov–Smirnov test
#' 
#' @param signature A vector of ranked symbols
#' @param genesets A list of genesets
#' @param weights Weights for weighted score (Subramanian et al.)
#' @param weights.pwr Exponent for weights (Subramanian et al.)
#' @param absolute Takes max-min score rather than the max deviation from null
#' @param plotting Use true to generate plot
#' @return A list of data and plots
#' 
#' @keywords internal
.ks_enrichment <- function(
    signature,
    genesets,
    weights = NULL,
    weights.pwr = 1,
    absolute = FALSE,
    plotting = TRUE) 
{
  if (!is(genesets, "list")) stop("Error: Expected genesets to be a list of gene sets\n")
  if (!is.null(weights)) stopifnot(length(signature) == length(weights))

  signature <- unique(signature)
  genesets <- lapply(genesets, unique)

  results <- mapply( function(geneset, title) {
    ranks <- match(geneset, signature)
    ranks <- ranks[!is.na(ranks)]

    ## Run ks-test
    results_in <- .kstest(
      n.x = length(signature),
      y = ranks,
      weights = weights,
      weights.pwr = weights.pwr,
      absolute = absolute,
      plotting = plotting,
      plot.title = title
    )
    #results_in[["geneset"]] <- length(geneset)
    results_in[["geneset"]] <- length(intersect(geneset, signature))
    results_in[["overlap"]] <- length(results_in$leading_hits)
    return(results_in)
  }, genesets, names(genesets), USE.NAMES = TRUE, SIMPLIFY = FALSE)

  results <- do.call(rbind, results)
  data <- data.frame(apply(results[, c("score", "pval", "geneset", "overlap")], 2, unlist),
    stringsAsFactors = FALSE
  )
  ## add list of genes in the leading edge
  data <- data %>%
    #dplyr::mutate(hits = sapply(results[, "leading_hits"], function(x) paste(signature[x], collapse = ",")))
    dplyr::mutate(hits = sapply(results[, "leading_hits"], function(x) paste(signature[x], collapse = " , ")))
  data$score <- signif(data$score, 2)
  data$pval <- signif(data$pval, 2)
  data$label <- names(genesets)
  data$signature <- length(signature)
  data$fdr <- signif(p.adjust(data$pval, method = "fdr"), 2)
  data <- data %>%
    dplyr::relocate(fdr, .after = pval) %>%
    dplyr::relocate(signature, .after = geneset) %>%
    dplyr::relocate(label) %>%
    tibble::remove_rownames() # make sure this is OK
  plots <- results[, "plot"]

  return(list(
    data = data,
    plots = plots,
    leading_hits = sapply(results[, "leading_hits"], function(x) signature[x])
  ))
}

#' Get msigdbr package version number
#'
#' @return Version number
#'
#' @examples
#' msigdb_version()
#'
#' @export
msigdb_version <- function() {
    paste("v", as.character(packageVersion("msigdbr")), sep="")
}

#' Get msigdbr available species
#'
#' @return A character vector of species
#'
#' @examples
#' msigdb_species()
#'
#' @importFrom msigdbr msigdbr_species
#' @export
msigdb_species <- function() {
    msigdbr::msigdbr_species()$species_name
}

#' Check if species is available
#'
#' @param species A species
#' @return NULL
#'
#' @examples
#' \dontrun{
#' msigdb_check_species("Homo sapiens")
#' }
#' 
#' @keywords internal
msigdb_check_species <- function(species="") {
    if (!species %in% msigdb_species()) {
        stop("Species must be one of the following: \n", paste(msigdb_species(), "\n"))
    }
}

#' Get msigdbr available genesets
#'
#' @param species A species to determine gene symbols (refer to ?msigdbr::msigdbr for available species)
#' @return A dataframe of available genesets
#'
#' @examples
#' msigdb_available("Homo sapiens")
#'
#' @importFrom magrittr %>% set_colnames
#' @importFrom dplyr select
#' @importFrom msigdbr msigdbr
#' 
#' @export
msigdb_available <- function(species="Homo sapiens") {
    
    # Check species
    msigdb_check_species(species)
    
    # Gene set categories
    msigdbr(species=species) %>%
    dplyr::select(gs_collection, gs_subcollection) %>%
    unique() %>%
    dplyr::arrange(gs_collection, gs_subcollection) %>%
    magrittr::set_colnames(c("Collection", "Subcollection"))
}

#' Print msigdb gsets information
#'
#' @return NULL
#'
#' @examples
#' msigdb_info()
#'
#' @export
msigdb_info <- function() {
    cat("|------------------------------------------------------------------|\n")
    cat("| Via: R package msigdbr                                    ")
    cat(msigdb_version())
    cat(" |\n")
    cat("|------------------------------------------------------------------|\n")
    cat("| Available Species                                                |\n")
    cat("|------------------------------------------------------------------|\n")
    cat("| Homo sapiens                                                     |\n")
    cat("| Mus musculus                                                     |\n")
    cat("| Drosophila melanogaster                                          |\n")
    cat("| Gallus gallus                                                    |\n")
    cat("| Saccharomyces cerevisiae                                         |\n")
    cat("| Bos taurus                                                       |\n")
    cat("| Caenorhabditis elegans                                           |\n")
    cat("| Canis lupus familiaris                                           |\n")
    cat("| Danio rerio                                                      |\n")
    cat("| Rattus norvegicus                                                |\n")
    cat("| Sus scrofa                                                       |\n")
    cat("|------------------------------------------------------------------|\n")
    cat("| Available Genesets                                               |\n")
    cat("|------------------------------------------------------------------|\n")
    cat("| Collection Subcollection | Description                               |\n")    
    cat("|------------------------------------------------------------------|\n")
    cat("| C1                   | Positional                                |\n")
    cat("| C2 CGP               | Chemical and Genetic Perturbations        |\n")
    cat("| C2 CP                | Canonical Pathways                        |\n")
    cat("| C2 CP:BIOCARTA       | Canonical BIOCARTA                        |\n")
    cat("| C2 CP:KEGG           | Canonical KEGG                            |\n")
    cat("| C2 CP:PID            | Canonical PID                             |\n")
    cat("| C2 CP:REACTOME       | Canonical REACTOME                        |\n")
    cat("| C3 MIR               | Motif miRNA Targets                       |\n")
    cat("| C3 TFT               | Motif Transcription Factor Targets        |\n")
    cat("| C4 CGN               | Cancer Gene Neighborhoods                 |\n")
    cat("| C4 CM                | Cancer Modules                            |\n")
    cat("| C5 BP                | GO Biological Process                     |\n")
    cat("| C5 CC                | GO Cellular Component                     |\n")
    cat("| C5 MF                | GO Molecular Function                     |\n")
    cat("| C6                   | Oncogenic Signatures                      |\n")
    cat("| C7                   | Immunologic Signatures                    |\n")
    cat("| H                    | Hallmark                                  |\n")
    cat("|------------------------------------------------------------------|\n")
    cat("| Source: http://software.broadinstitute.org/gsea/msigdb           |\n")
    cat("|------------------------------------------------------------------|\n")
}

#' Download data from msigdb in the form of a named list
#'
#' @param species A species to determine gene symbols (refer to ?msigdbr::msigdbr for available species)
#' @param collection Geneset collection (refer to ?msigdbr::msigdbr_collections for available categories)
#' @param subcollection Geneset subcollection (refer to ?msigdbr::msigdbr_collections for available subcategories)
#' @return A list of genesets
#'
#' @examples
#' HALLMARK_HUMAN <- msigdb_download("Homo sapiens", "H")
#' HALLMARK_MOUSE <- msigdb_download("Mus musculus", "MH")
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr select
#' @importFrom msigdbr msigdbr
#' @export
msigdb_download <- function(species, collection, subcollection=NULL) {
    
    # Check species
    msigdb_check_species(species)
    
    if(species == "Homo sapiens") {
      db_species = "HS"
    } else if (species == "Mus musculus") {
      db_species = "MM"
    } else {
      # For non-human species msigdb will use gene orthologs from the human database.
      db_species == "HS"
    }
    
    response <- msigdbr(species = species, 
                        db_species = db_species, 
                        collection = collection, 
                        subcollection = subcollection)
    if (nrow(response) == 0) {
        stop("No data found: Please review available species and genesets\n", msigdb_info())
    }
    
    # Download genesets
    mdf <- msigdbr(species = species, 
                   collection = collection, 
                   db_species = db_species, 
                   subcollection = subcollection) %>%
        dplyr::select(gs_name, gene_symbol) %>%
        dplyr::distinct()
    
    # Convert to list
    gsets <- split(mdf$gene_symbol, mdf$gs_name)
    return(gsets)
}

#' Download data from msigdb in the form of a gsets object
#'
#' @param species A species to determine gene symbols (refer to ?msigdbr::msigdbr_species for available species)
#' @param collection Geneset collection (refer to ?msigdbr::msigdbr_collections for available categories)
#' @param subcollection Geneset subcollection (refer to ?msigdbr::msigdbr_collections for available subcategories)
#' @param clean Use true to clean labels of genesets
#' @return A gsets object
#'
#' @examples
#' HALLMARK_HUMAN <- msigdb_gsets("Homo sapiens", "H")
#' HALLMARK_MOUSE <- msigdb_gsets("Mus musculus", "MH")
#'
#' @export
msigdb_gsets <- function(species, collection, subcollection=NULL, clean=FALSE) {
    genesets <- msigdb_download(species, collection, subcollection)
    name <- ifelse(is.null(subcollection), collection, paste(collection, subcollection, sep="."))
    version <- msigdb_version()
    gsets$new(genesets, name=name, version=version, clean=clean)
}

#' Differential Expression
#'
#' A differential expression table
#' 
#' @format A data frame
#' 
"limma"

#' Co-expression Modules
#'
#' A list of co-expression modules
#' 
#' @format A nested list of character vectors
#' 
"wgcna"

#' Plot top enriched genesets across multiple signatures
#'
#' @param multihyp_data A list of hyp objects
#' @param top Limit number of genesets shown
#' @param abrv Abbreviation length of genesetlabels
#' @param size_by Size dots by e.g. c("genesets", "significance", "none")
#' @param pval_cutoff Filter results to be less than pval cutoff
#' @param fdr_cutoff Filter results to be less than fdr cutoff
#' @param val Choose significance value e.g. c("fdr", "pval")
#' @param title Plot title
#' @return A ggplot object
#'
#' @importFrom reshape2 melt
#' @importFrom magrittr %>% set_colnames
#' @importFrom dplyr filter select
#' @importFrom scales log10_trans
#' @importFrom ggplot2 ggplot aes geom_point labs scale_color_continuous scale_size_continuous guides theme element_text element_blank
#' 
#' @keywords internal
.dots_multi_plot <- function(multihyp_data,
                             top=20,
                             abrv=50,
                             size_by=c("genesets", "significance", "overlap", "none"),
                             pval_cutoff=1, 
                             fdr_cutoff=1,
                             val=c("fdr", "pval"),
                             title="") {
    
    # Default arguments
    val <- match.arg(val)
    size_by <- match.arg(size_by)
    
    # Count significant genesets across signatures
    multihyp_dfs <- lapply(multihyp_data, function(hyp_obj) {
        hyp_obj$data %>%
        dplyr::filter(pval <= pval_cutoff) %>%
        dplyr::filter(fdr <= fdr_cutoff) %>%
        dplyr::select(label)
    })
    
    # Take top genesets
    labels <- names(sort(table(unlist(multihyp_dfs)), decreasing=TRUE))
    if (!is.null(top)) labels <- head(labels, top)
    
    # Handle empty dataframes
    if (length(labels) == 0) return(ggempty())
    
    # Create a multihyp dataframe
    dfs <- lapply(multihyp_data, function(hyp_obj) {
        hyp_df <- hyp_obj$data
        hyp_df[hyp_df$label %in% labels, c("label", val), drop=FALSE]
    })
    
    df <- suppressWarnings(Reduce(function(x, y) merge(x, y, by="label", all=TRUE), dfs))
    colnames(df) <- c("label", names(dfs))
    rownames(df) <- df$label
    df <- df[rev(labels), names(dfs)]
    
    # Abbreviate labels
    label.abrv <- substr(rownames(df), 1, abrv)
    if (any(duplicated(label.abrv))) {
        stop("Non-unique labels after abbreviating")
    } else {
        rownames(df) <- factor(label.abrv, levels=label.abrv)   
    }
    
    if (val == "pval") {
        cutoff <- pval_cutoff
        color.label <- "P-Value"
    }
    if (val == "fdr") {
        cutoff <- fdr_cutoff
        color.label <- "FDR"
    }
    
    df.melted <- reshape2::melt(as.matrix(df))
    colnames(df.melted) <- c("label", "signature", "significance")
    df.melted$size <- 1
    
    if (size_by == "significance") {
        df.melted$size <- df.melted$significance
    } else if (size_by == "genesets") {
        geneset.sizes <- lapply(multihyp_data, function(hyp_obj) {
                hyp_obj$data[, c("label", "geneset")]
            }) %>%
            do.call(rbind, .) %>%
            dplyr::distinct(label, .keep_all=TRUE) %>%
            dplyr::pull(geneset, label)
        #df.melted$size <- geneset.sizes[df.melted$label]
        names(geneset.sizes) <- substr(names(geneset.sizes), 1, abrv)
        stopifnot( all(!is.na(match_idx <- match(df.melted$label,names(geneset.sizes)))) )
        df.melted$size <- geneset.sizes[match_idx]
    } else if (size == "overlap") {
      stop( "size_by overlap not implemented yet")
      overlap.sizes <- lapply(multihyp_data, function(hyp_obj) {
        hyp_obj$data[, c("label", "overlap")]
      }) %>%
        do.call(rbind, .) %>%
        dplyr::distinct(label, .keep_all=TRUE) %>%
        dplyr::pull(overlap, label)
      #df.melted$size <- overlap.sizes[df.melted$label]
      names(overlap.sizes) <- substr(names(overlap.sizes), 1, abrv)
      stopifnot( all(!is.na(match_idx <- match(df.melted$label,names(overlap.sizes)))) )
      df.melted$size <- overlap.sizes[match_idx]
    }

    p <- df.melted %>%
    dplyr::filter(significance <= cutoff) %>%
    ggplot(aes(x=signature, y=label, color=significance, size=size)) +
    geom_point() +
    scale_color_continuous(high = "#114357", low = "#E53935", trans = scales::log10_trans(), guide = guide_colorbar(reverse = TRUE)) +
    labs(title=title, color=color.label) +  
    theme(plot.title=element_text(hjust=0.5),
          axis.title.y=element_blank(),
          axis.title.x=element_blank(),
          axis.text.x=element_text(angle=45, hjust=1))
    
    if (size_by == "none") {
        p <- p + guides(size="none")
    } else if (size_by == "significance") {
        p <- p + scale_size_continuous(trans=scales::log10_trans()) + labs(size="Significance")
    } else if (size_by == "genesets" ) {
        p <- p + scale_size_continuous(trans=scales::log10_trans()) + labs(size="Genesets\nSize")
    } else if (size_by == "overlap" ) {
      p <- p + scale_size_continuous(trans=scales::log10_trans()) + labs(size="Overlap\nSize")
    } else {
      stop("unrecognized 'size_by':", size_by)
    }
    return(p)
}

#' Plot top enriched genesets
#'
#' @param hyp_df A dataframe from a hyp object
#' @param top Limit number of genesets shown
#' @param abrv Abbreviation length of genesetlabels
#' @param size_by Size dots by e.g. c("genesets", "significance", "none")
#' @param pval_cutoff Filter results to be less than pval cutoff
#' @param fdr_cutoff Filter results to be less than fdr cutoff
#' @param val Choose significance value e.g. c("fdr", "pval")
#' @param title Plot title
#' @return A ggplot object
#'
#' @importFrom purrr when
#' @importFrom dplyr filter
#' @importFrom scales log10_trans
#' @importFrom ggplot2 ggplot aes geom_point labs scale_color_continuous scale_y_continuous guide_colorbar coord_flip geom_hline guides theme element_text element_blank
#' 
#' @keywords internal
.dots_plot <- function(hyp_df,
                       top=20,
                       abrv=50,
                       size_by=c("genesets", "significance", "none"),
                       pval_cutoff=1, 
                       fdr_cutoff=1,
                       val=c("fdr", "pval"),
                       title="") {
    
    # Default arguments
    val <- match.arg(val)
    size_by <- match.arg(size_by)

    # Subset results
    df <- hyp_df %>%
          dplyr::filter(pval <= pval_cutoff) %>%
          dplyr::filter(fdr <= fdr_cutoff) %>%
          purrr::when(!is.null(top) ~ head(., top), ~ .)

    # Handle empty dataframes
    if (nrow(df) == 0) return(ggempty())

    # Plotting variables
    df$significance <- df[,val]
    df$size <- 1
    
    if (size_by == "significance") {
        df$size <- df$significance
    }
    if (size_by == "genesets") {
        df$size <- df$geneset
    }

    # Order by significance value
    df <- df[order(-df[,val]),]
    
    # Abbreviate labels
    label.abrv <- substr(df$label, 1, abrv)
    if (any(duplicated(label.abrv))) {
        stop("Non-unique labels after abbreviating")
    } else {
        df$label.abrv <- factor(label.abrv, levels=label.abrv)   
    }

    if (val == "pval") {
        color.label <- "P-Value"
    }
    if (val == "fdr") {
        color.label <- "FDR"
    }

    p <- ggplot(df, aes(x=label.abrv, y=significance, color=significance, size=size)) +
    geom_point() +
    labs(title=title, y=color.label, color=color.label) +
    scale_color_continuous(low="#E53935", high="#114357", guide=guide_colorbar(reverse=TRUE)) +
    coord_flip() +
    scale_y_continuous(trans=.reverselog_trans(10)) +
    geom_hline(yintercept=0.05, linetype="dotted") +
    theme(plot.title=element_text(hjust=0.5),
          axis.title.y=element_blank())
    
    if (size_by == "none") {
        p <- p + guides(size="none")
    }
    if (size_by == "significance") {
        p <- p + scale_size_continuous(trans=.reverselog_trans(10)) + labs(size="Significance")
    }
    if (size_by == "genesets") {
        p <- p + scale_size_continuous(trans=scales::log10_trans()) + labs(size="Genesets\nSize")
    }
    
    return(p)
}

#' Visualize hyp/multihyp objects as a dots plot
#'
#' @param hyp_obj A hyp or multihyp object
#' @param top Limit number of genesets shown
#' @param abrv Abbreviation length of geneset labels
#' @param size_by Size dots by e.g. c("genesets", "significance", "none")
#' @param pval Filter results to be less than pval cutoff
#' @param fdr Filter results to be less than fdr cutoff
#' @param val Choose significance value for plot e.g. c("fdr", "pval")
#' @param title Plot title
#' @param merge Use true to merge a multihyp object into one plot
#' @return A ggplot object
#'
#' @examples
#' genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")
#'
#' signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
#'                "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
#'                "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")
#'
#' hyp_obj <- hypeR(signature, genesets, background=2522)
#'
#' hyp_dots(hyp_obj, val="fdr")
#'
#' @export
hyp_dots <- function(hyp_obj,
                     top=20,
                     abrv=50,
                     size_by=c("genesets", "significance", "none"),
                     pval=1, 
                     fdr=1,
                     val=c("fdr", "pval"), 
                     title="",
                     merge=FALSE) {

    stopifnot(is(hyp_obj, "hyp") | is(hyp_obj, "multihyp"))

    # Default arguments
    val <- match.arg(val)
    size_by <- match.arg(size_by)
    
    # Handling of multiple signatures
    if (is(hyp_obj, "multihyp")) {
        multihyp_obj <- hyp_obj

        # Merge multiple signatures into a single plot
        if (merge) {
            .dots_multi_plot(multihyp_obj$data, top, abrv, size_by, pval, fdr, val, title)
        } 
        # Return a list of plots for each signature
        else {
            mapply(function(hyp_obj, title) {

                hyp_dots(hyp_obj,
                         top=top,
                         abrv=abrv,
                         size_by=size_by,
                         pval=pval,
                         fdr=fdr,
                         val=val,
                         title=title)

            }, multihyp_obj$data, names(multihyp_obj$data), USE.NAMES=TRUE, SIMPLIFY=FALSE)
        }
    } 
    else {
        .dots_plot(hyp_obj$data, top, abrv, size_by, pval, fdr, val, title)
    }
}

#' Plot hiearchy map
#'
#' @param hyp_df A dataframe from a hyp object
#' @param rgsets_obj A relatonal geneset from a hyp object
#' @param pval_cutoff Filter results to be less than pval cutoff
#' @param fdr_cutoff Filter results to be less than fdr cutoff
#' @param val Choose significance value displayed when hovering nodes e.g. c("fdr", "pval")
#' @param top Limit number of pathways shown
#' @param title Plot title
#' @param graph Return an igraph object instead
#' @return A visNetwork object
#'
#' @importFrom purrr when
#' @importFrom dplyr filter
#' @importFrom igraph graph_from_data_frame set_vertex_attr as_ids V E
#' @importFrom visNetwork visNetwork visNodes visEdges visOptions visInteraction visIgraphLayout
#' 
#' @keywords internal
.hiearchy_map <- function(hyp_df,
                          rgsets_obj,
                          pval_cutoff=1, 
                          fdr_cutoff=1,
                          val=c("fdr", "pval"),
                          top=NULL,
                          title="",
                          graph=FALSE) {

    # Subset results
    hyp_df <- hyp_df %>%
              dplyr::filter(pval <= pval_cutoff) %>%
              dplyr::filter(fdr <= fdr_cutoff) %>%
              purrr::when(!is.null(top) ~ head(., top), ~ .)
        
    # Handle empty dataframes
    if (nrow(hyp_df) == 0) return(NULL)
    
    # Subset relational genesets
    rgsets.obj.subset <- rgsets_obj$subset(hyp_df$label)
    
    # Extract hiearchy information
    nodes <- rgsets.obj.subset$nodes
    edges <- rgsets.obj.subset$edges

    # Node sizes set by geneset length
    size.scaler <- function(x) (x-min(x, na.rm=TRUE))/(max(x, na.rm=TRUE)-min(x, na.rm=TRUE))*30
    nodes$size <- sapply(size.scaler(nodes$length), function(x) ifelse(x < 15, 15, x))
    
    # Node weights based on significance
    node.weights <- sapply(nodes$label, function(x) {
                           if (x %in% hyp_df$label) {
                               hyp_df %>%
                               dplyr::filter(label == x) %>%
                               dplyr::pull(val)
                           } else { NA }
                    })

    val.pretty <- ifelse(val == "fdr", "FDR", "P-Value")
    nodes$title <- sapply(node.weights, function(x) {
                       ifelse(is.na(x), NA, paste(val.pretty, x, sep=": "))
                   })

    nodes$color.background <- ifelse(is.na(node.weights), "#581845", "#C70039")
    nodes$color.highlight <- ifelse(is.na(node.weights), .hexa("#581845", 0.9), .hexa("#C70039", 0.9))
    weight.scaler <- function(x) (x-max(x, na.rm=TRUE))/(min(x, na.rm=TRUE)-max(x, na.rm=TRUE))
    nodes$color.border <- sapply(weight.scaler(node.weights), function(x) { 
                                  if (is.na(x)) {
                                      return("#581845")
                                  } else{
                                      return(.hexa("#FFC300", x))
                                  }
                          })

    if (graph) {
        ig <- igraph::graph_from_data_frame(edges, directed=TRUE, vertices=rownames(nodes))
        v.id <- igraph::as_ids(igraph::V(ig))
        v.where <- match(v.id, rownames(nodes))
        v.label <- nodes[v.where, "label"]
        v.weight <- sapply(v.label, function(x) {
            if (x %in% hyp_df$label) {
                hyp_df %>%
                dplyr::filter(label == x) %>%
                dplyr::pull(val)
            } else { NA }
        })
        ig <- igraph::set_vertex_attr(ig, name=val, value=v.weight)
        igraph::V(ig)$size = nodes[v.where, "size"]
        igraph::V(ig)$color = nodes[v.where, "color.background"]
        igraph::V(ig)$frame.color = nodes[v.where, "color.border"]
        igraph::V(ig)$label = v.label
        igraph::V(ig)$type = ifelse(is.na(v.weight), "internal", "leaf")
        igraph::V(ig)$label.family = "Helvetica"
        igraph::V(ig)$label.color = "#000000"
        igraph::V(ig)$label.font = 2
        igraph::V(ig)$label.cex = 0.75
        igraph::V(ig)$label.dist = 1
        igraph::E(ig)$width = 1
        igraph::E(ig)$color = "#3D3D3D"
        igraph::E(ig)$arrow.size= 0.2
        return(ig)
    } else {
        visNetwork(nodes, edges, main=list(text=title, style="font-family:Helvetica")) %>%
        visNodes(borderWidth=3, borderWidthSelected=0) %>%
        visEdges(arrows='to', selectionWidth=0) %>%
        visIgraphLayout(layout="layout_nicely") %>%  
        visInteraction(multiselect=TRUE, tooltipDelay=300) %>%
        visOptions(highlightNearest=TRUE, collapse=list(enabled=TRUE, clusterOptions=list(color="rgba(199,0,57,1.0)")))   
    }
}

#' Visualize hyp/multihyp objects as a hiearchy map
#'
#' @param hyp_obj A hyp or multihyp object
#' @param pval Filter results to be less than pval cutoff
#' @param fdr Filter results to be less than fdr cutoff
#' @param val Choose significance value displayed when hovering nodes e.g. c("fdr", "pval")
#' @param top Limit number of pathways shown
#' @param title Plot title
#' @param graph Return an igraph object instead
#' @return A visNetwork object
#'
#' @examples
#' genesets <- hyperdb_rgsets("REACTOME", "70.0")
#'
#' signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
#'                "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
#'                "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")
#'
#' hyp_obj <- hypeR(signature, genesets, background=2522)
#'
#' hyp_hmap(hyp_obj, top=60)
#'
#' @importFrom rlang duplicate
#' 
#' @export
hyp_hmap <- function(hyp_obj,
                     pval=1, 
                     fdr=1,
                     val=c("fdr", "pval"),
                     top=NULL,
                     title="",
                     graph=FALSE) {
    
    # Checks and warnings
    stopifnot(is(hyp_obj, "hyp") | is(hyp_obj, "multihyp"))
    
    # Default arguments
    val <- match.arg(val)

    # Handling of multiple signatures
    if (is(hyp_obj, "multihyp")) {
        multihyp_obj <- hyp_obj

        mapply(function(hyp_obj, title) {

            hyp_hmap(hyp_obj,
                     pval=pval,
                     fdr=fdr,
                     val=val,
                     top=top,
                     title=title,
                     graph=graph)

        }, multihyp_obj$data, names(multihyp_obj$data), USE.NAMES=TRUE, SIMPLIFY=FALSE)
    } 
    else {
        hyp_df <- hyp_obj$data
        rgsets_obj <- rlang::duplicate(hyp_obj$args$genesets)
        stopifnot(is(rgsets_obj, "rgsets"))
        .hiearchy_map(hyp_df, rgsets_obj, pval, fdr, val, top, title, graph)
    }
}

#' @title A genesets object
#' 
#' @examples
#' genesets <- list("GSET1" = c("GENE1", "GENE2", "GENE3"),
#'                  "GSET2" = c("GENE4", "GENE5", "GENE6"),
#'                  "GSET3" = c("GENE7", "GENE8", "GENE9"))
#'
#' gsets_obj <- gsets$new(genesets, name="example", version="v1.0")
#' print(gsets_obj)
#' 
#' @section See Also:
#' 
#' \code{rgsets}
#' 
#' @importFrom R6 R6Class
#' 
#' @export
gsets <- R6Class("gsets", list(
    #' @field genesets A named list of genesets
    #' @field name A character vector describing source of genesets
    #' @field version A character vector describing versioning
    genesets = NULL,
    name = NULL,
    version = NULL,

    #' @description
    #' Create a gsets object
    #' @param genesets A named list of genesets
    #' @param name A character vector describing source of genesets
    #' @param version A character vector describing versioning
    #' @param clean Use true to clean labels of genesets
    #' @param quiet Use true to silence warnings
    #' @return A new gsets object
    initialize = function(genesets, name="Custom", version="", clean=FALSE, quiet=FALSE) {
        if (!is(genesets, "list")) stop("Genesets must be a named list of symbols")
        if (is.null(names(genesets))) stop("Genesets must be a named list of symbols")
        
        # Handle versioning information
        if (name == "Custom" & !quiet) warning("Describing genesets with a name will aid reproducibility")
        if (version == "" & !quiet) warning("Including a version number will aid reproducibility")
        
        if (clean) {
            names(genesets) <- clean_genesets(names(genesets))
        }
        
        self$genesets <- genesets
        self$name <- name
        self$version <- version
    },
    #' @description
    #' Print genesets information
    #' @return NULL
    print = function() {
        cat(self$info(), "\n")
        for (i in head(names(self$genesets))) {
            cat(.format_str("{1} ({2})\n", i, length(self$genesets[[i]])))
        }
        invisible(self)
    },
    #' @description
    #' Return genesets as a list
    #' @return A list of genesets
    list = function() {
        return(self$genesets)
    },
    #' @description
    #' Returns versioning information
    #' @return A character vector with name and version
    info = function() {
        return(.format_str("{1} {2}", self$name, self$version))
    },
    #' @description
    #' Reduces genesets to a background distribution of symbols
    #' @param background A character vector of symbols
    #' @return A gsets object
    reduce = function(background) {
        genesets <- lapply(self$genesets, function(x) intersect(x, background))
        return(gsets$new(genesets, self$name, self$version, quiet=TRUE))
    }
))

test_that("gsets object is working", {
    
    genesets <- list("GSET1" = c("GENE1", "GENE2", "GENE3"),
                     "GSET2" = c("GENE4", "GENE5", "GENE6"),
                     "GSET3" = c("GENE7", "GENE8", "GENE9"))

    # Basic functionality
    gsets_obj <- gsets$new(genesets=genesets, name="example", version="1.0")
    expect_is(gsets_obj, "gsets")
    expect_is(gsets_obj, "R6")   
    expect_output(print(gsets_obj))
    expect_equal(gsets_obj$genesets, genesets)
    expect_equal(gsets_obj$name, "example")
    expect_equal(gsets_obj$version, "1.0")
    
    # Reduce genesets on a background distribution of symbols
    background <- c("GENE1", "GENE2", "GENE5", "GENE7", "GENE8", "GENE9")
    gsets_obj_reduce <- gsets_obj$reduce(background)
    expect_output(print(gsets_obj))
    expect_equal(gsets_obj_reduce$genesets, list("GSET1" = c("GENE1", "GENE2"),
                                                 "GSET2" = c("GENE5"),
                                                 "GSET3" = c("GENE7", "GENE8", "GENE9")))    
    
    # Warnings and errors
    expect_warning(gsets$new(genesets=genesets))
    expect_warning(gsets$new(genesets=genesets, name="example"))
    expect_warning(gsets$new(genesets=genesets, version="1.0"))
    expect_error(gsets$new(c("GENE1", "GENE2", "GENE3")))
    expect_error(gsets$new(list(c("GENE1", "GENE2", "GENE3"))))
})

test_that("rgsets object is working", {
    
    testdat <- readRDS(file.path(system.file("extdata", package="hypeR"), "testdat.rds"))
    genesets <- testdat$rgsets$genesets
    nodes <- testdat$rgsets$nodes
    edges <- testdat$rgsets$edges
    
    # Basic functionality
    rgsets_obj <- rgsets$new(genesets=genesets, nodes=nodes, edges=edges, name="example", version="1.0")
    expect_is(rgsets_obj, "rgsets")
    expect_is(rgsets_obj, "R6")   
    expect_output(print(rgsets_obj))
    expect_equal(names(rgsets_obj$genesets)[1:3], c("Leaf Geneset 1", "Leaf Geneset 2", "Leaf Geneset 3"))
    expect_equal(colnames(rgsets_obj$nodes), c("label", "id", "length"))
    expect_equal(rgsets_obj$nodes["G12", "length"], length(unique(c(rgsets_obj$genesets[["Leaf Geneset 7"]],
                                                                    rgsets_obj$genesets[["Leaf Geneset 8"]],
                                                                    rgsets_obj$genesets[["Leaf Geneset 9"]]))))
    
    
    # Reduce functionality
    background <- c("D", "G", "A", "B", "K", "N")
    rgsets_obj_reduce <- rgsets_obj$reduce(background)
    expect_output(print(rgsets_obj_reduce))
    expect_equal(rgsets_obj_reduce$genesets[c(1,2,4)], list("Leaf Geneset 1" = c("D", "G", "A", "B", "K", "N"),
                                                            "Leaf Geneset 2" = c("N", "G", "B"),
                                                            "Leaf Geneset 4" = c("G", "N", "B")))    
    
    # Subset functionality
    expect_equal(colnames(rgsets_obj$edges), c("from", "to"))
    expect_equal(dim(rgsets_obj$edges), c(10,2))
    rgsets_obj_subset <- rgsets_obj$subset(c("Leaf Geneset 1", "Leaf Geneset 5", "Leaf Geneset 8"))
    expect_equivalent(c("G1","G11","G12","G13","G14","G15","G5","G8"), sort(rgsets_obj_subset$nodes$id))
    expect_equal(names(rgsets_obj_subset$genesets), c("Leaf Geneset 1", "Leaf Geneset 5", "Leaf Geneset 8"))
    expect_equal(dim(rgsets_obj_subset$edges), c(6,2))
    expect_equal(dim(rgsets_obj$edges), c(10,2))
    
    # Warnings and errors
    expect_warning(rgsets$new(genesets=genesets, nodes=nodes, edges=edges))
    expect_warning(rgsets$new(genesets=genesets, nodes=nodes, edges=edges, name="example"))
    expect_warning(rgsets$new(genesets=genesets, nodes=nodes, edges=edges, version="v1.0"))
})

#' @title A relational genesets object
#' @section See Also:
#' 
#' \code{gsets}
#' 
#' @importFrom R6 R6Class
#' @importFrom dplyr filter pull %>%
#' 
#' @export
rgsets <- R6Class("rgsets", list(
    #' @field genesets A list of genesets where list names refers to geneset labels and values are geneset members represented as a vector
    #' @field nodes A data frame of labeled nodes
    #' @field edges A data frame of directed edges
    #' @field name A character vector describing source of genesets
    #' @field version A character vector describing versioning
    genesets = NULL,
    nodes = NULL,
    edges = NULL,
    name = NULL,
    version = NULL,

    #' @description
    #' Create a rgsets object
    #' @param genesets A list of genesets where list names refers to geneset labels and values are geneset members represented as a vector
    #' @param nodes A data frame of labeled nodes
    #' @param edges A data frame of directed edges
    #' @param name A character vector describing source of genesets
    #' @param version A character vector describing versioning
    #' @param quiet Use true to silence warnings
    #' @return A new rgsets object
    initialize = function(genesets, nodes, edges, name="Custom", version="", quiet=FALSE) {
        # Handle versioning information
        if (name == "Custom" & !quiet) warning("Describing genesets with a name will aid reproducibility")
        if (version == "" & !quiet) warning("Including a version number will aid reproducibility")
        
        # Basic checks
        stopifnot(is(edges, "data.frame"))
        stopifnot(ncol(edges) == 2)
        stopifnot(colnames(edges) == c("from", "to"))
        stopifnot(is(nodes, "data.frame"))
        stopifnot(ncol(nodes) > 0)
        stopifnot("label" %in% colnames(nodes))
        
        if (!all(unique(unlist(edges)) %in% rownames(nodes))) {
            stop("Some edge entities are missing from nodes")
        }
        if (any(is.na(edges$from) | is.na(edges$to))) {
            edges <- edges[complete.cases(edges),]
            warning("Dropping incomplete edges")
        }
        if (any(edges$from == edges$to)) {
            edges <- edges[edges$from != edges$to,]
            warning("Dropping edges with self loops")
        }
        
        self$genesets <- genesets
        self$nodes <- nodes
        self$edges <- edges
        self$nodes$id <- rownames(self$nodes)
        self$nodes$length <- sapply(self$nodes$id, function(x) {length(.find_members(x, genesets, nodes, edges))})
        self$name <- name
        self$version <- version
    },
    #' @description
    #' Print relational genesets information
    #' @return NULL
    print = function() {
        cat(self$info(), "\n\n")
        cat("Genesets\n\n")
        for (i in head(names(self$genesets))) {
            cat(.format_str("{1} ({2})\n", i, length(self$genesets[[i]])))
        }
        cat("\nNodes\n\n")
        base::print(head(self$nodes))
        cat("\nEdges\n\n")
        base::print(head(self$edges)) 
        invisible(self)
    },
    #' @description
    #' Returns versioning information
    #' @return A character vector with name and version
    info = function() {
        return(.format_str("{1} {2}", self$name, self$version))
    },
    #' @description
    #' Reduces genesets to a background distribution of symbols
    #' @param background A character vector of symbols
    #' @return A rgsets object
    reduce = function(background) {
        genesets <- lapply(self$genesets, function(x) intersect(x, background))
        return(rgsets$new(genesets, self$nodes, self$edges, self$name, self$version, quiet=TRUE))
    },
    #' @description
    #' Subsets genesets on a character vector of labels
    #' @param labels A character vector of genesets
    #' @return A rgsets object
    subset = function(labels) {

        children <- self$nodes %>%
                    subset(label %in% labels) %>%
                    rownames()

        ids.subset <- pvector$new()
        for (id.x in children) {
            
            ids.subset$push(id.x)
            
            parents <- pvector$new(
                           self$edges %>%
                           dplyr::filter(to == id.x) %>%
                           dplyr::pull(from)   
                       )
            
            while (parents$length() > 0) {
                id.y <- parents$pop()
                id.z <- self$edges %>%
                        dplyr::filter(to == id.y) %>%
                        dplyr::pull(from)
                
                ids.subset$push(c(id.y, id.z))  
                parents$push(id.z)
            }
        }
        ids <- unique(ids.subset$values)
        genesets <- self$genesets[names(self$genesets) %in% labels]
        nodes <- self$nodes[ids,,drop=F]
        edges <- self$edges[self$edges$from %in% ids & self$edges$to %in% ids,,drop=F]
        return(rgsets$new(genesets, nodes, edges, self$name, self$version, quiet=TRUE))
    }
))

#' Reactable table for hyp objects
#'
#' @param hyp A hyp object
#' @param type Use style class for outer or inner tables
#' @param show_emaps Option to show enrichment maps in tabs
#' @param show_hmaps Option to show hiearchy maps in tabs
#' @param hyp_emap_args A list of keyword arguments passed to hyp_emap
#' @param hyp_hmap_args A list of keyword arguments passed to hyp_hmap
#' 
#' @examples
#' genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")$genesets[1:5]
#'
#' signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
#'               "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
#'               "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")
#'
#' hyp_obj <- hypeR(signature, genesets, background=2522)
#'
#' rctbl_hyp(hyp_obj)
#'
#' @importFrom reactable reactable colDef
#' @importFrom htmltools div tagAppendChild
#' @importFrom dplyr select
#' 
#' @export
rctbl_hyp <- function(hyp,
                      type=c("inner", "outer"),
                      show_emaps=FALSE,
                      show_hmaps=FALSE,
                      hyp_emap_args=list(top=25, val="fdr"),
                      hyp_hmap_args=list(top=25, val="fdr")) {

    type <- match.arg(type)
    class.obj    <- .format_str("rctbl-{1}-obj", type)
    class.tbl    <- .format_str("rctbl-{1}-tbl", type)
    class.header <- .format_str("rctbl-{1}-header", type)

    df <- dplyr::select(hyp$data, c("label", "pval", "fdr", "geneset", "overlap", "hits"))
    tbl <- reactable(df,
                     rownames=FALSE,
                     resizable=TRUE,
                     showPageSizeOptions=FALSE,
                     compact=TRUE, 
                     defaultColDef=colDef(headerClass=class.header),
                     columns=list(label   = colDef(name="Label", minWidth=300),
                                  pval    = colDef(name="P-Value"),
                                  fdr     = colDef(name="FDR"),
                                  geneset = colDef(name="Geneset Size"),
                                  overlap = colDef(name="Overlap"),
                                  hits    = colDef(name="Hits")),
                     class=class.tbl)

    dat <- htmltools::div(class=class.obj, tbl)
    
    if (show_emaps) {
        hyp_emap_args[['hyp_obj']] <- hyp
        viz <- do.call(hyp_emap, hyp_emap_args)
        dat <- htmltools::tagAppendChild(dat, viz)
    }

    if (show_hmaps) {
        hyp_hmap_args[['hyp_obj']] <- hyp
        viz <- do.call(hyp_hmap, hyp_hmap_args)
        dat <- htmltools::tagAppendChild(dat, viz)
    }

    return(dat)
}

#' Reactable table for multihyp objects
#'
#' @param mhyp A multihyp object
#' @param show_emaps Option to show enrichment maps in tabs
#' @param show_hmaps Option to show hiearchy maps in tabs
#' @param hyp_emap_args A list of keyword arguments passed to hyp_emap
#' @param hyp_hmap_args A list of keyword arguments passed to hyp_hmap
#' 
#' @examples
#' genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")$genesets[1:5]
#'
#' experiment <- list("S1"=c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502"),
#'                    "S2"=c("PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC"))
#'
#' mhyp_obj <- hypeR(experiment, genesets, background=2522)
#'
#' rctbl_mhyp(mhyp_obj)
#' 
#' @importFrom reactable reactable colDef
#' @importFrom htmltools div
#' 
#' @export
rctbl_mhyp <- function(mhyp,
                       show_emaps=FALSE,
                       show_hmaps=FALSE,
                       hyp_emap_args=list(top=25, val="fdr"),
                       hyp_hmap_args=list(top=25, val="fdr")) {

    mhyp.df <- data.frame(signature=names(mhyp$data), 
                          size=sapply(mhyp$data, function(hyp) hyp$info[["Signature Size"]]),
                          enriched=sapply(mhyp$data, function(hyp) nrow(hyp$data)),
                          gsets=sapply(mhyp$data, function(hyp) hyp$info[["Genesets"]]),
                          bg=sapply(mhyp$data, function(hyp) hyp$info[["Background"]]))
    
    tbl <- reactable(
        mhyp.df,
        showPageSizeOptions = FALSE,
        onClick = "expand",
        resizable = TRUE,
        rownames = FALSE,
        defaultColDef = colDef(headerClass="rctbl-outer-header"),
        columns = list(signature = colDef(name="Signature", minWidth=300),
                       size = colDef(name="Signature Size"),
                       enriched = colDef(name="Enriched Genesets"),
                       gsets = colDef(name="Genesets"),
                       bg = colDef(name="Background")),
        
        details = function(index) {
                hyp <- mhyp$data[[index]]
                rctbl_hyp(hyp, type="inner", show_emaps, show_hmaps, hyp_emap_args, hyp_hmap_args)
            },
        wrap = FALSE,
        class = "rctbl-outer-tbl",
        rowStyle = list(cursor="pointer")
        )
    
    htmltools::div(class="rctbl-outer-obj", tbl) 
}

#' Reactable builder for hyp or mhyp objects
#' 
#' @param obj A hyp or multihyp object
#' @param ... Arguments passed to table generators 
#' 
#' @examples
#' genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")$genesets[1:5]
#'
#' experiment <- list("S1"=c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502"),
#'                    "S2"=c("PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC"))
#'
#' mhyp_obj <- hypeR(experiment, genesets, background=2522)
#'
#' rctbl_build(mhyp_obj)
#' 
#' @export
rctbl_build <- function(obj, ...) {
    if (is(obj, "hyp")) {
        obj <- multihyp$new(data=list(" " = obj))
    }
    return(rctbl_mhyp(obj, ...))
}

#' Convert a hyp object to a reactable table
#'
#' @param hyp_obj A hyp object
#' @param simple Use true to only include essential columns
#' @return A reactable table
#'
#' @examples
#' genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")
#'
#' signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
#'                "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
#'                "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")
#'
#' hyp_obj <- hypeR(signature, genesets, background=2522)
#'
#' hyp_show(hyp_obj)
#'
#' @importFrom reactable reactable
#' @importFrom stringr str_to_title
#' 
#' @export
hyp_show <- function(hyp_obj, simple=FALSE) {
    stopifnot(is(hyp_obj, "hyp"))

    # Extract hyp dataframe
    df <- hyp_obj$data

    # Pretty column names
    colnames(df) <- c("Label", "P-Value", "FDR", str_to_title(colnames(df)[4:ncol(df)]))

    cols <- if(simple) c(1,2,3) else seq_len(ncol(df))

    reactable(data=df[,cols,drop=FALSE],
              searchable=TRUE,
              compact=TRUE, 
              fullWidth=TRUE,
              defaultPageSize=15,
              pageSizeOptions=c(15, 25, 50, 100),
              striped=TRUE,
              showPageSizeOptions=TRUE)
}

#' Venn diagram implemented in ggplot
#'
#' @param a A vector for group a
#' @param b A vector for group b
#' @param ga A string label for group a
#' @param gb A string label for group b
#' @param title Plot title
#' @return A ggplot object
#'
#' @importFrom igraph groups
#' @importFrom magrittr %>%
#' @importFrom ggplot2 ggplot aes coord_fixed theme_void theme labs element_text
#' @importFrom ggforce geom_circle
#' 
#' @export
ggvenn <- function(a, b, ga, gb, title="") {
   
    # Calculate area
    x.a <- length(a)
    x.b <- length(b)
    x.u <- length(intersect(a, b))
    
    # Normalize area between 0-1
    nx.a <- x.a/(x.a+x.b)
    nx.b <- x.b/(x.a+x.b)
    
    # Circle radius and diameter
    r.a <- sqrt(nx.a/pi); d.a <- r.a*2
    r.b <- sqrt(nx.b/pi); d.b <- r.b*2
    
    # Overlay circles by percent overlap of smaller group
    ol <- ifelse(x.a < x.b, d.a*x.u/x.a, d.b*x.u/x.b)
    
    data.frame(x=c(-r.b-r.a+ol, 0),
               y=c(0, 0),
               groups=c(paste(ga, " (", x.a, ")", sep=""),
                        paste(gb, " (", x.b, ")", sep=""))) %>%
        
    ggplot(aes(x0=x, y0=y, r=c(r.a, r.b), fill=groups)) +
    geom_circle(alpha=0.3, linewidth=0.5) +
    coord_fixed() +
    theme_void() +
    theme(plot.title=element_text(hjust=0.5),
          plot.subtitle=element_text(hjust=0.5)) +
    labs(title=title, subtitle=paste("Overlap", " (", x.u, ")", sep=""))
}

test_that("ggvenn() is working", {
    testdat <- readRDS(file.path(system.file("extdata", package="hypeR"), "testdat.rds"))
    signature <- testdat$signature
    genesets <- testdat$gsets$genesets
    p <- ggvenn(signature, genesets[[1]], "signature", "genset", "Geneset Name")
    expect_is(p, "gg")
})

#' Convert a hyp object to an igraph object
#'
#' @param hyp_obj A hyp object
#' @return An igraph object
#'
#' @examples
#' genesets <- hyperdb_rgsets("REACTOME", "70.0")
#'
#' signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
#'                "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
#'                "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")
#'
#' hyp_obj <- hypeR(signature, genesets, background=2522)
#'
#' ig <- hyp_to_graph(hyp_obj)
#' 
#' @importFrom igraph graph_from_data_frame set_vertex_attr as_ids V E
#' @importFrom rlang duplicate
#' 
#' @export
hyp_to_graph <- function(hyp_obj) {
    
    # Checks and warnings
    stopifnot(is(hyp_obj, "hyp"))
    hyp_df <- hyp_obj$data
    rgsets_obj <- rlang::duplicate(hyp_obj$args$genesets)
    stopifnot(is(rgsets_obj, "rgsets"))
    
    # Extract nodes and edges
    nodes <- rgsets_obj$nodes
    edges <- rgsets_obj$edges
    
    # Create igraph and copy over enrichment data to graph vertices
    ig <- igraph::graph_from_data_frame(edges, directed=TRUE, vertices=rownames(nodes))
    v.id <- igraph::as_ids(igraph::V(ig))
    v.where <- match(v.id, rownames(nodes))
    v.label <- nodes[v.where, "label"]
    igraph::V(ig)$label <- v.label
    hyp.where <- match(v.label, hyp_df$label)
    for (i in setdiff(colnames(hyp_df), "label")) {
        ig <- igraph::set_vertex_attr(ig, name=i, value=hyp_df[hyp.where, i])
    }
    
    return(ig)
}

---
title: "Using hypeR in Shiny Applications"
vignette: >
  %\VignetteIndexEntry{Visualize Results}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include=FALSE, messages=FALSE, warnings=FALSE}
knitr::opts_chunk$set(comment="", fig.align="center", fig.width=10, fig.height=8, cache=FALSE)
devtools::load_all(".")
```

# Shiny Modules
All __hypeR__ methods output objects that are compatible with R Shiny and can be incorporated into a variety of applications (e.g. `hyp_dots()` returns a `ggplot` object). The most difficult challenge in incorporating geneset enrichment tasks in Shiny applications is the geneselect selection / fetching itself. To help with this, __hypeR__ includes module functions that abstract away the geneset selection code.

## What Are Shiny Modules?

Shiny modules are functions that generato Shiny UI / Server code. They are composable elements that can be used within and interface with existing applications. For more information, check out the [latest documentation](https://shiny.rstudio.com/articles/modules.html).

## Example

For those familiar with Shiny, you will have accompanying modules for the ui and server sections of your application. These modules are `hypeR::genesets_UI()` and `hypeR::genesets_Server()` respectively.

### UI

Here we create a simple interface where we use the genesets selection module. Through that module, users can select genesets available through **hypeR** and the application will load those genesets into a *reactive variable* (more on this later). We add additional code to take a user-defined gene signature and produce an enrichment plot which represents components specific to your Shiny application. This can be anything!

```{r, eval=FALSE}
ui <- fluidPage(
        sidebarLayout(
            sidebarPanel(
                # Put your geneset selector module anywhere
                hypeR::genesets_UI("genesets"),
                
                # Add components specific to your application
                textAreaInput("signature", 
                              label="Signature", 
                              rows=5,
                              placeholder="GENE1,GENE2,GENE3", 
                              resize="vertical"),
                
                actionButton("enrichment", "Enrichment")
            ),
            mainPanel(
                # Enrichment plot
                plotOutput("plot")
            )
        )
    )
```

### Server

Now we need to create the server code that is responsible for all the backend work. Again, we provide an associated module function for the server code. The serve code returns a *reactive variable* containing the fetched genesets that were selected. **Selection changes will update this variable and propogate to downstream functions**. Importantly, this variable holding the genesets can be accessed by any part of your application now, enabling you to make applications completely customizable while still utilizing this feature. As an example, our custom function is producing a simple enrichment plot.

```{r, eval=FALSE}
server <- function(input, output, session) {
    # Retrieve selected genesets as a reactive variable
    # Selection changes will update this variable and propogate to downstream functions
    genesets <- hypeR::genesets_Server("genesets")
    
    # Your custom downstream functions
    reactive_plot <- eventReactive(input$enrichment, {
        
        # Here are the fetched genesets
        gsets <- genesets()
        
        # Process the signature into a character vector
        signature <- input$signature %>%
                     stringr::str_split(pattern=",", simplify=TRUE) %>%
                     as.vector()
        
        # Run hypeR
        hyp <- hypeR::hypeR(signature, gsets, test="hypergeometric")
        p <- hypeR::hyp_dots(hyp, top=10, fdr=0.25)
        
        # These are just ggplot objects you could customize
        p + theme(axis.text=element_text(size=12, face="bold"))
    })
    
    output$plot <- renderPlot({
        reactive_plot()
    })
}
```

## Run

```{r, eval=FALSE}
shinyApp(ui, server)
```

---
title: "Downloading Genesets"
vignette: >
  %\VignetteIndexEntry{Downloading Genesets}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include=FALSE, messages=FALSE, warnings=FALSE}
knitr::opts_chunk$set(comment="", cache=FALSE, fig.align="center")
devtools::load_all(".")
library(tidyverse)
library(qusage)
library(igraph)
```

# Object Oriented Genesets

Genesets are simply a named list of character vectors which can be directly passed to `hyper()`. Alternatively, one can pass a `gsets` object, which can retain the name and version of the genesets one uses. This versioning will be included when exporting results or generating reports, which will ensure your results are reproducible.

```{r}
genesets <- list("GSET1" = c("GENE1", "GENE2", "GENE3"),
                 "GSET2" = c("GENE4", "GENE6"),
                 "GSET3" = c("GENE7", "GENE8", "GENE9"))
```

Creating a `gsets` object is easy...

```{r}
genesets <- gsets$new(genesets, name="Example Genesets", version="v1.0")
print(genesets)
```

And can be passed directly to `hyper()`...

```{r eval=FALSE}
hypeR(signature, genesets)
```

To aid in workflow efficiency, __hypeR__ enables users to download genesets, wrapped as `gsets` objects, from multiple data sources.

# Downloading **msigdb** Genesets

Most researchers will find the genesets hosted by [msigdb](https://software.broadinstitute.org/gsea/msigdb/collections.jsp) are adequate to perform geneset enrichment analysis. There are various types of genesets available across multiple species.

**Please pay attention to the versioning** - `hypeR` will default to the `msigdbr` version installed on your machine which updates with the curation version of the genesets frequently done by the Broad. Check to make sure you are using the genesets you expect.

```{r eval=FALSE}
msigdb_version()
```

If you want a specific version, you need to reinstall the dependency.

```{r eval=FALSE}
devtools::install_version("msigdbr", version="7.2.1", repos="http://cran.us.r-project.org")
```


```{r eval=FALSE}
msigdb_info()
```

Here we download the Hallmarks genesets...

```{r}
HALLMARK <- msigdb_gsets(species="Homo sapiens", collection="H")
print(HALLMARK)
```

We can also clean them up by removing the first leading common substring...

```{r}
HALLMARK <- msigdb_gsets(species="Homo sapiens", collection="H", clean=TRUE)
print(HALLMARK)
```

This can be passed directly to `hypeR()`...

```{r eval=FALSE}
hypeR(signature, genesets=HALLMARK)
```

Other commonly used genesets include Biocarta, Kegg, and Reactome...

```{r}
BIOCARTA <- msigdb_gsets(species="Homo sapiens", collection="C2", subcollection="CP:BIOCARTA")
KEGG     <- msigdb_gsets(species="Homo sapiens", collection="C2", subcollection="CP:KEGG_LEGACY")
REACTOME <- msigdb_gsets(species="Homo sapiens", collection="C2", subcollection="CP:REACTOME")
```

# Downloading **enrichr** Genesets

If msigdb genesets are not sufficient, we have also provided another set of functions for downloading and loading other publicly available genesets. This is facilitated by interfacing with the publicly available [libraries](https://amp.pharm.mssm.edu/Enrichr/#stats) hosted by [enrichr](https://amp.pharm.mssm.edu/Enrichr/).

```{r}
available <- enrichr_available()
reactable(available)
```

```{r}
ATLAS <- enrichr_gsets("Human_Gene_Atlas")
print(ATLAS)
```

Note: These libraries do not have a systematic versioning scheme, however the date downloaded will be recorded.

Additionally download other species if you aren't working with human or mouse genes!

```{r eval=FALSE}
yeast <- enrichr_gsets("GO_Biological_Process_2018", db="YeastEnrichr")
worm <- enrichr_gsets("GO_Biological_Process_2018", db="WormEnrichr")
fish <- enrichr_gsets("GO_Biological_Process_2018", db="FishEnrichr")
fly <- enrichr_gsets("GO_Biological_Process_2018", db="FlyEnrichr")
```

# Relational Genesets

When dealing with hundreds of genesets, it's often useful to understand the relationships between them. This allows researchers to summarize many enriched pathways as more general biological processes. To do this, we rely on curated relationships defined between them. For example, [Reactome](https://reactome.org/) conveniently defines their genesets in a [hiearchy of pathways](https://reactome.org/PathwayBrowser/). This data can be formatted into a relational genesets object called `rgsets`.

We currently curate some relational genesets for use with __hypeR__ and plan to add more continuously.

```{r}
hyperdb_available()
```

Downloading relational genesets is easy...

```{r}
genesets <- hyperdb_rgsets("REACTOME", "70.0")
```

And can be passed directly to `hyper()`...

```{r eval=FALSE}
hypeR(signature, genesets)
```

### Creating Relational Genesets

We try to provide relational genesets for popular databases that include hierarchical information. For users who want to create their own, we provide this example.

Raw data for gsets, nodes, and edges can be directly downloaded.

```{r}
genesets.url <- "https://reactome.org/download/current/ReactomePathways.gmt.zip"
nodes.url <- "https://reactome.org/download/current/ReactomePathways.txt"
edges.url <- "https://reactome.org/download/current/ReactomePathwaysRelation.txt"
```

#### Loading Data
```{r message=FALSE}
# Genesets
genesets.tmp <- tempfile(fileext=".gmt.zip")
download.file(genesets.url, destfile = genesets.tmp, mode = "wb")
genesets.raw <- genesets.tmp %>%
                unzip() %>%
                read.gmt() %>%
                lapply(function(x) {
                    toupper(x[x != "Reactome Pathway"])
                })
# Nodes
nodes.raw <- nodes.url %>%
             read.delim(sep="\t", 
                        header=FALSE, 
                        fill=TRUE, 
                        col.names=c("id", "label", "species"), 
                        stringsAsFactors=FALSE)
# Edges
edges.raw <- edges.url %>%
             read.delim(sep="\t", 
                        header=FALSE, 
                        fill=TRUE, 
                        col.names=c("from", "to"),
                        stringsAsFactors=FALSE)
```

#### Organizing a Hierarchy

```{r}
# Species-specific nodes
nodes <- nodes.raw %>%
         dplyr::filter( label %in% names(genesets.raw) ) %>%
         dplyr::filter( species == "Homo sapiens" ) %>%
         dplyr::filter(! duplicated(id) ) %>%
         magrittr::set_rownames( .$id ) %>%
         { .[, "label", drop=FALSE] }

# Species-specific edges
edges <- edges.raw %>%
         dplyr::filter( from %in% rownames(nodes) ) %>%
         dplyr::filter( to %in% rownames(nodes) )

# Leaf genesets
genesets <- nodes %>%
            rownames() %>%
            .[! . %in% edges$from] %>%
            sapply( function(x) nodes[x, "label"] ) %>%
            genesets.raw[.]
```

##### nodes

A single-column data frame of labels where the rownames are unique identifiers. Leaf node labels should have an associated geneset, while internal nodes do not have to. The only genesets tested, will be those in the list of genesets.

```{r}
head(nodes)
```

##### edges

A dataframe with two columns of identifiers, indicating directed edges between nodes in the hierarchy.

```{r}
head(edges)
```

##### genesets

A list of character vectors, named by the geneset labels. Typically, genesets will be at the leaves of the hierarchy, while not required.

```{r}
head(names(genesets))
```

#### The `rgsets` Object

```{r}
genesets <- rgsets$new(genesets, nodes, edges, name="REACTOME", version="v70.0")
print(genesets)
```

---
title: "Basic Usage"
vignette: >
  %\VignetteIndexEntry{Basic Usage}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include=FALSE, messages=FALSE, warnings=FALSE}
knitr::opts_chunk$set(comment="", cache=FALSE, fig.align="center")
library(tidyverse)
devtools::load_all(".")
```

# Terminology

All analyses with __hypeR__ must include one or more signatures and genesets.

### Signature
There are multiple types of enrichment analyses (e.g. hypergeometric, kstest, gsea) one can perform. Depending on the type, different kinds of signatures are expected. There are three types of signatures `hypeR()` expects.

```{r}
# Simply a character vector of symbols (hypergeometric)
signature <- c("GENE1", "GENE2", "GENE3")

# A ranked character vector of symbols (kstest)
ranked.signature <- c("GENE2", "GENE1", "GENE3")

# A ranked named numerical vector of symbols with ranking weights (gsea)
weighted.signature <- c("GENE2"=1.22, "GENE1"=0.94, "GENE3"=0.77)
```

### Geneset
A geneset is simply a list of vectors, therefore, one can use any custom geneset in their analyses, as long as it's appropriately defined. Additionally, `hypeR()` recognized object oriented genesets called `gsets` and `rgsets` objects, which are [explained later](https://montilab.github.io/hypeR-docs/articles/docs/data.html) in the documentation.

```{r}
genesets <- list("GSET1" = c("GENE1", "GENE2", "GENE3"),
                 "GSET2" = c("GENE4", "GENE5", "GENE6"),
                 "GSET3" = c("GENE7", "GENE8", "GENE9"))
```

# Usage

### Example Data

In these tutorials, we will use example data. The example data includes pre-computed results from common gene expression analysis workflows such as diffential expression and weighted gene co-expression.

```{r}
data(limma)
```

Using a differential expression dataframe created with Limma, we will extract a signature of upregulated genes for use with a *hypergeometric* test and rank genes descending by their differential expression level for use with a *kstest*.

```{r}
reactable(limma)
```

### Downloading Genesets

We'll also import the latest genesets from [Kegg](https://www.kegg.jp) using another set of functions provided by __hypeR__ for downloading and loading hundreds of open source genesets. 

```{r}
genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")
```

See [Downloading Genesets](https://montilab.github.io/hypeR-docs/articles/docs/data.html) for more information.

### Performing Enrichment

All workflows begin with performing enrichment with `hypeR()`. Often we're just interested in a single signature, as described above. In this case, `hypeR()` will return a `hyp` object. This object contains relevant information to the enrichment results, as well as plots for each geneset tested, and is recognized by downstream methods.

The most basic signature is an unranked vector of genes. This could be a differential expression signature, module of co-expressed genes, etc. As an example, we use the differential expression dataframe to filter genes that are upregulated (t > 0) and are sufficiently significant (fdr < 0.001), then extract the gene symbol column as a vector.

#### Unranked Signature

```{r}
signature <- limma %>% 
             dplyr::filter(t > 0 & fdr < 0.001) %>% 
             magrittr::use_series(symbol)
```

```{r}
length(signature)
head(signature)
```

```{r}
hyp_obj <- hypeR(signature, genesets, test="hypergeometric", background=50000, fdr=0.01, plotting=TRUE)
hyp_obj$plots[[1]]
```

#### Ranked Signature

Rather than setting a specific cutoff to define a differential expression signature, one could rank genes by their expression and provide the entire ranked vector as signature. From the differential expression dataframe, we order genes descending so upregulated genes are near the top, then extract the gene symbol column as a vector.

```{r}
signature <- limma %>% 
             dplyr::arrange(desc(t)) %>% 
             magrittr::use_series(symbol)
```

```{r}
length(signature)
head(signature)
```

```{r}
hyp_obj <- hypeR(signature, genesets, test="kstest", fdr=0.05, plotting=TRUE)
hyp_obj$plots[[1]]
```

#### Weighted Signature

In addition to providing a ranked signature, one could also add weights by including the t-statistic of the differential expression. From the differential expression dataframe, we order genes descending so upregulated genes are near the top, then extract and deframe the gene symbol and t-statistic columns as a named vector of weights.

```{r}
signature <- limma %>% 
             dplyr::arrange(desc(t)) %>% 
             dplyr::select(symbol, t) %>% 
             tibble::deframe()
```

```{r}
length(signature)
head(signature)
```

```{r}
hyp_obj <- hypeR(signature, genesets, test="kstest", fdr=0.05, plotting=TRUE)
hyp_obj$plots[[1]]
```

For permutation-based significance testing and normalized enrichment scores, please see [here](https://bioconductor.org/packages/release/bioc/html/fgsea.html).

### Downstream Analysis

#### The `hyp` Object

A `hyp` object contains all information relevant to the enrichment analysis, including the parameters used, a dataframe of results, plots for each geneset tested, as well as the arguments used to perform the analysis. All downstream functions used for analysis, visualization, and reporting recognize `hyp` objects and utilize their data. Adopting an object oriented framework brings modularity to hypeR, enabling flexible and reproducible workflows.

```{r}
print(hyp_obj)
```

All data related to enrichment arguments, parameters, and results and stored into a single `hyp` object. Saving your `hyp` objects will enable reproducible enrichment workflows.
```{r}
hyp_obj$info
```

#### The `hyp` Methods
```{r, eval=FALSE}
# Show interactive table
hyp_show(hyp_obj)

# Plot dots plot
hyp_dots(hyp_obj)

# Plot enrichment map
hyp_emap(hyp_obj)

# Plot hiearchy map (relational genesets)
hyp_hmap(hyp_obj)

# Map enrichment to an igraph object (relational genesets)
hyp_to_graph(hyp_obj)

# Save to excel
hyp_to_excel(hyp_obj)

# Save to table
hyp_to_table(hyp_obj)

# Generate markdown report
hyp_to_rmd(hyp_obj)
```

Continue to [Visualize Results](https://montilab.github.io/hypeR-docs/articles/docs/visualize.html) to see these methods in action.

---
title: "Fast Gene Set Enrichment Analysis"
vignette: >
  %\VignetteIndexEntry{Fast G}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

```{r, include=FALSE, messages=FALSE, warnings=FALSE}
knitr::opts_chunk$set(comment="", fig.align="center", fig.width=8.75, cache=FALSE)
library(tidyverse)
devtools::load_all(".")
```

## Fast Gene Set Enrichment Analysis

The primary focus of `hypeR` is on downstream enrichment analysis workflows. As long as enrichment results are formatted into a `hyp` object, they are compatible. To wrap third-party packages, we create modified version of the `hypeR()` function that calls external packages when performing the enrichment analysis, and then coerces the results into a `hyp` or `multihyp`objects. Here we wrap `fgsea` - an R-package for [fast preranked gene set enrichment analysis (GSEA)](https://www.biorxiv.org/content/10.1101/060012v3).

>`fgsea` is an R-package for fast preranked gene set enrichment analysis (GSEA). This package allows to quickly and accurately calculate arbitrarily low GSEA P-values for a collection of gene sets. P-value estimation is based on an adaptive multi-level split Monte-Carlo scheme.

```{r, messages=FALSE, warnings=FALSE}
suppressPackageStartupMessages(library(fgsea))
```

Here we can take a differential expression analysis and rank genes by their t-statstic or some other measure of differential expression between two groups.

```{r}
data(limma)

signature <- limma %>% arrange(desc(t)) %>% select(symbol, t) %>% deframe()

head(signature)
tail(signature)
```

We will also need some genesets...

```{r}
genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY", clean=TRUE)
```

#### Wrapper function

*This is an experimental feature and not officially apart of the package.*

The wrapper will take a signature and genesets as normally would be pass to `hyper()` and will instead feed them into `fgsea::fgseaMultilevel()`. Please refer to their documentation for specific parameters. This will test your preranked signature in both directions (e.g. enrichment in high and low ranking genes). The wrapper then separates each direction into and up and down signature respectively and formats them within a `hyp` object. Thus the wrapper will return a `multihyp` object.

```{r}
.handle.genesets <- function(genesets) {
    if (is(genesets, "list")) {
        gsets.obj <- gsets$new(genesets, quiet=TRUE)
    }
    else if (is(genesets, "gsets") | is(genesets, "rgsets")) {
        gsets.obj <- genesets
    } 
    else {
        stop("Genesets must be gsets/rgsets object or named list of genesets")
    }
    return(gsets.obj)
}

fgsea.wrapper <- function(signature, genesets, sample.size=101, min.size=1, max.size=Inf, ...) {
    # Save original arguments
    args <- as.list(environment())
    
    # Save gsets object
    gsets.obj <- .handle.genesets(genesets)
    args$genesets <- gsets.obj
    
    # Run fgsea
    results <- fgsea::fgseaMultilevel(stats=signature, 
                                      pathways=gsets.obj$genesets, 
                                      sampleSize=sample.size, 
                                      minSize=min.size, 
                                      maxSize=max.size, 
                                      ...)
    
    data <- results %>%
        data.frame() %>%
        plyr::rename(c("pathway"="label", "padj"="fdr", "log2err"="lte", "size"="overlap", "leadingEdge"="le")) %>%
        dplyr::rename_with(tolower) %>%
        mutate(pval=signif(pval, 2)) %>%
        mutate(fdr=signif(fdr, 2)) %>%
        mutate(le=sapply(le, function(x) paste(x, collapse=','))) %>%
        mutate(signature=length(signature)) %>%
        mutate(geneset=sapply(label, function(x) length(gsets.obj$genesets[[x]]))) %>%
        dplyr::select(c("label", "pval", "fdr", "lte", "es", "nes", "signature", "geneset", "overlap", "le"))
    
    data.up <- data %>%
        dplyr::filter(es > 0) %>%
        dplyr::arrange(pval, es)

    data.dn <- data %>%
        dplyr::filter(es < 0) %>%
        dplyr::arrange(pval, es)    

    # Reproducibility information
    info <- list(fgsea=paste("v", packageVersion("fgsea"), sep=""),
                 signature=length(signature), 
                 genesets=args$genesets$info())
    
    info <- c(info, args[c("sample.size", "min.size", "max.size")])
    info <- lapply(info, as.character)
    
    # Wrap dataframe in hyp object
    hyp.up <- hyp$new(data=data.up, args=args, info=info)
    hyp.dn <- hyp$new(data=data.dn, args=args, info=info)
    mhyp <- multihyp$new(data=list("up"=hyp.up, "dn"=hyp.dn))
    return(mhyp)
}
```

You'll likely see some warnings from `fgsea`...

```{r}
mhyp_obj <- fgsea.wrapper(signature, genesets)
print(mhyp_obj)
```

```{r}
# The hyp object of the up signature
hyp.up <- mhyp_obj$data$up
print(hyp.up$info)
```

```{r}
head(hyp.up$data[,1:6])
```

Now we can use it as we normally would...

```{r}
hyp_dots(mhyp_obj, merge=TRUE)
```

---
title: "Installation"
vignette: >
  %\VignetteIndexEntry{Installation}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

We recommend the latest version of R (\>= 4.0.0) but **hypeR** currently requires R (\>= 3.6.0) to be installed directly from Github or Bioconductor. To install with R (\>= 3.5.0) see below. Use with R (\< 3.5.0) is not recommended.

Install the development version of the package from Github.
```{r, eval=FALSE}
devtools::install_github("montilab/hypeR")
```

Or install the development version of the package from Bioconductor.
```{r, eval=FALSE}
BiocManager::install("montilab/hypeR", version="devel")
```

Or install with Conda.
```{r eval=FALSE}
conda create --name hyper
source activate hyper
conda install -c r r-devtools
R
library(devtools)
devtools::install_github("montilab/hypeR")
```

Or install with previous versions of R.
```{r eval=FALSE}
git clone https://github.com/montilab/hypeR
nano hypeR/DESCRIPTION
# Change Line 8
# Depends: R (>= 3.6.0) -> Depends: R (>= 3.5.0)
R
install.packages("path/to/hypeR", repos=NULL, type="source")
```

Load the package into an R session.
```{r, eval=FALSE}
library(hypeR)
```

---
title: "Multiple Signatures"
vignette: >
  %\VignetteIndexEntry{Multiple Signatures}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include=FALSE, messages=FALSE, warnings=FALSE}
knitr::opts_chunk$set(comment="", fig.align="center", fig.width=8.75, cache=FALSE)
devtools::load_all(".")
```

Often computational biologists must process, interpret, and share large amounts of biological data. A common example is interpreting gene co-expression modules across one or more phenotype, resulting in potentially hundreds of signatures to annotate. Here we have signatures of gene co-expression modules, generated with WGCNA, for two distinct phenotypes. In this case, we can feed `hypeR()` a named list of signatures and a `multihyp` object will be returned. This object is essentially just multiple `hyp` objects. However it is recognized and handled differently by downstream methods.

```{r}
data(wgcna)
```

We start by annotating signatures for the first phenotype..

```{r}
signatures <- wgcna[[1]]
str(signatures)
```

The signatures will be processed together...

```{r, message=FALSE, warning=FALSE, results='hide'}
genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY", clean=TRUE)

mhyp <- hypeR(signatures, genesets, test="hypergeometric", background=50000, fdr=0.05)
```

### A `multihyp` Object

```{r}
print(mhyp)
```

A `multihyp` object can be passed to any downstream method, with some altered behavior.

#### Altered Methods

With `hyp_to_excel` each signature is exported to its own sheet...

```{r, eval=FALSE}
hyp_to_excel(mhyp, file_path="hypeR.xlsx")
```

With `hyp_to_table` each signature is exported as its own table in a single directory...

```{r, eval=FALSE}
hyp_to_table(mhyp, file_path="hypeR")
```

With `hyp_to_rmd` each signature is displayed under its own tab...

```{r, eval=FALSE}
hyp_to_rmd(lmultihyp_obj, file_path="hypeR.rmd",
```

With `hyp_dots()`, `hyp_emap()`, and `hyp_hmap()` each signatures is plotted and returned separately...

```{r}
p <- hyp_dots(mhyp)
```

```{r, fig.height=5}
p[1:3]
```

Alternatively `hyp_dots(merge=TRUE)` can combine mulitple signatures into a single plot...

```{r}
hyp_dots(mhyp, merge=TRUE)
```

---
title: "Hierarchical Genesets"
vignette: >
  %\VignetteIndexEntry{Hierarchical Genesets}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

```{r, include=FALSE, messages=FALSE, warnings=FALSE}
knitr::opts_chunk$set(comment="", fig.align="center", fig.width=8.75, cache=FALSE)
library(tidyverse)
devtools::load_all(".")
```

## Relational Genesets
When dealing with hundreds of genesets, it's often useful to understand the relationships between them. This allows researchers to summarize many enriched pathways as more general biological processes. To do this, we rely on curated relationships defined between them. For example, [Reactome](https://reactome.org/) conveniently defines their genesets in a [hiearchy of pathways](https://reactome.org/PathwayBrowser/). This data can be formatted into a relational genesets object called `rgsets`. 

```{r}
genesets <- hyperdb_rgsets("REACTOME", version="70.0")
```

Relational genesets have three data atrributes including gsets, nodes, and edges. The `genesets` attribute includes the geneset information for the leaf nodes of the hiearchy, the `nodes` attribute describes all nodes in the hierarchy, including internal nodes, and the `edges` attribute describes the edges in the hiearchy.

```{r}
print(genesets)
```

Passing relational genesets works natively with `hypeR()`.

```{r}
data(limma)

signature <- limma %>% 
             dplyr::arrange(desc(t)) %>% 
             magrittr::use_series(symbol)

hyp_obj <- hypeR(signature, genesets, test="kstest", fdr=0.01)
```

## Interactive Visualization

One can visualize the top enriched genesets using `hyp_hmap()` which will return a hierarchy map. Each node represents a geneset, where the shade of the gold border indicates the normalized significance of enrichment. Hover over the leaf nodes to view the raw value. Double click internal nodes to cluster their first degree connections. Edges represent a directed relationship between genesets in the hiearchy. Note: This function only works when the `hyp` object was initialized with an `rgsets` object.

```{r, fig.height=7}
vn <- hyp_hmap(hyp_obj, top=30)
vn
```

Save to an html file.

```{r, eval=FALSE}
vn <- visNetwork::visOptions(vn, width="1280px", height="720px")
visNetwork::visSave(vn, "hyp_obj.html”)
```

## Static Visualization

One of the downsides of the above interactive object is it's difficult to render high quality figures in specific formats. You could take a screenshot after interacting with the figure, however that might not be high enough resolution for a publication. To help with this, you can alternatively return an `igraph` object pre-formatted with enrichment data.

```{r}
ig <- hyp_hmap(hyp_obj, top=30, graph=TRUE)
print(ig)
```

Colors, weights, and normalized sizing properties from the interactive visualization are copied over to the vertex properties of the `igraph` object.

```{r}
head(igraph::as_data_frame(ig, what="vertices"))[,c("name", "type", "fdr", "size", "color")]
```

Because genesets labels are typically long, it's static visualizations are difficult. You'll need to make custom adjustments depending on your needs.

```{r, fig.width=12, fig.height=10}
# Consistent layout
set.seed(1)

# Overriding existing edge/vertex properties
plot(ig,
     vertex.label=substr(ifelse(V(ig)$type == "leaf", V(ig)$label, ""), 1, 32), 
     vertex.size=5)
```

#### High quality rendering

```{r, eval=FALSE}
set.seed(1)
tiff("hyp_obj.tiff", units="in", width=8, height=8, res=300)
plot(ig)
dev.off()
```

## Raw Graph Objects

You can also directly copy enrichment data from a `hyp` object to an `igraph` object.

```{r}
ig <- hyp_to_graph(hyp_obj)
print(ig)
df.v <- ig %>%
        igraph::as_data_frame(what="vertices") %>%
        dplyr::arrange(fdr)

head(df.v)
```

Notice that internal nodes that don't have associated genesets (just generalized labels) will not have enrichment data associated with them.

```{r}
tail(df.v)
```

## Data Driven Hierarchies

*This is an experimental feature and not officially apart of the package.*

Genesets are often redundant, hard to parse, and lack relational structure. Thus it can be useful to infer which genesets are similar before analyzing enrichment results to help group multiple enriched genesets or pathways into more generalizable processes. Here we show a data-driven method using [Hierarchical Set](https://academic.oup.com/bioinformatics/article/33/11/1604/2959905) for turning flat genesets into `rgsets` objects.

#### Explanation from hierarchical sets

> The clustering, in contrast to more traditional approaches to hierarchical clustering, does not rely on a derived distance measure between the sets, but instead works directly with the set data itself using set algebra. This has two results: First, it is much easier to reason about the result in a set context, and second, you are not forced to provide a distance if none exists (sets are completely independent). The clustering is based on a generalization of Jaccard similarity, called Set Family Homogeneity, that, in its simplest form, is defined as the size of the intersection of the sets in the family divided by the size of the union of the sets in the family. The clustering progresses by iteratively merging the set families that shows the highest set family homogeneity and is terminated once all remaining set family pairs have a homogeneity of 0. Note that this means that the clustering does not necessarily end with the all sets in one overall cluster, but possibly split into several hierarchies - this is intentional.

#### Flat genests

What if we want to use the KEGG genesets from MSigDB - but we want to organize them into a hierarchy?

```{r}
gsets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY", clean=TRUE)
genesets <- gsets$genesets
length(genesets)
```

#### Clustering

We need some additional packages to help with this...

```{r, messages=FALSE, warnings=FALSE}
suppressPackageStartupMessages(library(hierarchicalSets))
suppressPackageStartupMessages(library(qdapTools))
```

```{r}
mat <- genesets %>%
    qdapTools::mtabulate() %>%
    as.matrix() %>%
    t() %>%
    hierarchicalSets::format_sets()

hierarchy <- hierarchicalSets::create_hierarchy(mat, intersectLimit=1)
print(hierarchy)
```

```{r, fig.width=12, fig.height=10}
plot(hierarchy, type='intersectStack', showHierarchy=TRUE, label=FALSE)
```

There is clearly a lot of overlap between these genesets...

```{r}
plot(hierarchy, type='outlyingElements', quantiles=0.75, alpha=0.5, label=FALSE)
```

#### Extracting the hierarchy

```{r, messages=FALSE, warnings=FALSE}
suppressPackageStartupMessages(library(dendextend))
suppressPackageStartupMessages(library(stringi))
```

A helper function for recursively reading and extracting trees from the clustering structure.

```{r}
find.trees <- function(d) {
    subtrees <- dendextend::partition_leaves(d)
    leaves <- subtrees[[1]]
    find.paths <- function(leaf) {
        which(sapply(subtrees, function(x) leaf %in% x))
    }
    paths <- lapply(leaves, find.paths)
    edges <- data.frame(from=c(), to=c())
    if (length(d) > 1) {
        for (path in paths) {
            for (i in seq(1, length(path)-1)) {
                edges <- rbind(edges, data.frame(from=path[i], to=path[i+1]))
            }
        }
        edges <- dplyr::distinct(edges)
        edges$from <- paste0("N", edges$from)
        edges$to <- paste0("N", edges$to)
    }
    names(subtrees) <- paste0("N", seq(1:length(subtrees)))
    nodes <- data.frame(id=names(subtrees))
    rownames(nodes) <- nodes$id
    nodes$label <- ""
    leaves <- sapply(subtrees, function(x) length(x) == 1)
    nodes$label[leaves] <- sapply(subtrees[leaves], function(x) x[[1]])
    nodes$id <- NULL
    
    # Internal nodes will not have labels, so we can generate unique hash identifiers
    ids <- stringi::stri_rand_strings(nrow(nodes), 32)
    names(ids) <- rownames(nodes)
    rownames(nodes) <- ids[rownames(nodes)]
    edges$from <- ids[edges$from]
    edges$to <- ids[edges$to]
    
    return(list("edges"=edges, "nodes"=nodes))
}
```

```{r}
trees <- lapply(hierarchy$clusters, find.trees)
length(trees)
```

Now we can merge the independent trees into a single graph...

#### Nodes
```{r}
nodes.all <- lapply(trees, function(x) x$nodes)
nodes <- do.call(rbind, nodes.all)
head(nodes)
```

#### Edges
```{r}
edges.all <- lapply(trees, function(x) x$edges)
edges <- data.frame(do.call(rbind, edges.all))
head(edges)
```

Create the relational genesets object...

```{r}
rgsets_obj <- rgsets$new(genesets, nodes, edges, name="MSIGDB_KEGG", version=msigdb_version())
rgsets_obj
```

```{r}
hyp <- hypeR(signature, rgsets_obj, test="kstest")
hyp_dots(hyp, fdr=0.1, top=25)
```

```{r}
hyp_hmap(hyp, fdr=0.1)
```

---
title: "Visualize Results"
vignette: >
  %\VignetteIndexEntry{Visualize Results}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

```{r, include=FALSE, messages=FALSE, warnings=FALSE}
knitr::opts_chunk$set(comment="", fig.align="center", fig.width=8.75, cache=FALSE)
library(tidyverse)
devtools::load_all(".")
```

### Example Data
The example data includes a pre-computed differential expression dataframe from limma. From the differential expression dataframe, we order genes descending so upregulated genes are near the top, then extract the gene symbol column as a vector. 

```{r}
data(limma)

signature <- limma %>% 
             dplyr::arrange(desc(t)) %>% 
             magrittr::use_series(symbol)

head(signature)
```

```{r}
genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:REACTOME", clean=TRUE)

hyp_obj <- hypeR(signature, genesets, test="kstest", fdr=0.01)
```

To visualize the results, just pass the `hyp` object to any downstream functions.

# Dots Plot

One can visualize the top enriched genesets using `hyp_dots()` which returns a horizontal dots plot. Each dot is a geneset, where the color represents the significance and the size signifies the geneset size.

```{r, fig.height=5}
hyp_dots(hyp_obj)
```

# Enrichment Map

One can visualize the top enriched genesets using `hyp_emap()` which will return an enrichment map. Each node represents a geneset, where the shade of red indicates the normalized significance of enrichment. Hover over the node to view the raw value. Edges represent geneset similarity, calculated by either jaccard or overlap similarity metrics.

```{r, fig.height=7}
hyp_emap(hyp_obj, similarity_cutoff=0.70)
```

# Hiearchy Map

When dealing with hundreds of genesets, it's often useful to understand the relationships between them. This allows researchers to summarize many enriched pathways as more general biological processes. To do this, we rely on curated relationships defined between them.

### Relational Genesets

For example, [Reactome](https://reactome.org/) conveniently defines their genesets in a [hiearchy of pathways](https://reactome.org/PathwayBrowser/). This data can be formatted into a relational genesets object called `rgsets`. 

```{r}
genesets <- hyperdb_rgsets("REACTOME", version="70.0")
```

Relational genesets have three data atrributes including gsets, nodes, and edges. The `genesets` attribute includes the geneset information for the leaf nodes of the hiearchy, the `nodes` attribute describes all nodes in the hierarchy, including internal nodes, and the `edges` attribute describes the edges in the hiearchy.

```{r}
print(genesets)
```

Passing relational genesets works natively with `hypeR()`.

```{r}
hyp_obj <- hypeR(signature, genesets, test="kstest", fdr=0.01)
```

One can visualize the top enriched genesets using `hyp_hmap()` which will return a hierarchy map. Each node represents a geneset, where the shade of the gold border indicates the normalized significance of enrichment. Hover over the leaf nodes to view the raw value. Double click internal nodes to cluster their first degree connections. Edges represent a directed relationship between genesets in the hiearchy. Note: This function only works when the `hyp` object was initialized with an `rgsets` object.

```{r, fig.height=7}
hyp_hmap(hyp_obj, top=30)
```

---
title: "Generating Reports"
vignette: >
  %\VignetteIndexEntry{Generating Reports}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

```{r, include=FALSE, messages=FALSE, warnings=FALSE}
knitr::opts_chunk$set(comment="", fig.align="center", fig.width=8.75, cache=FALSE)
devtools::load_all(".")
```

Often researchers need to annotate multiple signatures across multiple experiments. Typically, the best way to manage this data is to process it all at once and generate a markdown report to analyze and share with collaborators. Let's take an example where we have one experiment with many signatures.

```{r}
data(wgcna)

signatures <- wgcna[[1]]
str(signatures)
```

```{r, message=FALSE, warning=FALSE, results='hide'}
genesets <- hyperdb_rgsets("KEGG", "92.0")
mhyp <- hypeR(signatures, genesets, test="hypergeometric", background=36000, fdr=0.05)
```

We have included some convenient functions that return some html for turning `hyp` and `mhyp` objects into concise tables for markdown documents. These tables can also include some plots for each individual `hyp` object.
```{r}
rctbl_build(mhyp, show_hmaps=TRUE)
```

Alright, how about we process all of these nested signatures and provide an example of what your markdown report might look like. Because we have a nested list of signatures, we use `hyper()` with the `lapply` function. This results in a list of `mhyp` objects.

```{r, message=FALSE, warning=FALSE, results='hide'}
lmhyp <- lapply(wgcna, hypeR, genesets, test="hypergeometric", background=36000, fdr=0.05)
```

First start with a nice theme and include the css required to make the tables pretty.

```r
title: "Project Title"
subtitle: "Project Subtitle"
author: "Anthony Federico"
date: "Last Modified: 'r Sys.Date()'"
output:
  html_document:
    theme: flatly
    toc: true
    toc_float: false
    code_folding: hide
    toc_depth: 4
    css: 'r system.file("style", "rctbl.css", package="hypeR")'
```


### LA

```{r}
hyp_dots(lmhyp$LA, merge=TRUE)
rctbl_build(lmhyp$LA, show_hmaps=TRUE)
```

### LB
```{r}
hyp_dots(lmhyp$LB, merge=TRUE)
rctbl_build(lmhyp$LB, show_hmaps=TRUE)
```

### H2
```{r}
hyp_dots(lmhyp$H2, merge=TRUE)
rctbl_build(lmhyp$H2, show_hmaps=TRUE)
```

### BL
```{r}
hyp_dots(lmhyp$BL, merge=TRUE)
rctbl_build(lmhyp$BL, show_hmaps=TRUE)
```

If you're only looking at one signature you can format it with a dropdown table.

```{r}
hyp <- hypeR(signatures[[1]], genesets, test="hypergeometric", background=36000, fdr=0.05)

rctbl_build(hyp)
```

### Generating Markdown Reports

For quick report generation one can use `hyp_to_rmd()` which will accept multiple formats, including a single `hyp` or `multihyp` object as well as a list of either, including a list of `hyp` or `multihyp` objects together. When a list of `multihyp` objects are passed for example, each experiment will become its own section, while each signature becomes its own tab within that section. Lists of keyword arguments can be passed for `hyp_dots()`, `hyp_emap()`, and `hyp_hmap()`, allowing customization of their functionality per report. See `hyp_to_rmd()` for details.

```{r, eval=FALSE}
hyp_to_rmd(lmultihyp_obj,
           file_path="hypeR.rmd",
           title="hypeR Report",
           subtitle="Weighted Gene Co-expression Analysis",
           author="Anthony Federico, Stefano Monti",
           show_dots=T,
           show_emaps=T,
           show_hmaps=T,
           show_tables=T)
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_enrichr.R
\name{enrichr_gsets}
\alias{enrichr_gsets}
\title{Download data from enrichr in the form of a gsets object}
\usage{
enrichr_gsets(
  genesets,
  db = c("Enrichr", "YeastEnrichr", "FlyEnrichr", "WormEnrichr", "FishEnrichr"),
  clean = FALSE
)
}
\arguments{
\item{genesets}{A name corresponding to available genesets}

\item{db}{A species}

\item{clean}{Use true to clean labels of genesets}
}
\value{
A gsets object
}
\description{
Download data from enrichr in the form of a gsets object
}
\examples{
ATLAS <- enrichr_gsets("Human_Gene_Atlas")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reactable.R
\name{rctbl_build}
\alias{rctbl_build}
\title{Reactable builder for hyp or mhyp objects}
\usage{
rctbl_build(obj, ...)
}
\arguments{
\item{obj}{A hyp or multihyp object}

\item{...}{Arguments passed to table generators}
}
\description{
Reactable builder for hyp or mhyp objects
}
\examples{
genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")$genesets[1:5]

experiment <- list("S1"=c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502"),
                   "S2"=c("PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC"))

mhyp_obj <- hypeR(experiment, genesets, background=2522)

rctbl_build(mhyp_obj)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_hyper.R
\name{hyperdb_available}
\alias{hyperdb_available}
\title{Check available data to download from hyperdb}
\usage{
hyperdb_available()
}
\description{
Check available data to download from hyperdb
}
\examples{
hyperdb_available()

}

=pod

=head1 NAME

Hyper::Manual - Manual for the Hyper Framework

=head1 SECTIONS

 L<Manual::Control::Setup|Manual::Control::Setup> - how to create new controls

=head1 AUTHOR

Martin Kutter <kutterma@users.sourceforge.net>

=head1 COPYING

=head1 Repository information

 $ID: $

 $LastChangedDate: $
 $LastChangedRevision: $
 $LastChangedBy: $

 $HeadURL: $

=cut

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_enrichr.R
\name{enrichr_available}
\alias{enrichr_available}
\title{Get enrichr available genesets}
\usage{
enrichr_available(
  db = c("Enrichr", "YeastEnrichr", "FlyEnrichr", "WormEnrichr", "FishEnrichr")
)
}
\arguments{
\item{db}{A species}
}
\value{
A dataframe of available genesets
}
\description{
Get enrichr available genesets
}
\examples{
enrichr_available()

}

=pod

=head1 NAME

Hyper::Manual::Control::Setup - How to create new controls

=head1 DESCRIPTION

To create a new control element, for a service usecase, the following files
are required:

=over

=item * etc/Hyper/Control/Container/$service/$usecase.ini

Defines the components and steps a control consists of.
See L<usecase.ini|usecase.ini>.

=item * var/Hyper/Control/Container/$service/usecase.htm

Template for displaying the usecase. See <template.htm|template.htm>

=item * var/Hyper/Control/Container/$service/labels.ini

Labels configuration file for the service. See <labels.ini|labels.ini>

=back

After creating these files, classes are generated by a
Hyper::Generator::Control::Container run.

You may also use L<generate-control.pl|generate-control.pl> to create the
control classes.

=head1 FILES

=head2 usecase.ini

usecase.ini is the control container definition file. It consists of the
following sections:

=head3 [global]

Global settings.

Valid keys are:

=over

=item * attributes

Multi-Value field. All values specified will be included as object attributes
in the control container. get_$name and set_$name methods will be generated,
too.

=back

=head3 [Control]

Define the controls for this container here. To define a control, add
a [Control Name] subsection. Controls may have the following attributes:

=over

=item * class

The implementation class of the control with Hyper::Control stripped of in
. notation.

Examples:

 Primitive.PAccountSelect  (expands to Hyper::Control::Primitive::PAccountSelect)
 Base.BCheckBox            (expands to Hyper::Control::Base::BCheckBox)

=item * template

Template to use (if any).

=item * validators

Validators to use (if any).

=item * group_validators

Group validators to use. Group validators are used for validating groups
of fields - like name and given name for a "full name" control container.

Group validators return OK if, and only if, all single validators grouped
together into a group validator return OK.

Group validators return all error messages of all single validators grouped
together (if any).

When validating groups of fields, group validators are recommended for
usability.

=back

Example:

 [Control cSelectURAAccount]
 class=Base.BSelectList
 template=SelectAccount.htc

=head3 [Step]

Define the steps for the container here.

For every Step, place a [Step Name] section here.

Steps may include the following attributes:

=over

=item * controls

A list of controls. Only controls defined in the same file may be used here.

=item * action

Actions to perform for this control. For the grammar of action definitions,
see L<Hyper::Generator::Control::ContainerFlow>

=item * params

=back

For transitions, place a [Step Name Next_Name] subsection here.

=head2 template.htm

=head2 labels.ini

labels.ini is a UNIX-Style ini file defining the label namespaces used
in the service's templates.

It contains a section C<[global]> for namespaces required in all service
templates.

For every usecase template, a section named like the template (without
suffix) may be specified.

In all sections, namespaces may be specified by the key C<namespace>.
C<namespace> is a multi-value field, so you may set more than one namespace
by heredocs.

 ; global settings for all templates in this directory
 ; namespace: label namespace
 [global]
 namespace=GlobalData

 ; global setting may be overridden on a per-file base.
 ;[CSelectPerson]
 ;namespace=<<EON
 ;GlobalData
 ;SpecialNamespace
 ;EON

=head1 AUTHOR

 Martin Kutter <kutterma@users.sourceforge.net>

=head1 COPYING


=head1 Repository information

 $ID: $

 $LastChangedDate: $
 $LastChangedRevision: $
 $LastChangedBy: $

 $HeadURL: $

=cut

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.string_args}
\alias{.string_args}
\title{Convert an arguments list to string format}
\usage{
.string_args(args)
}
\arguments{
\item{args}{A list of keyword arguments}
}
\value{
A string of keyword arguments
}
\description{
Convert an arguments list to string format
}
\examples{
\dontrun{
string_args(list(x=15, y="fdr", z=TRUE))
}

}
\keyword{internal}

=pod

=head1 NAME

Hyper::Manual::Templates - all you want to know about templates

=head1 The basics

The Hyper Framework can use different Template parsers / Content generators.
The templated parser is configured via Hyper::Singleton::Context's
set_template_class method somewhere in your application:

 Hyper::Singleton::Context->singleton
    ->set_template_class('Hyper::Template');

That is the default, so usually you do not need to care about it.

=head1 Hyper::Template

Hyper::Template is based on HTML::Template::Compiled, too, but adds
the Hyper::HTC::Plugin::Text plugin. This plugin introduces a new template tag,
TEXT, which is used for inserting translated texts.

Translation is performed via the currently configured Translation object,
which is set via Hyper::Singleton::Context.

=head2 Using the TEXT tag

Imagine you got the following labels in your label translator:

 test1 => q{There's something rotten},
 test2 => q{Your [_1] has [*_2,handbrake,handbrakes,no handbrake]},
 test3 => q{

 * [*,_1,apple,apples,no apple]
 * [*,_2,bananas,bananas,not even one banana]

 }

As you may gess from the label contents, test2 uses maketext while test3
combines maketext with textile formatting.

Now imagine a template:

 <%TEXT VALUE="test1" %>
 <%TEXT brakes VALUE="test2" %>
 <%TEXT fruits VALUE="test3" %>

Now we set parameters on the template, say:

 $htc->params( brakes => [ 2 ], fruits => [1,0] );

and process the template with

 $htc->output();

It will be transformed into

 There's something rotten
 Your bike has 2 handbrakes
 <ul>
 <li>1 apple</li>
 <li>not even one banana</li>
 </ul>

Got it?

To be honest, in the Hyper Framework you usually don't have to pass parameters
to the template or call it's output method - the framework does it for you.

=head1 AUTHOR

 Martin Kutter <kutterma@users.sourceforge.net>

=head1 COPYING



=head1 Repository information

 $ID: $

 $LastChangedDate: $
 $LastChangedRevision: $
 $LastChangedBy: $

 $HeadURL: $

=cut

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_hyper.R
\name{hyperdb_gsets}
\alias{hyperdb_gsets}
\title{Download data from hyperdb}
\usage{
hyperdb_gsets(source, gsets)
}
\arguments{
\item{source}{A source identifier}

\item{gsets}{A genesets identifier}
}
\value{
A list
}
\description{
Download data from hyperdb
}
\examples{
KEGG <- hyperdb_gsets("KEGG", "KEGG_v92.0.rds")

}

=head1 NAME

Hyper::Manual::Usecase::Howto - how to implement a usecase with the Hyper Framework

=head1 STEPS

=head2 Create etc/Hyper/Control/Flow/FUsecase.ini

=over

=item * Generate the interface for this usecase

 generate-interface.pl -s Service -u Usecase

This script will make a module like

 lib/Hyper/Interface/$Service/I$Usecase.pm

See the embedded pod of this file for a list of available interface methods.

=item * Write down all steps from use case design as [Step $NAME] sections

Transitions are written as

 [Step $NAME $NEXT_NAME]
 condition=...

The condition is optional.

=item * Write down all required controls for the steps as [Control $NAME]

You may need new controls - in this case you have to create
them.

See <Hyper::Manual::Control::Howto>

=back

=head2 Run generate-flow.pl on your usecase

=cut

=pod

=head1 NAME

Hyper::HowTo::Flow_Control -  How to create Flow Controls

=head1 VERSION

This document describes Hyper::Control::Flow 0.01

=head1 DESCRIPTION

This document describes the development of a flow control.

=head1 CONFIGURATION FILES

The ini style configuration files are stored within the following structure:

 $APP_ROOT/etc/Hyper/Control/Flow/$SERVICE/$USECASE.ini

=head1 CONFIG FILE SYNTAX

The config file syntax is UNIX-Style .ini-Files. They are a bit different 
from Windows-style .ini files - the most notable difference is 
heredoc-support:

 attribute=<<EOT
 first_value
 second_value
 third_value
 EOT 

The config file is split into several sections. 

Sections are:

=over 

=item * global

Global configuration data

=item * Control

embedded controls

=item * Step

the steps for this flow.

=back

=head2 Config file sections

=head3 [global]

Global configuration data goes here. 

The attributes allowed in [global] are described below.

=over

=item attributes

Attributes for this Control. Multiple attributes can be specified using the 
heredoc syntax.

=back

Example:

 [global]
 attributes=<<EOT
 $ATTRIBUTE_NAME_1
 $ATTRIBUTE_NAME_2
 EOT

=head3 [Control] - embedded controls

You can embed Flow, Container and Primitive controls. Each embedded control 
needs a unique name and a class.

Controls are all subsections of the section [Control]:

 [Control]
 [Control $NAME]

Controls have the following attributes: 

=over

=item class :MANDATORY

Class of the embedded control. Perl class name with all '::' replaced by '.' 
and without the leading Hyper namespace

Example: 

 [Control cSampleControl]
 ; use Hyper::Control::Container::CSample as Perl class
 class=Control.Container.CSample
 
=item template :OPTIONAL

Available for Container, Base and Primitive Controls. Template used for 
rendering a control. You may either specify a path relative to base_path
or an absolute path.

=back

Foll example:

 [Control]
 [Control cExampleControl]
 class=ControlType.myService.myUsecase
 template=/path/to/template

=head3 [Step] - workflow steps

A workflow consist of a number of steps. Steps may have actions (code) to be 
executed and controls to be displayed. 

Steps are connected via transitions which may have conditions to be met.

All steps are subsections of the section [Step]:

 [Step]
 [Step myStep]

Steps may have the following attributes:

=over

=item action :OPTIONAL

Actions are executed before your own code is executed. 
In actions, you may assign data to embedded controls by reading out other 
controls' data or calling their methods.

Multiple actions can be specified using the heredoc syntax.
Each action must be terminated by ';'.

Elements of the action syntax are described below.

=over

=item * this

The special control "this" refers to an instance of the current object itself:

 this.mAccount=cAccount.value();

This corresponds to $self used as a convention in perl classes.  

=item * Constants

Numbers without any quotes or text with embraced by ' or ".

 this.mNumericConstant=23;
 this.mStringConstant="Hello World"

=item * Variables / Attributes

Variables can be nested with a '.' as seperator. Each variable must begin 
with a char A-Z, a-z as first sign. All other chars of the variable
name can be A-Z, a-z, _ and 0-9.

 this.mNumericConstant=this.someVariable;
 this.mStringConstant=cControl.anotherVariable2;

=item * Methods

Each method name must begin with a char A-Z, a-z as first sign. All other 
chars of the variable name can be A-Z, a-z, _ and 0-9.

Methods can also be called on nested variables if the variable has this 
method.

=back

Examples:

 ; assignment
 action=<<EOT
 this.mTextAttribute="This is a Constant";
 this.mAnotherText='Another Constant';
 this.mNumber=1234;
 cEmbeddedContainer.mValue=cAnotherContainer.mTest;
 EOT

 ; method call
 action=<<EOT
 this.callMe();
 cEmbeddedContainer.mValue=cAnotherContainer.test();
 EOT

=back

=head3 [Step source destination] - transitions from one step to another

Each Step may have multiple transitions to other steps.

Transitions are written as sub-sections of the source step with the name of 
the destination step:

 [Step SourceStep DestinationStep]

Transitions may only be performed when a condition is met. If no condition 
is specified, the transition will be performed automatically.

Transitions may have the following attributes:

=over

=item condition :OPTIONAL

You may use constants, variables, and method calls in conditions 
(see actions for more information). You can't make assignments but you 
may use the following logical operators.

 Operator       Description
 ------------------------------------
 !              Logical not
 not            Not operator
 ==             Numeric equal
 !=             Numeric uneuqal
 eq             String equal
 ne             String unequal
 &&             Logical and
 ||             Logical or
 and            And operator
 or             or operator

Operator precendence is equal to perl - see L<perlop> for details.

Examples:

 [Step One altTwo]
 condition=this.is_valid();

 [Step One altTwo]
 condition=this.is_valid() && cControl.something.is_valid();

=back

=head2 CODE GENERATION

use generate-flow.pl to generate a perl class for yout flow control with 
a shadow class and a basic template.

 $APP_ROOT/bin/generate-flow.pl -s $SERVICE -U $USECASE

The following files will be generated:

if not existant:

 $APP_ROOT/lib/Hyper/Control/Flow/$SERVICE/F$USECASE.pm
 $APP_ROOT/var/Hyper/Control/Flow/$SERVICE/$USECASE.htc

always (previous files will be overwritten):

 $APP_ROOT/lib/Hyper/Control/Flow/$SERVICE/_F$USECASE.pm

=head2 YOUR CODE

Each Step will call a method named action_$STEP_NAME if existant. 

This methods may gather data from interfaces, perform interface calls etc.

You should place your code and template into 

 $APP_ROOT/lib/Hyper/Control/Flow/$SERVICE/F$USECASE.pm
 $APP_ROOT/var/Hyper/Control/Flow/$SERVICE/$USECASE.htc

=head1 RCS INFORMATIONS

=over

=item ID

$Id$

=item Revision

Revision $Revision$, $HeadURL$, $Date$

=back

=head1 AUTHOR

 Andreas Specht  C<< <ACID@cpan.org> >>

=head1 LICENSE AND COPYRIGHT

Copyright (c) 2007, Andreas Specht C<< <ACID@cpan.org> >>. All rights reserved.

This file is part of Hyper.

This file is free software - you may distribute/modify it under the same 
terms as perl itself. 

=cut

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggempty.R
\name{ggempty}
\alias{ggempty}
\title{An empty ggplot}
\usage{
ggempty()
}
\value{
A ggplot object
}
\description{
An empty ggplot
}

=head1 NAME

Hyper::Manual::Overwiew

=head1 DESCRIPTION

The Hyper Framework consist of two main parts:

=over

=item * A runtime environment for (generated) Control elements

=item * A template-driven Code Generator

=back

There are two main groups of control elements: 

=over 

=item * Control Container elements

Control containers are basically complex widgets made up of simple (or other 
complex) widgets.

=item * Control Flow elements

Control Flow elements model the workflow for a specific usecase. Control flow 
elements combine a number of B<Steps> displaying simple or complex Controls 
with a number of transitions.

=back

=cut   

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shiny_modules.R
\name{genesets_UI}
\alias{genesets_UI}
\title{Shiny interface module for geneset selection}
\usage{
genesets_UI(id)
}
\arguments{
\item{id}{A unique namespace identifier}
}
\value{
Shiny ui elements
}
\description{
Shiny interface module for geneset selection
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hyp_to_table.R
\name{hyp_to_table}
\alias{hyp_to_table}
\title{Export hyp/multihyp object to table}
\usage{
hyp_to_table(hyp_obj, file_path, sep = "\\t", cols = NULL, versioning = TRUE)
}
\arguments{
\item{hyp_obj}{A hyp or multihyp object}

\item{file_path}{A file path for hyp objects and directory for multihyp objects}

\item{sep}{The field separator string}

\item{cols}{Dataframe columns to include}

\item{versioning}{Add header with versioning information}
}
\description{
Export hyp/multihyp object to table
}
\examples{
genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")

signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
               "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
               "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")

hyp_obj <- hypeR(signature, genesets, background=2522)

hyp_to_table(hyp_obj, file_path="pathways.txt")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.reverselog_trans}
\alias{.reverselog_trans}
\title{Custom reverse log transformation of continous ggplot axes}
\usage{
.reverselog_trans(base = exp(1))
}
\arguments{
\item{base}{Logarithm base}
}
\description{
Custom reverse log transformation of continous ggplot axes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggeplot.R
\name{ggeplot}
\alias{ggeplot}
\title{Enrichment plot implemented in ggplot}
\usage{
ggeplot(n, positions, x_axis, y_axis, title = "")
}
\arguments{
\item{n}{The length of a ranked list}

\item{positions}{A vector of positions in the ranked list}

\item{x_axis}{The x-axis of a running enrichment score}

\item{y_axis}{The y-axis of a running enrichment score}

\item{title}{Plot title}
}
\value{
A ggplot object
}
\description{
Enrichment plot implemented in ggplot
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.overlap_similarity}
\alias{.overlap_similarity}
\title{Calculate overlap similarity of two sets}
\usage{
.overlap_similarity(a, b)
}
\arguments{
\item{a}{A vector}

\item{b}{A vector}
}
\value{
A numerical value
}
\description{
Calculate overlap similarity of two sets
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reactable.R
\name{rctbl_hyp}
\alias{rctbl_hyp}
\title{Reactable table for hyp objects}
\usage{
rctbl_hyp(
  hyp,
  type = c("inner", "outer"),
  show_emaps = FALSE,
  show_hmaps = FALSE,
  hyp_emap_args = list(top = 25, val = "fdr"),
  hyp_hmap_args = list(top = 25, val = "fdr")
)
}
\arguments{
\item{hyp}{A hyp object}

\item{type}{Use style class for outer or inner tables}

\item{show_emaps}{Option to show enrichment maps in tabs}

\item{show_hmaps}{Option to show hiearchy maps in tabs}

\item{hyp_emap_args}{A list of keyword arguments passed to hyp_emap}

\item{hyp_hmap_args}{A list of keyword arguments passed to hyp_hmap}
}
\description{
Reactable table for hyp objects
}
\examples{
genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")$genesets[1:5]

signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
              "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
              "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")

hyp_obj <- hypeR(signature, genesets, background=2522)

rctbl_hyp(hyp_obj)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_msig.R
\name{msigdb_available}
\alias{msigdb_available}
\title{Get msigdbr available genesets}
\usage{
msigdb_available(species = "Homo sapiens")
}
\arguments{
\item{species}{A species to determine gene symbols (refer to ?msigdbr::msigdbr for available species)}
}
\value{
A dataframe of available genesets
}
\description{
Get msigdbr available genesets
}
\examples{
msigdb_available("Homo sapiens")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_msig.R
\name{msigdb_info}
\alias{msigdb_info}
\title{Print msigdb gsets information}
\usage{
msigdb_info()
}
\description{
Print msigdb gsets information
}
\examples{
msigdb_info()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{clean_genesets}
\alias{clean_genesets}
\title{Clean labels of genesets}
\usage{
clean_genesets(x)
}
\arguments{
\item{x}{A vector of labels}
}
\description{
Clean labels of genesets
}
\examples{
HALLMARK <- msigdb_download("Homo sapiens", "H")
names(HALLMARK) <- clean_genesets(names(HALLMARK))
head(names(HALLMARK))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_msig.R
\name{msigdb_version}
\alias{msigdb_version}
\title{Get msigdbr package version number}
\usage{
msigdb_version()
}
\value{
Version number
}
\description{
Get msigdbr package version number
}
\examples{
msigdb_version()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hype.R
\name{hypeR}
\alias{hypeR}
\title{Calculate enrichment of one or more signatures}
\usage{
hypeR(
  signature,
  genesets,
  test = c("hypergeometric", "kstest"),
  background = 23467,
  power = 1,
  absolute = FALSE,
  pval = 1,
  fdr = 1,
  plotting = FALSE,
  quiet = TRUE
)
}
\arguments{
\item{signature}{A vector of symbols}

\item{genesets}{A gsets/rgsets object or a named list of genesets}

\item{test}{Choose an enrichment type e.g. c("hypergeometric", "kstest")}

\item{background}{Size or character vector of background population genes}

\item{power}{Exponent for weights (kstest only)}

\item{absolute}{Takes max-min score rather than the max deviation from null (kstest only)}

\item{pval}{Filter results to be less than pval cutoff}

\item{fdr}{Filter results to be less than fdr cutoff}

\item{plotting}{Use true to generate plots for each geneset test (may slow performance)}

\item{quiet}{Use true to suppress logs and warnings}
}
\value{
A hyp object
}
\description{
Calculate enrichment of one or more signatures
}
\examples{
genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")

signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
               "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
               "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")

hyp_obj <- hypeR(signature, genesets, background=2522)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{wgcna}
\alias{wgcna}
\title{Co-expression Modules}
\format{
A nested list of character vectors
}
\usage{
wgcna
}
\description{
A list of co-expression modules
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_enrichr.R
\name{enrichr_connect}
\alias{enrichr_connect}
\title{Connect to the enrichr web application}
\usage{
enrichr_connect(
  endpoint,
  db = c("Enrichr", "YeastEnrichr", "FlyEnrichr", "WormEnrichr", "FishEnrichr")
)
}
\arguments{
\item{endpoint}{The url endpoint to connect to}

\item{db}{A species}
}
\value{
A web response
}
\description{
Connect to the enrichr web application
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_msig.R
\name{msigdb_species}
\alias{msigdb_species}
\title{Get msigdbr available species}
\usage{
msigdb_species()
}
\value{
A character vector of species
}
\description{
Get msigdbr available species
}
\examples{
msigdb_species()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shiny_modules.R
\name{genesets_Server}
\alias{genesets_Server}
\title{Shiny server module for geneset selection}
\usage{
genesets_Server(id, clean = FALSE)
}
\arguments{
\item{id}{A unique namespace identifier matching to interface}

\item{clean}{Use true to clean geneset names}
}
\value{
Shiny server code
}
\description{
Shiny server module for geneset selection
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{limma}
\alias{limma}
\title{Differential Expression}
\format{
A data frame
}
\usage{
limma
}
\description{
A differential expression table
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_msig.R
\name{msigdb_check_species}
\alias{msigdb_check_species}
\title{Check if species is available}
\usage{
msigdb_check_species(species = "")
}
\arguments{
\item{species}{A species}
}
\description{
Check if species is available
}
\examples{
\dontrun{
msigdb_check_species("Homo sapiens")
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reactable.R
\name{rctbl_mhyp}
\alias{rctbl_mhyp}
\title{Reactable table for multihyp objects}
\usage{
rctbl_mhyp(
  mhyp,
  show_emaps = FALSE,
  show_hmaps = FALSE,
  hyp_emap_args = list(top = 25, val = "fdr"),
  hyp_hmap_args = list(top = 25, val = "fdr")
)
}
\arguments{
\item{mhyp}{A multihyp object}

\item{show_emaps}{Option to show enrichment maps in tabs}

\item{show_hmaps}{Option to show hiearchy maps in tabs}

\item{hyp_emap_args}{A list of keyword arguments passed to hyp_emap}

\item{hyp_hmap_args}{A list of keyword arguments passed to hyp_hmap}
}
\description{
Reactable table for multihyp objects
}
\examples{
genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")$genesets[1:5]

experiment <- list("S1"=c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502"),
                   "S2"=c("PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC"))

mhyp_obj <- hypeR(experiment, genesets, background=2522)

rctbl_mhyp(mhyp_obj)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hyp_emap.R
\name{hyp_emap}
\alias{hyp_emap}
\title{Visualize hyp/multihyp objects as an enrichment map}
\usage{
hyp_emap(
  hyp_obj,
  similarity_metric = c("jaccard_similarity", "overlap_similarity"),
  similarity_cutoff = 0.2,
  pval = 1,
  fdr = 1,
  val = c("fdr", "pval"),
  top = NULL,
  title = ""
)
}
\arguments{
\item{hyp_obj}{A hyp or multihyp object}

\item{similarity_metric}{Metric to calculate geneset similarity}

\item{similarity_cutoff}{Geneset similarity cutoff}

\item{pval}{Filter results to be less than pval cutoff}

\item{fdr}{Filter results to be less than fdr cutoff}

\item{val}{Choose significance value shown above nodes e.g. c("fdr", "pval")}

\item{top}{Limit number of pathways shown}

\item{title}{Plot title}
}
\value{
A visNetwork object
}
\description{
Visualize hyp/multihyp objects as an enrichment map
}
\examples{
genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")

signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
               "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
               "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")

hyp_obj <- hypeR(signature, genesets, background=2522)

hyp_emap(hyp_obj, top=30, val="fdr")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/multihyp.R
\name{multihyp}
\alias{multihyp}
\title{A multihyp object}
\description{
A multihyp object

A multihyp object
}
\section{See Also}{


\code{hyp}
}

\examples{
data <- data.frame(replicate(5,sample(0:1,10,rep=TRUE)))
args <- list("arg_1"=1, "arg_2"=2, "arg_3"=3)
hyp_obj <- hyp$new(data, args=args)
data <- list("hyp_1"=hyp_obj, "hyp_2"=hyp_obj,"hyp_3"=hyp_obj)
multihyp_obj <- multihyp$new(data)

}
\section{Public fields}{
\if{html}{\out{<div class="r6-fields">}}
\describe{
\item{\code{data}}{A list of hyp objects}
}
\if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-multihyp-new}{\code{multihyp$new()}}
\item \href{#method-multihyp-print}{\code{multihyp$print()}}
\item \href{#method-multihyp-as.list}{\code{multihyp$as.list()}}
\item \href{#method-multihyp-clone}{\code{multihyp$clone()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-multihyp-new"></a>}}
\if{latex}{\out{\hypertarget{method-multihyp-new}{}}}
\subsection{Method \code{new()}}{
Create a multihyp object
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{multihyp$new(data)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{data}}{A list of hyp objects}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A new multihyp object
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-multihyp-print"></a>}}
\if{latex}{\out{\hypertarget{method-multihyp-print}{}}}
\subsection{Method \code{print()}}{
Print multihyp obect
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{multihyp$print()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
NULL
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-multihyp-as.list"></a>}}
\if{latex}{\out{\hypertarget{method-multihyp-as.list}{}}}
\subsection{Method \code{as.list()}}{
Print multihyp obect
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{multihyp$as.list()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
A list of hyp objects as dataframes
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-multihyp-clone"></a>}}
\if{latex}{\out{\hypertarget{method-multihyp-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{multihyp$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hyp_to_graph.R
\name{hyp_to_graph}
\alias{hyp_to_graph}
\title{Convert a hyp object to an igraph object}
\usage{
hyp_to_graph(hyp_obj)
}
\arguments{
\item{hyp_obj}{A hyp object}
}
\value{
An igraph object
}
\description{
Convert a hyp object to an igraph object
}
\examples{
genesets <- hyperdb_rgsets("REACTOME", "70.0")

signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
               "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
               "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")

hyp_obj <- hypeR(signature, genesets, background=2522)

ig <- hyp_to_graph(hyp_obj)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_enrichr.R
\name{enrichr_download}
\alias{enrichr_download}
\title{Download data from enrichr in the form of a named list}
\usage{
enrichr_download(
  genesets,
  db = c("Enrichr", "YeastEnrichr", "FlyEnrichr", "WormEnrichr", "FishEnrichr")
)
}
\arguments{
\item{genesets}{A name corresponding to available genesets}

\item{db}{A species}
}
\value{
A list of genesets
}
\description{
Download data from enrichr in the form of a named list
}
\examples{
ATLAS <- enrichr_download("Human_Gene_Atlas")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hyp_emap.R
\name{.enrichment_map}
\alias{.enrichment_map}
\title{Plot enrichment map}
\usage{
.enrichment_map(
  hyp_df,
  genesets,
  similarity_metric = c("jaccard_similarity", "overlap_similarity"),
  similarity_cutoff = 0.2,
  pval_cutoff = 1,
  fdr_cutoff = 1,
  val = c("fdr", "pval"),
  top = NULL,
  title = ""
)
}
\arguments{
\item{hyp_df}{A dataframe from a hyp object}

\item{genesets}{A list of genesets}

\item{similarity_metric}{Metric to calculate geneset similarity}

\item{similarity_cutoff}{Geneset similarity cutoff}

\item{pval_cutoff}{Filter results to be less than pval cutoff}

\item{fdr_cutoff}{Filter results to be less than fdr cutoff}

\item{val}{Choose significance value shown above nodes e.g. c("fdr", "pval")}

\item{top}{Limit number of pathways shown}

\item{title}{Plot title}
}
\value{
A visNetwork object
}
\description{
Plot enrichment map
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_msig.R
\name{msigdb_download}
\alias{msigdb_download}
\title{Download data from msigdb in the form of a named list}
\usage{
msigdb_download(species, collection, subcollection = NULL)
}
\arguments{
\item{species}{A species to determine gene symbols (refer to ?msigdbr::msigdbr for available species)}

\item{collection}{Geneset collection (refer to ?msigdbr::msigdbr_collections for available categories)}

\item{subcollection}{Geneset subcollection (refer to ?msigdbr::msigdbr_collections for available subcategories)}
}
\value{
A list of genesets
}
\description{
Download data from msigdb in the form of a named list
}
\examples{
HALLMARK_HUMAN <- msigdb_download("Homo sapiens", "H")
HALLMARK_MOUSE <- msigdb_download("Mus musculus", "MH")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hyp_dots.R
\name{.dots_multi_plot}
\alias{.dots_multi_plot}
\title{Plot top enriched genesets across multiple signatures}
\usage{
.dots_multi_plot(
  multihyp_data,
  top = 20,
  abrv = 50,
  size_by = c("genesets", "significance", "overlap", "none"),
  pval_cutoff = 1,
  fdr_cutoff = 1,
  val = c("fdr", "pval"),
  title = ""
)
}
\arguments{
\item{multihyp_data}{A list of hyp objects}

\item{top}{Limit number of genesets shown}

\item{abrv}{Abbreviation length of genesetlabels}

\item{size_by}{Size dots by e.g. c("genesets", "significance", "none")}

\item{pval_cutoff}{Filter results to be less than pval cutoff}

\item{fdr_cutoff}{Filter results to be less than fdr cutoff}

\item{val}{Choose significance value e.g. c("fdr", "pval")}

\item{title}{Plot title}
}
\value{
A ggplot object
}
\description{
Plot top enriched genesets across multiple signatures
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hyp_hmap.R
\name{.hiearchy_map}
\alias{.hiearchy_map}
\title{Plot hiearchy map}
\usage{
.hiearchy_map(
  hyp_df,
  rgsets_obj,
  pval_cutoff = 1,
  fdr_cutoff = 1,
  val = c("fdr", "pval"),
  top = NULL,
  title = "",
  graph = FALSE
)
}
\arguments{
\item{hyp_df}{A dataframe from a hyp object}

\item{rgsets_obj}{A relatonal geneset from a hyp object}

\item{pval_cutoff}{Filter results to be less than pval cutoff}

\item{fdr_cutoff}{Filter results to be less than fdr cutoff}

\item{val}{Choose significance value displayed when hovering nodes e.g. c("fdr", "pval")}

\item{top}{Limit number of pathways shown}

\item{title}{Plot title}

\item{graph}{Return an igraph object instead}
}
\value{
A visNetwork object
}
\description{
Plot hiearchy map
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rgsets.R
\name{rgsets}
\alias{rgsets}
\title{A relational genesets object}
\description{
A relational genesets object

A relational genesets object
}
\section{See Also}{


\code{gsets}
}

\section{Public fields}{
\if{html}{\out{<div class="r6-fields">}}
\describe{
\item{\code{genesets}}{A list of genesets where list names refers to geneset labels and values are geneset members represented as a vector}

\item{\code{nodes}}{A data frame of labeled nodes}

\item{\code{edges}}{A data frame of directed edges}

\item{\code{name}}{A character vector describing source of genesets}

\item{\code{version}}{A character vector describing versioning}
}
\if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-rgsets-new}{\code{rgsets$new()}}
\item \href{#method-rgsets-print}{\code{rgsets$print()}}
\item \href{#method-rgsets-info}{\code{rgsets$info()}}
\item \href{#method-rgsets-reduce}{\code{rgsets$reduce()}}
\item \href{#method-rgsets-subset}{\code{rgsets$subset()}}
\item \href{#method-rgsets-clone}{\code{rgsets$clone()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-rgsets-new"></a>}}
\if{latex}{\out{\hypertarget{method-rgsets-new}{}}}
\subsection{Method \code{new()}}{
Create a rgsets object
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{rgsets$new(
  genesets,
  nodes,
  edges,
  name = "Custom",
  version = "",
  quiet = FALSE
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{genesets}}{A list of genesets where list names refers to geneset labels and values are geneset members represented as a vector}

\item{\code{nodes}}{A data frame of labeled nodes}

\item{\code{edges}}{A data frame of directed edges}

\item{\code{name}}{A character vector describing source of genesets}

\item{\code{version}}{A character vector describing versioning}

\item{\code{quiet}}{Use true to silence warnings}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A new rgsets object
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-rgsets-print"></a>}}
\if{latex}{\out{\hypertarget{method-rgsets-print}{}}}
\subsection{Method \code{print()}}{
Print relational genesets information
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{rgsets$print()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
NULL
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-rgsets-info"></a>}}
\if{latex}{\out{\hypertarget{method-rgsets-info}{}}}
\subsection{Method \code{info()}}{
Returns versioning information
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{rgsets$info()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
A character vector with name and version
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-rgsets-reduce"></a>}}
\if{latex}{\out{\hypertarget{method-rgsets-reduce}{}}}
\subsection{Method \code{reduce()}}{
Reduces genesets to a background distribution of symbols
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{rgsets$reduce(background)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{background}}{A character vector of symbols}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A rgsets object
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-rgsets-subset"></a>}}
\if{latex}{\out{\hypertarget{method-rgsets-subset}{}}}
\subsection{Method \code{subset()}}{
Subsets genesets on a character vector of labels
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{rgsets$subset(labels)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{labels}}{A character vector of genesets}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A rgsets object
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-rgsets-clone"></a>}}
\if{latex}{\out{\hypertarget{method-rgsets-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{rgsets$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.hexa}
\alias{.hexa}
\title{Adjust alpha of a hex string}
\usage{
.hexa(hex, percent = 1)
}
\arguments{
\item{hex}{A 6-character hex string (e.g. #000000)}

\item{percent}{Alpha level from 0-1}
}
\value{
A hex string
}
\description{
Adjust alpha of a hex string
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_enrichr.R
\name{enrichr_urls}
\alias{enrichr_urls}
\title{Get url base for species-specific enrichr libraries}
\usage{
enrichr_urls(
  db = c("Enrichr", "YeastEnrichr", "FlyEnrichr", "WormEnrichr", "FishEnrichr")
)
}
\arguments{
\item{db}{A species}
}
\value{
A url
}
\description{
Get url base for species-specific enrichr libraries
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hyp_show.R
\name{hyp_show}
\alias{hyp_show}
\title{Convert a hyp object to a reactable table}
\usage{
hyp_show(hyp_obj, simple = FALSE)
}
\arguments{
\item{hyp_obj}{A hyp object}

\item{simple}{Use true to only include essential columns}
}
\value{
A reactable table
}
\description{
Convert a hyp object to a reactable table
}
\examples{
genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")

signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
               "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
               "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")

hyp_obj <- hypeR(signature, genesets, background=2522)

hyp_show(hyp_obj)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.jaccard_similarity}
\alias{.jaccard_similarity}
\title{Calculate jaccard similarity of two sets}
\usage{
.jaccard_similarity(a, b)
}
\arguments{
\item{a}{A vector}

\item{b}{A vector}
}
\value{
A numerical value
}
\description{
Calculate jaccard similarity of two sets
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ks_enrichment.R
\name{.kstest}
\alias{.kstest}
\title{One-sided Kolmogorov–Smirnov test}
\usage{
.kstest(
  n.x,
  y,
  weights = NULL,
  weights.pwr = 1,
  absolute = FALSE,
  plotting = FALSE,
  plot.title = ""
)
}
\arguments{
\item{n.x}{The length of a ranked list}

\item{y}{A vector of positions in the ranked list}

\item{weights}{Weights for weighted score (Subramanian et al.)}

\item{weights.pwr}{Exponent for weights (Subramanian et al.)}

\item{absolute}{Takes max-min score rather than the max deviation from null}

\item{plotting}{Use true to generate plot}

\item{plot.title}{Plot title}
}
\value{
A list of data and plots
}
\description{
One-sided Kolmogorov–Smirnov test
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_hyper.R
\name{.hyperdb_url}
\alias{.hyperdb_url}
\title{Get base url for hyperdb}
\usage{
.hyperdb_url(api = FALSE)
}
\value{
A base url
}
\description{
Get base url for hyperdb
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_hyper.R
\name{hyperdb_rgsets}
\alias{hyperdb_rgsets}
\title{Download data from hyperdb in the form of a rgsets object}
\usage{
hyperdb_rgsets(rgsets, version)
}
\arguments{
\item{rgsets}{A name corresponding to an available relational genesets object}

\item{version}{A version number}
}
\value{
An rgsets object
}
\description{
Download data from hyperdb in the form of a rgsets object
}
\examples{
REACTOME <- hyperdb_rgsets("REACTOME", "70.0")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ks_enrichment.R
\name{.ks_enrichment}
\alias{.ks_enrichment}
\title{Enrichment test via one-sided Kolmogorov–Smirnov test}
\usage{
.ks_enrichment(
  signature,
  genesets,
  weights = NULL,
  weights.pwr = 1,
  absolute = FALSE,
  plotting = TRUE
)
}
\arguments{
\item{signature}{A vector of ranked symbols}

\item{genesets}{A list of genesets}

\item{weights}{Weights for weighted score (Subramanian et al.)}

\item{weights.pwr}{Exponent for weights (Subramanian et al.)}

\item{absolute}{Takes max-min score rather than the max deviation from null}

\item{plotting}{Use true to generate plot}
}
\value{
A list of data and plots
}
\description{
Enrichment test via one-sided Kolmogorov–Smirnov test
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_hyper.R
\name{.github_rds}
\alias{.github_rds}
\title{Load an rds file directly from github}
\usage{
.github_rds(url)
}
\arguments{
\item{url}{A url}
}
\value{
A list
}
\description{
Load an rds file directly from github
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hyp_to_rmd.R
\name{hyp_to_rmd}
\alias{hyp_to_rmd}
\title{Export hyp object to rmarkdown}
\usage{
hyp_to_rmd(
  hyp_obj,
  file_path,
  title = "Workflow Report",
  subtitle = "",
  author = "",
  header = "Results",
  versioning = TRUE,
  show_dots = TRUE,
  show_emaps = TRUE,
  show_hmaps = FALSE,
  show_tables = TRUE,
  hyp_dots_args = list(top = 15, val = "fdr"),
  hyp_emap_args = list(top = 25, val = "fdr", similarity_metric = "jaccard_similarity",
    similarity_cutoff = 0.2),
  hyp_hmap_args = list(top = 25, val = "fdr"),
  custom_rmd_config = NULL,
  custom_pre_content = NULL,
  custom_post_content = NULL,
  session_info = FALSE
)
}
\arguments{
\item{hyp_obj}{A hyp object, multihyp object, or list of multihyp objects}

\item{file_path}{A file path}

\item{title}{Title of markdown report}

\item{subtitle}{Subtitle of markdown report}

\item{author}{Authors of markdown report}

\item{header}{Header name of tabset section}

\item{versioning}{Add versioning information}

\item{show_dots}{Option to show dots plots in tabs}

\item{show_emaps}{Option to show enrichment maps in tabs}

\item{show_hmaps}{Option to show hiearchy maps in tabs}

\item{show_tables}{Option to show table in tabs}

\item{hyp_dots_args}{A list of keyword arguments passed to hyp_dots}

\item{hyp_emap_args}{A list of keyword arguments passed to hyp_emap}

\item{hyp_hmap_args}{A list of keyword arguments passed to hyp_hmap}

\item{custom_rmd_config}{Replace configuration section of markdown report}

\item{custom_pre_content}{Insert custom content before tabset section}

\item{custom_post_content}{Insert custom content after tabset section}

\item{session_info}{Use true to include session info}
}
\description{
Export hyp object to rmarkdown
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db_msig.R
\name{msigdb_gsets}
\alias{msigdb_gsets}
\title{Download data from msigdb in the form of a gsets object}
\usage{
msigdb_gsets(species, collection, subcollection = NULL, clean = FALSE)
}
\arguments{
\item{species}{A species to determine gene symbols (refer to ?msigdbr::msigdbr_species for available species)}

\item{collection}{Geneset collection (refer to ?msigdbr::msigdbr_collections for available categories)}

\item{subcollection}{Geneset subcollection (refer to ?msigdbr::msigdbr_collections for available subcategories)}

\item{clean}{Use true to clean labels of genesets}
}
\value{
A gsets object
}
\description{
Download data from msigdb in the form of a gsets object
}
\examples{
HALLMARK_HUMAN <- msigdb_gsets("Homo sapiens", "H")
HALLMARK_MOUSE <- msigdb_gsets("Mus musculus", "MH")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hyper_enrichment.R
\name{.hyper_enrichment}
\alias{.hyper_enrichment}
\title{Overrepresentation test via hyper-geometric distribution}
\usage{
.hyper_enrichment(
  signature,
  genesets,
  background = length(unique(unlist(genesets))),
  plotting = TRUE
)
}
\arguments{
\item{signature}{A vector of symbols}

\item{genesets}{A list of genesets}

\item{background}{Size of background population genes}

\item{plotting}{Use true to generate plots}
}
\value{
A list of data and plots
}
\description{
Overrepresentation test via hyper-geometric distribution
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.find_members}
\alias{.find_members}
\title{Find geneset members}
\usage{
.find_members(id, genesets, nodes, edges)
}
\arguments{
\item{id}{A vector of ids}

\item{genesets}{A list of genesets (see \code{rgsets})}

\item{nodes}{A data frame of labeled nodes (see \code{rgsets})}

\item{edges}{A data frame of directed edges (see \code{rgsets})}
}
\value{
A vector of ids
}
\description{
Find geneset members
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hyp.R
\name{hyp}
\alias{hyp}
\title{A hyp object}
\description{
A hyp object

A hyp object
}
\section{See Also}{


\code{multihyp}
}

\examples{
data <- data.frame(replicate(5,sample(0:1,10,rep=TRUE)))
args <- list("arg_1"=1, "arg_2"=2, "arg_3"=3)
hyp_obj <- hyp$new(data, args=args)

}
\section{Public fields}{
\if{html}{\out{<div class="r6-fields">}}
\describe{
\item{\code{data}}{A dataframe returned by hypeR()}

\item{\code{plots}}{A list of plots returned by hypeR()}

\item{\code{args}}{A list of arguments passed to hypeR()}

\item{\code{info}}{Exported information for reproducibility}
}
\if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-hyp-new}{\code{hyp$new()}}
\item \href{#method-hyp-print}{\code{hyp$print()}}
\item \href{#method-hyp-as.data.frame}{\code{hyp$as.data.frame()}}
\item \href{#method-hyp-clone}{\code{hyp$clone()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-hyp-new"></a>}}
\if{latex}{\out{\hypertarget{method-hyp-new}{}}}
\subsection{Method \code{new()}}{
Create a hyp object
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{hyp$new(data, plots = NULL, args = NULL, info = NULL)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{data}}{A dataframe returned by hypeR()}

\item{\code{plots}}{A list of plots returned by hypeR()}

\item{\code{args}}{A list of arguments passed to hypeR()}

\item{\code{info}}{Exported information for reproducibility}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A new hyp object
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-hyp-print"></a>}}
\if{latex}{\out{\hypertarget{method-hyp-print}{}}}
\subsection{Method \code{print()}}{
Print hyp obect
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{hyp$print()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
NULL
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-hyp-as.data.frame"></a>}}
\if{latex}{\out{\hypertarget{method-hyp-as.data.frame}{}}}
\subsection{Method \code{as.data.frame()}}{
Extract dataframe from hyp obect
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{hyp$as.data.frame()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
NULL
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-hyp-clone"></a>}}
\if{latex}{\out{\hypertarget{method-hyp-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{hyp$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hyp_dots.R
\name{hyp_dots}
\alias{hyp_dots}
\title{Visualize hyp/multihyp objects as a dots plot}
\usage{
hyp_dots(
  hyp_obj,
  top = 20,
  abrv = 50,
  size_by = c("genesets", "significance", "none"),
  pval = 1,
  fdr = 1,
  val = c("fdr", "pval"),
  title = "",
  merge = FALSE
)
}
\arguments{
\item{hyp_obj}{A hyp or multihyp object}

\item{top}{Limit number of genesets shown}

\item{abrv}{Abbreviation length of geneset labels}

\item{size_by}{Size dots by e.g. c("genesets", "significance", "none")}

\item{pval}{Filter results to be less than pval cutoff}

\item{fdr}{Filter results to be less than fdr cutoff}

\item{val}{Choose significance value for plot e.g. c("fdr", "pval")}

\item{title}{Plot title}

\item{merge}{Use true to merge a multihyp object into one plot}
}
\value{
A ggplot object
}
\description{
Visualize hyp/multihyp objects as a dots plot
}
\examples{
genesets <- msigdb_gsets("Homo sapiens", "C2", "CP:KEGG_LEGACY")

signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
               "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
               "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")

hyp_obj <- hypeR(signature, genesets, background=2522)

hyp_dots(hyp_obj, val="fdr")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pvector.R
\name{pvector}
\alias{pvector}
\title{A push/pop capable vector}
\description{
A push/pop capable vector

A push/pop capable vector
}
\keyword{internal}
\section{Public fields}{
\if{html}{\out{<div class="r6-fields">}}
\describe{
\item{\code{values}}{A vector of values}
}
\if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-pvector-new}{\code{pvector$new()}}
\item \href{#method-pvector-print}{\code{pvector$print()}}
\item \href{#method-pvector-length}{\code{pvector$length()}}
\item \href{#method-pvector-pop}{\code{pvector$pop()}}
\item \href{#method-pvector-push}{\code{pvector$push()}}
\item \href{#method-pvector-clone}{\code{pvector$clone()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-pvector-new"></a>}}
\if{latex}{\out{\hypertarget{method-pvector-new}{}}}
\subsection{Method \code{new()}}{
Create a pvector
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{pvector$new(values = c())}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{values}}{A vector of values}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A new pvector
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-pvector-print"></a>}}
\if{latex}{\out{\hypertarget{method-pvector-print}{}}}
\subsection{Method \code{print()}}{
Print pvector
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{pvector$print()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
NULL
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-pvector-length"></a>}}
\if{latex}{\out{\hypertarget{method-pvector-length}{}}}
\subsection{Method \code{length()}}{
Get length of pvector
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{pvector$length()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
An integer
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-pvector-pop"></a>}}
\if{latex}{\out{\hypertarget{method-pvector-pop}{}}}
\subsection{Method \code{pop()}}{
Pop vector
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{pvector$pop()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
Popped value
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-pvector-push"></a>}}
\if{latex}{\out{\hypertarget{method-pvector-push}{}}}
\subsection{Method \code{push()}}{
Push values
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{pvector$push(pushed.values)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{pushed.values}}{A vector of values}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
NULL
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-pvector-clone"></a>}}
\if{latex}{\out{\hypertarget{method-pvector-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{pvector$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hyp_dots.R
\name{.dots_plot}
\alias{.dots_plot}
\title{Plot top enriched genesets}
\usage{
.dots_plot(
  hyp_df,
  top = 20,
  abrv = 50,
  size_by = c("genesets", "significance", "none"),
  pval_cutoff = 1,
  fdr_cutoff = 1,
  val = c("fdr", "pval"),
  title = ""
)
}
\arguments{
\item{hyp_df}{A dataframe from a hyp object}

\item{top}{Limit number of genesets shown}

\item{abrv}{Abbreviation length of genesetlabels}

\item{size_by}{Size dots by e.g. c("genesets", "significance", "none")}

\item{pval_cutoff}{Filter results to be less than pval cutoff}

\item{fdr_cutoff}{Filter results to be less than fdr cutoff}

\item{val}{Choose significance value e.g. c("fdr", "pval")}

\item{title}{Plot title}
}
\value{
A ggplot object
}
\description{
Plot top enriched genesets
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gsets.R
\name{gsets}
\alias{gsets}
\title{A genesets object}
\description{
A genesets object

A genesets object
}
\section{See Also}{


\code{rgsets}
}

\examples{
genesets <- list("GSET1" = c("GENE1", "GENE2", "GENE3"),
                 "GSET2" = c("GENE4", "GENE5", "GENE6"),
                 "GSET3" = c("GENE7", "GENE8", "GENE9"))

gsets_obj <- gsets$new(genesets, name="example", version="v1.0")
print(gsets_obj)

}
\section{Public fields}{
\if{html}{\out{<div class="r6-fields">}}
\describe{
\item{\code{genesets}}{A named list of genesets}

\item{\code{name}}{A character vector describing source of genesets}

\item{\code{version}}{A character vector describing versioning}
}
\if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-gsets-new}{\code{gsets$new()}}
\item \href{#method-gsets-print}{\code{gsets$print()}}
\item \href{#method-gsets-list}{\code{gsets$list()}}
\item \href{#method-gsets-info}{\code{gsets$info()}}
\item \href{#method-gsets-reduce}{\code{gsets$reduce()}}
\item \href{#method-gsets-clone}{\code{gsets$clone()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-gsets-new"></a>}}
\if{latex}{\out{\hypertarget{method-gsets-new}{}}}
\subsection{Method \code{new()}}{
Create a gsets object
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{gsets$new(
  genesets,
  name = "Custom",
  version = "",
  clean = FALSE,
  quiet = FALSE
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{genesets}}{A named list of genesets}

\item{\code{name}}{A character vector describing source of genesets}

\item{\code{version}}{A character vector describing versioning}

\item{\code{clean}}{Use true to clean labels of genesets}

\item{\code{quiet}}{Use true to silence warnings}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A new gsets object
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-gsets-print"></a>}}
\if{latex}{\out{\hypertarget{method-gsets-print}{}}}
\subsection{Method \code{print()}}{
Print genesets information
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{gsets$print()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
NULL
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-gsets-list"></a>}}
\if{latex}{\out{\hypertarget{method-gsets-list}{}}}
\subsection{Method \code{list()}}{
Return genesets as a list
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{gsets$list()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
A list of genesets
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-gsets-info"></a>}}
\if{latex}{\out{\hypertarget{method-gsets-info}{}}}
\subsection{Method \code{info()}}{
Returns versioning information
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{gsets$info()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
A character vector with name and version
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-gsets-reduce"></a>}}
\if{latex}{\out{\hypertarget{method-gsets-reduce}{}}}
\subsection{Method \code{reduce()}}{
Reduces genesets to a background distribution of symbols
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{gsets$reduce(background)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{background}}{A character vector of symbols}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A gsets object
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-gsets-clone"></a>}}
\if{latex}{\out{\hypertarget{method-gsets-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{gsets$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hyp_hmap.R
\name{hyp_hmap}
\alias{hyp_hmap}
\title{Visualize hyp/multihyp objects as a hiearchy map}
\usage{
hyp_hmap(
  hyp_obj,
  pval = 1,
  fdr = 1,
  val = c("fdr", "pval"),
  top = NULL,
  title = "",
  graph = FALSE
)
}
\arguments{
\item{hyp_obj}{A hyp or multihyp object}

\item{pval}{Filter results to be less than pval cutoff}

\item{fdr}{Filter results to be less than fdr cutoff}

\item{val}{Choose significance value displayed when hovering nodes e.g. c("fdr", "pval")}

\item{top}{Limit number of pathways shown}

\item{title}{Plot title}

\item{graph}{Return an igraph object instead}
}
\value{
A visNetwork object
}
\description{
Visualize hyp/multihyp objects as a hiearchy map
}
\examples{
genesets <- hyperdb_rgsets("REACTOME", "70.0")

signature <- c("IDH3B","DLST","PCK2","CS","PDHB","PCK1","PDHA1","LOC642502",
               "PDHA2","LOC283398","FH","SDHD","OGDH","SDHB","IDH3A","SDHC",
               "IDH2","IDH1","OGDHL","PC","SDHA","SUCLG1","SUCLA2","SUCLG2")

hyp_obj <- hypeR(signature, genesets, background=2522)

hyp_hmap(hyp_obj, top=60)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.check_overlap}
\alias{.check_overlap}
\title{Check overlap of signature across genesets}
\usage{
.check_overlap(signature, genesets, threshold = 0.05)
}
\arguments{
\item{signature}{A vector of symbols}

\item{genesets}{A list of genesets}

\item{threshold}{Minimum percent overlap}
}
\value{
Percent overlap
}
\description{
Check overlap of signature across genesets
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggvenn.R
\name{ggvenn}
\alias{ggvenn}
\title{Venn diagram implemented in ggplot}
\usage{
ggvenn(a, b, ga, gb, title = "")
}
\arguments{
\item{a}{A vector for group a}

\item{b}{A vector for group b}

\item{ga}{A string label for group a}

\item{gb}{A string label for group b}

\item{title}{Plot title}
}
\value{
A ggplot object
}
\description{
Venn diagram implemented in ggplot
}
